(*     changed by: rlang
   last change by: rlang
             date: 02.11.28
*)

(*
   use"../knowledge/Poly.ML";
   use"knowledge/Poly.ML";
   use"Poly.ML";

   remove_thy"Poly";
   use_thy"knowledge/Isac";

   use"ROOT.ML";
   cd"knowledge";
 *)
"******* Poly.ML begin *******";

theory' := overwritel (!theory', [("Poly.thy",Poly.thy)]);


(* is_polyrat_in becomes true, if no bdv is in the denominator of a fraction*)
fun is_polyrat_in t v = 
    let 
	fun coeff_in c v = v mem (vars c);
   	fun finddivide (_ $ _ $ _ $ _) v = raise error("is_polyrat_in:")
	    (* at the moment there is no term like this, but ....*)
	  | finddivide (t as (Const ("HOL.divide",_) $ _ $ b)) v = not(coeff_in b v)
	  | finddivide (_ $ t1 $ t2) v = (finddivide t1 v) orelse (finddivide t2 v)
	  | finddivide (_ $ t1) v = (finddivide t1 v)
	  | finddivide _ _ = false;
     in
	finddivide t v
    end;
    
fun eval_is_polyrat_in _ _ (p as (Const ("Poly.is'_polyrat'_in",_) $ t $ v)) _  =
    if is_polyrat_in t v then 
	Some ((term2str p) ^ " = True",
	      Trueprop $ (mk_equality (p, HOLogic.true_const)))
    else Some ((term2str p) ^ " = True",
	       Trueprop $ (mk_equality (p, HOLogic.false_const)))
  | eval_is_polyrat_in _ _ _ _ = ((*writeln"### nichts matcht";*) None);


local
    (*.a 'c is coefficient of v' if v does NOT occur in c.*)
    fun coeff_in c v = not (v mem (vars c));
    (*
     val v = (term_of o the o (parse thy)) "x";
     val t = (term_of o the o (parse thy)) "1";
     coeff_in t v;
     (*val it = true : bool*)
     val t = (term_of o the o (parse thy)) "a*b+c";
     coeff_in t v;
     (*val it = true : bool*)
     val t = (term_of o the o (parse thy)) "a*x+c";
     coeff_in t v;
     (*val it = false : bool*)
    *)
    (*. a 'monomial t in variable v' is a term t with
      either (1) v NOT existent in t, or (2) v contained in t,
      if (1) then degree 0
      if (2) then v is a factor on the very right, ev. with exponent.*)
    fun factor_right_deg (*case 2*)
    	    (t as Const ("op *",_) $ t1 $ 
    	       (Const ("Atools.pow",_) $ vv $ Free (d,_))) v =
    	if ((vv = v) andalso (coeff_in t1 v)) then Some (int_of_str' d) else None
      | factor_right_deg 
    	    (t as Const ("Atools.pow",_) $ vv $ Free (d,_)) v =
    	if (vv = v) then Some (int_of_str' d) else None
      | factor_right_deg (t as Const ("op *",_) $ t1 $ vv) v = 
    	if ((vv = v) andalso (coeff_in t1 v))then Some 1 else None
      | factor_right_deg vv v =
    	if (vv = v) then Some 1 else None;    
    fun mono_deg_in m v =
    	if coeff_in m v then (*case 1*) Some 0
    	else factor_right_deg m v;
    (*
     val v = (term_of o the o (parse thy)) "x";
     val t = (term_of o the o (parse thy)) "(a*b+c)*x^^^7";
     mono_deg_in t v;
     (*val it = Some 7*)
     val t = (term_of o the o (parse thy)) "x^^^7";
     mono_deg_in t v;
     (*val it = Some 7*)
     val t = (term_of o the o (parse thy)) "(a*b+c)*x";
     mono_deg_in t v;
     (*val it = Some 1*)
     val t = (term_of o the o (parse thy)) "(a*b+x)*x";
     mono_deg_in t v;
     (*val it = None*)
     val t = (term_of o the o (parse thy)) "x";
     mono_deg_in t v;
     (*val it = Some 1*)
     val t = (term_of o the o (parse thy)) "(a*b+c)";
     mono_deg_in t v;
     (*val it = Some 0*)
     val t = (term_of o the o (parse thy)) "ab - (a*b)*x";
     mono_deg_in t v;
     (*val it = None*)
    *)
    fun expand_deg_in t v =
    	let fun edi ~1 ~1 (Const ("op +",_) $ t1 $ t2) =
    		(case mono_deg_in t2 v of (* $ is left associative*)
    		     Some d' => edi d' d' t1
		   | None => None)
    	      | edi ~1 ~1 (Const ("op -",_) $ t1 $ t2) =
    		(case mono_deg_in t2 v of
    		     Some d' => edi d' d' t1
		   | None => None)
    	      | edi d dmax (Const ("op -",_) $ t1 $ t2) =
    		(case mono_deg_in t2 v of
		     (*RL  orelse ((d=0) andalso (d'=0)) need to handle 3+4-...4  +x*)
    		     Some d' => if ((d > d') orelse ((d=0) andalso (d'=0))) then edi d' dmax t1 else None
		   | None => None)
    	      | edi d dmax (Const ("op +",_) $ t1 $ t2) =
    		(case mono_deg_in t2 v of
		     (*RL  orelse ((d=0) andalso (d'=0)) need to handle 3+4-...4  +x*)
    		     Some d' => if ((d > d') orelse ((d=0) andalso (d'=0))) then edi d' dmax t1 else None
		   | None => None)
    	      | edi ~1 ~1 t =
    		(case mono_deg_in t v of
    		     d as Some _ => d
		   | None => None)
    	      | edi d dmax t = (*basecase last*)
    		(case mono_deg_in t v of
    		     Some d' => if ((d > d') orelse ((d=0) andalso (d'=0)))  then Some dmax else None
		   | None => None)
    	in edi ~1 ~1 t end;
    (*
     val v = (term_of o the o (parse thy)) "x";
     val t = (term_of o the o (parse thy)) "a+b";
     expand_deg_in t v;
     (*val it = Some 0*)   
     val t = (term_of o the o (parse thy)) "(a+b)*x";
     expand_deg_in t v;
     (*Some 1*)   
     val t = (term_of o the o (parse thy)) "a*b - (a+b)*x";
     expand_deg_in t v;
     (*Some 1*)   
     val t = (term_of o the o (parse thy)) "a*b + (a-b)*x";
     expand_deg_in t v;
     (*Some 1*)   
     val t = (term_of o the o (parse thy)) "a*b + (a+b)*x + x^^^2";
     expand_deg_in t v;
    *)   
    fun poly_deg_in t v =
    	let fun edi ~1 ~1 (Const ("op +",_) $ t1 $ t2) =
    		(case mono_deg_in t2 v of (* $ is left associative*)
    		     Some d' => edi d' d' t1
		   | None => None)
    	      | edi d dmax (Const ("op +",_) $ t1 $ t2) =
    		(case mono_deg_in t2 v of
 		     (*RL  orelse ((d=0) andalso (d'=0)) need to handle 3+4-...4  +x*)
   		     Some d' => if ((d > d') orelse ((d=0) andalso (d'=0))) then edi d' dmax t1 else None
		   | None => None)
    	      | edi ~1 ~1 t =
    		(case mono_deg_in t v of
    		     d as Some _ => d
		   | None => None)
    	      | edi d dmax t = (*basecase last*)
    		(case mono_deg_in t v of
    		     Some d' => if ((d > d') orelse ((d=0) andalso (d'=0))) then Some dmax else None
		   | None => None)
    	in edi ~1 ~1 t end;
in

fun is_expanded_in t v =
    case expand_deg_in t v of Some _ => true | None => false;
fun is_poly_in t v =
    case poly_deg_in t v of Some _ => true | None => false;
fun has_degree_in t v =
    case expand_deg_in t v of Some d => d | None => ~1;
end;
(*
 val v = (term_of o the o (parse thy)) "x";
 val t = (term_of o the o (parse thy)) "a*b - (a+b)*x + x^^^2";
 has_degree_in t v;
 (*val it = 2*)
 val t = (term_of o the o (parse thy)) "-8 - 2*x + x^^^2";
 has_degree_in t v;
 (*val it = 2*)
 val t = (term_of o the o (parse thy)) "6 + 13*x + 6*x^^^2";
 has_degree_in t v;
 (*val it = 2*)
*)

(* 
   use"../knowledge/Poly.ML";
   use"knowledge/Poly.ML";
   use"Poly.ML";
 *)

(*("is_expanded_in", ("Poly.is'_expanded'_in", eval_is_expanded_in ""))*)
fun eval_is_expanded_in _ _ 
	     (p as (Const ("Poly.is'_expanded'_in",_) $ t $ v)) _ =
    if is_expanded_in t v
    then Some ((term2str p) ^ " = True",
	  Trueprop $ (mk_equality (p, HOLogic.true_const)))
    else Some ((term2str p) ^ " = True",
	  Trueprop $ (mk_equality (p, HOLogic.false_const)))
  | eval_is_expanded_in _ _ _ _ = None;
(*
 val t = (term_of o the o (parse thy)) "(-8 - 2*x + x^^^2) is_expanded_in x";
 val Some (id, t') = eval_is_expanded_in 0 0 t 0;
 (*val id = "Poly.is'_expanded'_in (-8 - 2 * x + x ^^^ 2) x = True"*)
 term2str t';
 (*val it = "Poly.is'_expanded'_in (-8 - 2 * x + x ^^^ 2) x = True"*)
*)
(*("is_poly_in", ("Poly.is'_poly'_in", eval_is_poly_in ""))*)
fun eval_is_poly_in _ _ 
	     (p as (Const ("Poly.is'_poly'_in",_) $ t $ v)) _ =
    if is_poly_in t v
    then Some ((term2str p) ^ " = True",
	  Trueprop $ (mk_equality (p, HOLogic.true_const)))
    else Some ((term2str p) ^ " = True",
	  Trueprop $ (mk_equality (p, HOLogic.false_const)))
  | eval_is_poly_in _ _ _ _ = None;
(*
 val t = (term_of o the o (parse thy)) "(8 + 2*x + x^^^2) is_poly_in x";
 val Some (id, t') = eval_is_poly_in 0 0 t 0;
 (*val id = "Poly.is'_poly'_in (8 + 2 * x + x ^^^ 2) x = True"*)
 term2str t';
 (*val it = "Poly.is'_poly'_in (8 + 2 * x + x ^^^ 2) x = True"*)
*)

(*("has_degree_in", ("Poly.has'_degree'_in", eval_has_degree_in ""))*)
fun eval_has_degree_in _ _ 
	     (p as (Const ("Poly.has'_degree'_in",_) $ t $ v)) _ =
    let val d = has_degree_in t v
	val d' = term_of_num HOLogic.realT d
    in Some ((term2str p) ^ " = " ^ (string_of_int d),
	  Trueprop $ (mk_equality (p, d')))
    end
  | eval_has_degree_in _ _ _ _ = None;
(*
> val t = (term_of o the o (parse thy)) "(-8 - 2*x + x^^^2) has_degree_in x";
> val Some (id, t') = eval_has_degree_in 0 0 t 0;
val id = "Poly.has'_degree'_in (-8 - 2 * x + x ^^^ 2) x = 2" : string
> term2str t';
val it = "Poly.has'_degree'_in (-8 - 2 * x + x ^^^ 2) x = 2" : string
*)

(*..*)
val calculate_Poly =
    append_rls "calculate_PolyFIXXXME.not.impl." e_rls
	       [];

(*.for evaluation of conditions in rewrite rules.*)
val poly_erls = 
    merge_rls "poly_erls" atools_erls
      (append_rls "ops_preds" e_rls
               [ Calc ("op =",eval_equal "#equal_"),
		 Thm  ("real_unari_minus",num_str real_unari_minus),
                 Calc ("op +",eval_binop "#add_"),
		 Calc ("op -",eval_binop "#subtract_"),
		 Calc ("op *",eval_binop "#mult_"),
		 Calc ("Atools.pow" ,eval_binop "#power_"),
		 Calc ("Poly.is'_expanded'_in",eval_is_expanded_in ""),
		 Calc ("Poly.is'_poly'_in",eval_is_poly_in ""),
                 Calc ("Poly.is'_polyrat'_in",eval_is_polyrat_in ""),
                 Calc ("Poly.has'_degree'_in",eval_has_degree_in ""),
		 Calc ("Atools.occurs'_in",eval_occurs_in "")
		 ]);
ruleset' := overwritel (!ruleset',
			[("poly_erls",poly_erls)(*FIXXXME:del with rls.rls'*)
			 ]);

local (*. for make_polynomial .*)

open Term;  (* for type order = EQUAL | LESS | GREATER *)

fun pr_ord EQUAL = "EQUAL"
  | pr_ord LESS  = "LESS"
  | pr_ord GREATER = "GREATER";

fun dest_hd' (Const (a, T)) =                          (* ~ term.ML *)
  (case a of
     "Atools.pow" => ((("|||||||||||||", 0), T), 0)           (*WN greatest *)
   | _ => (((a, 0), T), 0))
  | dest_hd' (Free (a, T)) = (((a, 0), T), 1)
  | dest_hd' (Var v) = (v, 2)
  | dest_hd' (Bound i) = ((("", i), dummyT), 3)
  | dest_hd' (Abs (_, T, _)) = ((("", 0), T), 4);

fun get_order_pow (t $ (Free(order,_))) = (* RL FIXXXME:geht zufaellig?WN*)
    	(case int_of_str (order) of
	             Some d => d
		   | None   => 0)
  | get_order_pow _ = 0;

fun size_of_term' (Const(str,_) $ t) =
  if "Atools.pow"= str then 1000 + size_of_term' t else 1+size_of_term' t(*WN*)
  | size_of_term' (Abs (_,_,body)) = 1 + size_of_term' body
  | size_of_term' (f$t) = size_of_term' f  +  size_of_term' t
  | size_of_term' _ = 1;

fun term_ord' pr thy (Abs (_, T, t), Abs(_, U, u)) =       (* ~ term.ML *)
      (case term_ord' pr thy (t, u) of EQUAL => typ_ord (T, U) | ord => ord)
  | term_ord' pr thy (t, u) =
      (if pr then 
	 let
	   val (f, ts) = strip_comb t and (g, us) = strip_comb u;
	   val _=writeln("t= f@ts= \""^
	      ((string_of_cterm o cterm_of (sign_of thy)) f)^"\" @ \"["^
	      (commas(map(string_of_cterm o cterm_of (sign_of thy))ts))^"]\"");
	   val _=writeln("u= g@us= \""^
	      ((string_of_cterm o cterm_of (sign_of thy)) g)^"\" @ \"["^
	      (commas(map(string_of_cterm o cterm_of (sign_of thy))us))^"]\"");
	   val _=writeln("size_of_term(t,u)= ("^
	      (string_of_int(size_of_term' t))^", "^
	      (string_of_int(size_of_term' u))^")");
	   val _=writeln("hd_ord(f,g)      = "^((pr_ord o hd_ord)(f,g)));
	   val _=writeln("terms_ord(ts,us) = "^
			   ((pr_ord o terms_ord str false)(ts,us)));
	   val _=writeln("-------");
	 in () end
       else ();
	 case int_ord (size_of_term' t, size_of_term' u) of
	   EQUAL =>
	     let val (f, ts) = strip_comb t and (g, us) = strip_comb u in
	       (case hd_ord (f, g) of EQUAL => (terms_ord str pr) (ts, us) 
	     | ord => ord)
	     end
	 | ord => ord)
and hd_ord (f, g) =                                        (* ~ term.ML *)
  prod_ord (prod_ord indexname_ord typ_ord) int_ord (dest_hd' f, dest_hd' g)
and terms_ord str pr (ts, us) = 
    list_ord (term_ord' pr (assoc_thy "Isac.thy"))(ts, us);
in

fun ord_make_polynomial (pr:bool) thy (_:subst) tu = 
    (term_ord' pr thy(***) tu = LESS );

end;(*local*)

local (*. poly_order for  x * y * x^^^2 .*)

open Term;  (* for type order = EQUAL | LESS | GREATER *)

fun pr_ord EQUAL = "EQUAL"
  | pr_ord LESS  = "LESS"
  | pr_ord GREATER = "GREATER";

fun dest_hd' (Const (a, T)) =                          (* ~ term.ML *)
  (case a of
     "Atools.pow" => ((("|||||||||||||", 0), T), 0)    (*WN greatest *)
   | _ => (((a, 0), T), 0))
  | dest_hd' (Free (a, T)) = (((a, 0), T), 1)
  | dest_hd' (Var v) = (v, 2)
  | dest_hd' (Bound i) = ((("", i), dummyT), 3)
  | dest_hd' (Abs (_, T, _)) = ((("", 0), T), 4);

fun size_of_term' (Const(str,_) $ t) =
  if "Atools.pow"= str then 1000 + size_of_term' t 
  else 1 + size_of_term' t                                      (*WN*)
  | size_of_term' (Abs (_,_,body)) = 1 + size_of_term' body
  | size_of_term' (f$t) = size_of_term' f  +  size_of_term' t
  | size_of_term' _ = 1;

fun term_ord' pr thy (Abs (_, T, t), Abs(_, U, u)) =       (* ~ term.ML *)
      (case term_ord' pr thy (t, u) of EQUAL => typ_ord (T, U) | ord => ord)
  | term_ord' pr thy (t, u) =
    (case int_ord (size_of_term' t, size_of_term' u) of
	 EQUAL =>
	 let val (f, ts) = strip_comb t and (g, us) = strip_comb u in
	     (case hd_ord (f, g) of EQUAL => (terms_ord str pr) (ts, us) 
				  | ord => ord)
	 end
       | ord => ord)
and hd_ord (f, g) =                                        (* ~ term.ML *)
  prod_ord (prod_ord indexname_ord typ_ord) int_ord (dest_hd' f, dest_hd' g)
and terms_ord str pr (ts, us) = 
    list_ord (term_ord' pr (assoc_thy "Isac.thy"))(ts, us);
in

fun ord_make_polynomial (pr:bool) thy (_:subst) tu = 
    (term_ord' pr thy(***) tu = LESS );

end;(*local*)

rew_ord' := overwritel (!rew_ord',
[("termlessI", termlessI),
 ("ord_make_polynomial", ord_make_polynomial false thy)
 ]);


val expand = 
  Rls{id = "expand", preconds = [], 
      rew_ord = ("dummy_ord", dummy_ord),
      erls = e_rls,srls = Erls,
      calc = [],
      asm_thm = [],
      rules = [Thm ("real_add_mult_distrib" ,num_str real_add_mult_distrib),
	       (*"(z1.0 + z2.0) * w = z1.0 * w + z2.0 * w"*)
	       Thm ("real_add_mult_distrib2",num_str real_add_mult_distrib2)
	       (*"w * (z1.0 + z2.0) = w * z1.0 + w * z2.0"*)
	       ], scr = EmptyScr}:rls;

val expand_poly = 
  Rls{id = "expand_poly", preconds = [], 
      rew_ord = ("dummy_ord", dummy_ord),
      erls = e_rls,srls = Erls,
      calc = [],
      asm_thm = [],
      rules = [Thm ("real_add_mult_distrib" ,num_str real_add_mult_distrib),
	       (*"(z1.0 + z2.0) * w = z1.0 * w + z2.0 * w"*)
	       Thm ("real_add_mult_distrib2",num_str real_add_mult_distrib2),
	       (*"w * (z1.0 + z2.0) = w * z1.0 + w * z2.0"*)
	       (*Thm ("real_add_mult_distrib1",num_str real_add_mult_distrib1),
		....... 18.3.03 undefined???*)

	       Thm ("real_plus_binom_pow2",num_str real_plus_binom_pow2),
	       (*"(a + b)^^^2 = a^^^2 + 2*a*b + b^^^2"*)
	       Thm ("real_minus_binom_pow2_p",num_str real_minus_binom_pow2_p),
	       (*"(a - b)^^^2 = a^^^2 + -2*a*b + b^^^2"*)
	       Thm ("real_plus_minus_binom1_p",
		    num_str real_plus_minus_binom1_p),
	       (*"(a + b)*(a - b) = a^^^2 + -1*b^^^2"*)
	       Thm ("real_plus_minus_binom2_p",
		    num_str real_plus_minus_binom2_p),
	       (*"(a - b)*(a + b) = a^^^2 + -1*b^^^2"*)

	       Thm ("real_minus_minus",num_str real_minus_minus),
	       (*"- (- ?z) = ?z"*)
	       Thm ("real_diff_minus",num_str real_diff_minus),
	       (*"a - b = a + -1 * b"*)
	       Thm ("sym_real_mult_minus1",num_str (real_mult_minus1 RS sym))
	       (*- ?z = "-1 * ?z"*)

	       (*Thm ("",num_str ),
	       Thm ("",num_str ),
	       Thm ("",num_str ),*)
	       (*Thm ("real_minus_add_distrib",
		      num_str real_minus_add_distrib),*)
	       (*"- (?x + ?y) = - ?x + - ?y"*)
	       (*Thm ("real_diff_plus",num_str real_diff_plus)*)
	       (*"a - b = a + -b"*)
	       ], scr = EmptyScr}:rls;
val simplify_power = 
  Rls{id = "simplify_power", preconds = [], 
      rew_ord = ("dummy_ord", dummy_ord),
      erls = e_rls, srls = Erls,
      calc = [],
      asm_thm = [],
      rules = [Thm ("realpow_multI", num_str realpow_multI),
	       (*"(r * s) ^^^ n = r ^^^ n * s ^^^ n"*)
	       
	       Thm ("sym_realpow_twoI",num_str (realpow_twoI RS sym)),	
	       (*"r1 * r1 = r1 ^^^ 2"*)
	       Thm ("realpow_plus_1",num_str realpow_plus_1),		
	       (*"r * r ^^^ n = r ^^^ (n + 1)"*)
	       Thm ("realpow_pow",num_str realpow_pow),
	       (*"(a ^^^ b) ^^^ c = a ^^^ (b * c)"*)
	       Thm ("sym_realpow_addI",num_str (realpow_addI RS sym)),
	       (*"r ^^^ n * r ^^^ m = r ^^^ (n + m)"*)
	       Thm ("realpow_oneI",num_str realpow_oneI),
	       (*"r ^^^ 1 = r"*)
	       Thm ("realpow_eq_oneI",num_str realpow_eq_oneI)
	       (*"1 ^^^ n = 1"*)
	       ], scr = EmptyScr}:rls;
val order_add_mult = 
  Rls{id = "order_add_mult", preconds = [], 
      rew_ord = ("ord_make_polynomial",ord_make_polynomial false Poly.thy),
      erls = e_rls,srls = Erls,
      calc = [],
      asm_thm = [],
      rules = [Thm ("real_mult_commute",num_str real_mult_commute),
	       (* z * w = w * z *)
	       Thm ("real_mult_left_commute",num_str real_mult_left_commute),
	       (*z1.0 * (z2.0 * z3.0) = z2.0 * (z1.0 * z3.0)*)
	       Thm ("real_mult_assoc",num_str real_mult_assoc),		
	       (*z1.0 * z2.0 * z3.0 = z1.0 * (z2.0 * z3.0)*)
	       Thm ("real_add_commute",num_str real_add_commute),	
	       (*z + w = w + z*)
	       Thm ("real_add_left_commute",num_str real_add_left_commute),
	       (*x + (y + z) = y + (x + z)*)
	       Thm ("real_add_assoc",num_str real_add_assoc)	               
	       (*z1.0 + z2.0 + z3.0 = z1.0 + (z2.0 + z3.0)*)
	       ], scr = EmptyScr}:rls;
val order_mult = 
  Rls{id = "order_mult", preconds = [], 
      rew_ord = ("ord_make_polynomial",ord_make_polynomial false Poly.thy),
      erls = e_rls,srls = Erls,
      calc = [],
      asm_thm = [],
      rules = [Thm ("real_mult_commute",num_str real_mult_commute),
	       (* z * w = w * z *)
	       Thm ("real_mult_left_commute",num_str real_mult_left_commute),
	       (*z1.0 * (z2.0 * z3.0) = z2.0 * (z1.0 * z3.0)*)
	       Thm ("real_mult_assoc",num_str real_mult_assoc)	
	       (*z1.0 * z2.0 * z3.0 = z1.0 * (z2.0 * z3.0)*)
	       ], scr = EmptyScr}:rls;
val collect_numerals = 
  Rls{id = "collect_numerals", preconds = [], 
      rew_ord = ("dummy_ord", dummy_ord),
      erls = atools_erls(*erls3.4.03*),srls = Erls,
      calc = [("plus"  , ("op +", eval_binop "#add_")), 
	      ("times" , ("op *", eval_binop "#mult_")),
	      ("power_", ("Atools.pow", eval_binop "#power_"))
	      ],
      asm_thm = [],
      rules = [Thm ("real_num_collect",num_str real_num_collect), 
	       (*"[| l is_const; m is_const |]==>l * n + m * n = (l + m) * n"*)
	       Thm ("real_num_collect_assoc",num_str real_num_collect_assoc),
	       (*"[| l is_const; m is_const |] ==>  
				l * n + (m * n + k) =  (l + m) * n + k"*)
	       Thm ("real_one_collect",num_str real_one_collect),	
	       (*"m is_const ==> n + m * n = (1 + m) * n"*)
	       Thm ("real_one_collect_assoc",num_str real_one_collect_assoc), 
	       (*"m is_const ==> k + (n + m * n) = k + (1 + m) * n"*)
	       Calc ("op +", eval_binop "#add_"), 
	       Calc ("op *", eval_binop "#mult_"),
	       Calc ("Atools.pow", eval_binop "#power_")
	       ], scr = EmptyScr}:rls;
val reduce_012 = 
  Rls{id = "reduce_012", preconds = [], 
      rew_ord = ("dummy_ord", dummy_ord),
      erls = e_rls,srls = Erls,
      calc = [],
      asm_thm = [],
      rules = [Thm ("real_mult_1",num_str real_mult_1),                 
	       (*"1 * z = z"*)
	       (*Thm ("real_mult_minus1",num_str real_mult_minus1),14.3.03*)
	       (*"-1 * z = - z"*)
	       Thm ("sym_real_mult_minus_eq1", 
		    num_str (real_mult_minus_eq1 RS sym)),
	       (*- (?x * ?y) = "- ?x * ?y"*)
	       (*Thm ("real_minus_mult_cancel",num_str real_minus_mult_cancel),
	       (*"- ?x * - ?y = ?x * ?y"*)---*)
	       Thm ("real_mult_0",num_str real_mult_0),        
	       (*"0 * z = 0"*)
	       Thm ("real_add_zero_left",num_str real_add_zero_left),
	       (*"0 + z = z"*)
	       Thm ("real_add_minus",num_str real_add_minus),
	       (*"?z + - ?z = 0"*)
	       Thm ("sym_real_mult_2",num_str (real_mult_2 RS sym)),	
	       (*"z1 + z1 = 2 * z1"*)
	       Thm ("real_mult_2_assoc",num_str real_mult_2_assoc)
	       (*"z1 + (z1 + k) = 2 * z1 + k"*)
	       ], scr = EmptyScr}:rls;
(*ein Hilfs-'ruleset' (benutzt das leere 'ruleset')*)
val discard_parentheses = 
    append_rls "discard_parentheses" e_rls 
	       [Thm ("sym_real_mult_assoc", num_str (real_mult_assoc RS sym)),
		Thm ("sym_real_add_assoc",num_str (real_add_assoc RS sym))];

val scr_make_polynomial = 
"Script Expand_binoms t_ =\
\(Repeat                       \
\((Try (Repeat (Rewrite real_diff_minus         False))) @@ \ 

\ (Try (Repeat (Rewrite real_add_mult_distrib   False))) @@ \	 
\ (Try (Repeat (Rewrite real_add_mult_distrib2  False))) @@ \	
\ (Try (Repeat (Rewrite real_diff_mult_distrib  False))) @@ \	
\ (Try (Repeat (Rewrite real_diff_mult_distrib2 False))) @@ \	

\ (Try (Repeat (Rewrite real_mult_1             False))) @@ \		   
\ (Try (Repeat (Rewrite real_mult_0             False))) @@ \		   
\ (Try (Repeat (Rewrite real_add_zero_left      False))) @@ \	 

\ (Try (Repeat (Rewrite real_mult_commute       False))) @@ \		
\ (Try (Repeat (Rewrite real_mult_left_commute  False))) @@ \	
\ (Try (Repeat (Rewrite real_mult_assoc         False))) @@ \		
\ (Try (Repeat (Rewrite real_add_commute        False))) @@ \		
\ (Try (Repeat (Rewrite real_add_left_commute   False))) @@ \	 
\ (Try (Repeat (Rewrite real_add_assoc          False))) @@ \	 

\ (Try (Repeat (Rewrite sym_realpow_twoI        False))) @@ \	 
\ (Try (Repeat (Rewrite realpow_plus_1          False))) @@ \	 
\ (Try (Repeat (Rewrite sym_real_mult_2         False))) @@ \		
\ (Try (Repeat (Rewrite real_mult_2_assoc       False))) @@ \		

\ (Try (Repeat (Rewrite real_num_collect        False))) @@ \		
\ (Try (Repeat (Rewrite real_num_collect_assoc  False))) @@ \	

\ (Try (Repeat (Rewrite real_one_collect        False))) @@ \		
\ (Try (Repeat (Rewrite real_one_collect_assoc  False))) @@ \   

\ (Try (Repeat (Calculate plus  ))) @@ \
\ (Try (Repeat (Calculate times ))) @@ \
\ (Try (Repeat (Calculate power_)))) \  
\ t_)";

val make_polynomial = 
  Seq{id = "make_polynomial", preconds = []:term list, 
      rew_ord = ("dummy_ord", dummy_ord),
      erls = atools_erls, srls = Erls,
      calc = [],asm_thm = [],
      rules = [Rls_ expand_poly,
	       Rls_ order_add_mult,
	       Rls_ simplify_power,   (*realpow_eq_oneI, eg. x^1 --> x *)
	       Rls_ collect_numerals, (*eg. x^(2+ -1) --> x^1          *)
	       Rls_ reduce_012,
	       Thm ("realpow_oneI",num_str realpow_oneI),(*in --^*) 
	       Rls_ discard_parentheses
	       ],
      scr = EmptyScr
      }:rls;      
ruleset' := overwritel (!ruleset',
			[("expand_poly", expand_poly),
			 ("simplify_power", simplify_power),
			 ("order_add_mult", order_add_mult),
			 ("collect_numerals", collect_numerals),
			 ("reduce_012", reduce_012),
			 ("discard_parentheses", discard_parentheses),
			 ("make_polynomial", make_polynomial)
			 ]);


val scr_expand_binoms =
"Script Expand_binoms t_ =\
\(Repeat                       \
\((Try (Repeat (Rewrite real_plus_binom_pow2    False))) @@ \
\ (Try (Repeat (Rewrite real_plus_binom_times   False))) @@ \
\ (Try (Repeat (Rewrite real_minus_binom_pow2   False))) @@ \
\ (Try (Repeat (Rewrite real_minus_binom_times  False))) @@ \
\ (Try (Repeat (Rewrite real_plus_minus_binom1  False))) @@ \
\ (Try (Repeat (Rewrite real_plus_minus_binom2  False))) @@ \

\ (Try (Repeat (Rewrite real_mult_1             False))) @@ \
\ (Try (Repeat (Rewrite real_mult_0             False))) @@ \
\ (Try (Repeat (Rewrite real_add_zero_left      False))) @@ \

\ (Try (Repeat (Calculate plus  ))) @@ \
\ (Try (Repeat (Calculate times ))) @@ \
\ (Try (Repeat (Calculate power_))) @@ \

\ (Try (Repeat (Rewrite sym_realpow_twoI        False))) @@ \
\ (Try (Repeat (Rewrite realpow_plus_1          False))) @@ \
\ (Try (Repeat (Rewrite sym_real_mult_2         False))) @@ \
\ (Try (Repeat (Rewrite real_mult_2_assoc       False))) @@ \

\ (Try (Repeat (Rewrite real_num_collect        False))) @@ \
\ (Try (Repeat (Rewrite real_num_collect_assoc  False))) @@ \

\ (Try (Repeat (Rewrite real_one_collect        False))) @@ \
\ (Try (Repeat (Rewrite real_one_collect_assoc  False))) @@ \ 

\ (Try (Repeat (Calculate plus  ))) @@ \
\ (Try (Repeat (Calculate times ))) @@ \
\ (Try (Repeat (Calculate power_)))) \  
\ t_)";

val expand_binoms = 
  Rls{id = "expand_binoms", preconds = [], rew_ord = ("termlessI",termlessI),
      erls = atools_erls, srls = Erls,
      calc = [("plus"  , ("op +", eval_binop "#add_")), 
	      ("times" , ("op *", eval_binop "#mult_")),
	      ("power_", ("Atools.pow", eval_binop "#power_"))
	      ],
      asm_thm = [],
      rules = [Thm ("real_plus_binom_pow2"  ,num_str real_plus_binom_pow2),     
	       (*"(a + b) ^^^ 2 = a ^^^ 2 + 2 * a * b + b ^^^ 2"*)
	       Thm ("real_plus_binom_times" ,num_str real_plus_binom_times),    
	      (*"(a + b)*(a + b) = ...*)
	       Thm ("real_minus_binom_pow2" ,num_str real_minus_binom_pow2),   
	       (*"(a - b) ^^^ 2 = a ^^^ 2 - 2 * a * b + b ^^^ 2"*)
	       Thm ("real_minus_binom_times",num_str real_minus_binom_times),   
	       (*"(a - b)*(a - b) = ...*)
	       Thm ("real_plus_minus_binom1",num_str real_plus_minus_binom1),   
		(*"(a + b) * (a - b) = a ^^^ 2 - b ^^^ 2"*)
	       Thm ("real_plus_minus_binom2",num_str real_plus_minus_binom2),   
		(*"(a - b) * (a + b) = a ^^^ 2 - b ^^^ 2"*)
	       (*RL 020915*)
	       Thm ("real_pp_binom_times",num_str real_pp_binom_times), 
		(*(a + b)*(c + d) = a*c + a*d + b*c + b*d*)
               Thm ("real_pm_binom_times",num_str real_pm_binom_times), 
		(*(a + b)*(c - d) = a*c - a*d + b*c - b*d*)
               Thm ("real_mp_binom_times",num_str real_mp_binom_times), 
		(*(a - b)*(c + d) = a*c + a*d - b*c - b*d*)
               Thm ("real_mm_binom_times",num_str real_mm_binom_times), 
		(*(a - b)*(c - d) = a*c - a*d - b*c + b*d*)
	       Thm ("realpow_multI",num_str realpow_multI),                
		(*(a*b)^^^n = a^^^n * b^^^n*)
	       Thm ("real_plus_binom_pow3",num_str real_plus_binom_pow3),
	        (* (a + b)^^^3 = a^^^3 + 3*a^^^2*b + 3*a*b^^^2 + b^^^3 *)
	       Thm ("real_minus_binom_pow3",num_str real_minus_binom_pow3),
	        (* (a - b)^^^3 = a^^^3 - 3*a^^^2*b + 3*a*b^^^2 - b^^^3 *)


             (*  Thm ("real_add_mult_distrib" ,num_str real_add_mult_distrib),	
		(*"(z1.0 + z2.0) * w = z1.0 * w + z2.0 * w"*)
	       Thm ("real_add_mult_distrib2",num_str real_add_mult_distrib2),	
	       (*"w * (z1.0 + z2.0) = w * z1.0 + w * z2.0"*)
	       Thm ("real_diff_mult_distrib" ,num_str real_diff_mult_distrib),	
	       (*"(z1.0 - z2.0) * w = z1.0 * w - z2.0 * w"*)
	       Thm ("real_diff_mult_distrib2",num_str real_diff_mult_distrib2),	
	       (*"w * (z1.0 - z2.0) = w * z1.0 - w * z2.0"*)
	       *)
	       
	       Thm ("real_mult_1",num_str real_mult_1),              (*"1 * z = z"*)
	       Thm ("real_mult_0",num_str real_mult_0),              (*"0 * z = 0"*)
	       Thm ("real_add_zero_left",num_str real_add_zero_left),(*"0 + z = z"*)

	       Calc ("op +", eval_binop "#add_"), 
	       Calc ("op *", eval_binop "#mult_"),
	       Calc ("Atools.pow", eval_binop "#power_"),
               (*	       
	        Thm ("real_mult_commute",num_str real_mult_commute),		(*AC-rewriting*)
	       Thm ("real_mult_left_commute",num_str real_mult_left_commute),	(**)
	       Thm ("real_mult_assoc",num_str real_mult_assoc),			(**)
	       Thm ("real_add_commute",num_str real_add_commute),		(**)
	       Thm ("real_add_left_commute",num_str real_add_left_commute),	(**)
	       Thm ("real_add_assoc",num_str real_add_assoc),	                (**)
	       *)
	       
	       Thm ("sym_realpow_twoI",num_str (realpow_twoI RS sym)),		
	       (*"r1 * r1 = r1 ^^^ 2"*)
	       Thm ("realpow_plus_1",num_str realpow_plus_1),			
	       (*"r * r ^^^ n = r ^^^ (n + 1)"*)
	       (*Thm ("sym_real_mult_2",num_str (real_mult_2 RS sym)),		
	       (*"z1 + z1 = 2 * z1"*)*)
	       Thm ("real_mult_2_assoc",num_str real_mult_2_assoc),		
	       (*"z1 + (z1 + k) = 2 * z1 + k"*)

	       Thm ("real_num_collect",num_str real_num_collect), 
	       (*"[| l is_const; m is_const |] ==> l * n + m * n = (l + m) * n"*)
	       Thm ("real_num_collect_assoc",num_str real_num_collect_assoc),	
	       (*"[| l is_const; m is_const |] ==>  l * n + (m * n + k) =  (l + m) * n + k"*)
	       Thm ("real_one_collect",num_str real_one_collect),		
	       (*"m is_const ==> n + m * n = (1 + m) * n"*)
	       Thm ("real_one_collect_assoc",num_str real_one_collect_assoc), 
	       (*"m is_const ==> k + (n + m * n) = k + (1 + m) * n"*)

	       Calc ("op +", eval_binop "#add_"), 
	       Calc ("op *", eval_binop "#mult_"),
	       Calc ("Atools.pow", eval_binop "#power_")
	       ],
      scr = Script ((term_of o the o (parse thy)) scr_expand_binoms)
      }:rls;      


ruleset' := overwritel (!ruleset',
			[("make_polynomial", make_polynomial),
			 ("expand_binoms", expand_binoms)
			 ]);

(* use"../knowledge/Poly.ML";
   use"knowledge/Poly.ML";
   use"Poly.ML";
   WN.12.8.02
 *)
"******* Poly.ML end *******";
