(* theorems in the Reals,
   necessary for special rule sets, in addition to Isabelle2002.
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   !!! THIS IS THE _least_ NUMBER OF ADDITIONAL THEOREMS !!!
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   xxxI contain ^^^ instead of ^ in the respective theorem xxx in 2002
   WN.12.8.02
   changed by: rlang 02.09.12
*)

(*
   use_thy"knowledge/Poly";
   use_thy"Poly";
   use_thy_only"knowledge/Poly";

   remove_thy"Poly";
   use_thy"Isac";


   use"ROOT.ML";
   cd"knowledge";
 *)

Poly = Atools + 

(*-------------------- consts-----------------------------------------------*)
consts

  is'_expanded'_in :: "[real, real] => bool" ("_ is'_expanded'_in _")
  is'_poly'_in :: "[real, real] => bool" ("_ is'_poly'_in _")
  has'_degree'_in  :: "[real, real] => real" ("_ has'_degree'_in _")
  is'_polyrat'_in :: "[real, real] => bool" ("_ is'_polyrat'_in _")

  Expand'_binoms
             :: "['y, \
		  \ 'y] => 'y"
               ("((Script Expand'_binoms (_ =))// \
                 \ (_))" 9)

(*-------------------- rules------------------------------------------------*)
rules (*.not contained in Isabelle2002,
         stated as axioms, TODO: prove as theorems;
         theorem-IDs 'xxxI' with ^^^ instead of ^ in 'xxx' in Isabelle2002.*)

  realpow_pow             "(a ^^^ b) ^^^ c = a ^^^ (b * c)"
  realpow_addI		  "r ^^^ (n + m) = r ^^^ n * r ^^^ m"
  realpow_oneI            "r ^^^ 1 = r"
  realpow_eq_oneI         "1 ^^^ n = 1"
  realpow_multI           "(r * s) ^^^ n = r ^^^ n * s ^^^ n" 
  realpow_minus_oneI      "-1 ^^^ (2 * n) = 1"  

  realpow_twoI            "r ^^^ 2 = r * r"
  realpow_two_atom        "r is_atom ==> r * r = r ^^^ 2"
  realpow_plus_1          "r * r ^^^ n = r ^^^ (n + 1)"         
  realpow_plus_1_atom     "r is_atom ==> r * r ^^^ n = r ^^^ (1 + n)"
  realpow_def_atom        "[| Not (r is_atom); 1 < n |] \
			  \ ==> r ^^^ n = r * r ^^^ (n + -1)"
  realpow_addI_atom       "r is_atom ==> r ^^^ n * r ^^^ m = r ^^^ (n + m)"


  realpow_minus_even	  "n is_even ==> (- r) ^^^ n = r ^^^ n"
  realpow_minus_odd       "Not (n is_even) ==> (- r) ^^^ n = -1 * r ^^^ n"


(* RL 020914 *)
  real_pp_binom_times        "(a + b)*(c + d) = a*c + a*d + b*c + b*d"
  real_pm_binom_times        "(a + b)*(c - d) = a*c - a*d + b*c - b*d"
  real_mp_binom_times        "(a - b)*(c + d) = a*c + a*d - b*c - b*d"
  real_mm_binom_times        "(a - b)*(c - d) = a*c - a*d - b*c + b*d"
  real_plus_binom_pow3       "(a + b)^^^3 = a^^^3 + 3*a^^^2*b + 3*a*b^^^2 + b^^^3"
  real_minus_binom_pow3      "(a - b)^^^3 = a^^^3 - 3*a^^^2*b + 3*a*b^^^2 - b^^^3"

  real_diff_plus             "a - b = a + -b" (*17.3.03: do_NOT_use*)
  real_diff_minus            "a - b = a + -1 * b"
  real_plus_binom_times      "(a + b)*(a + b) = a^^^2 + 2*a*b + b^^^2"
  real_minus_binom_times     "(a - b)*(a - b) = a^^^2 - 2*a*b + b^^^2"
  real_plus_binom_pow2       "(a + b)^^^2 = a^^^2 + 2*a*b + b^^^2"
  real_minus_binom_pow2      "(a - b)^^^2 = a^^^2 - 2*a*b + b^^^2"
  real_minus_binom_pow2_p    "(a - b)^^^2 = a^^^2 + -2*a*b + b^^^2"
  real_plus_minus_binom1     "(a + b)*(a - b) = a^^^2 - b^^^2"
  real_plus_minus_binom1_p   "(a + b)*(a - b) = a^^^2 + -1*b^^^2"
  real_plus_minus_binom2     "(a - b)*(a + b) = a^^^2 - b^^^2"
  real_plus_minus_binom2_p   "(a - b)*(a + b) = a^^^2 + -1*b^^^2"

  real_num_collect           "[| l is_const; m is_const |] ==> \
					\l * n + m * n = (l + m) * n"
  real_num_collect_assoc     "[| l is_const; m is_const |] ==>  \
					\l * n + (m * n + k) = (l + m) * n + k"
  real_one_collect           "m is_const ==> n + m * n = (1 + m) * n"
  real_one_collect_assoc     "m is_const ==> n + (m * n + k) = (1 + m) * n + k"

  real_mult_2_assoc          "z1 + (z1 + k) = 2 * z1 + k"

end
