(* use"ME/generate.sml";
   use"generate.sml";
*)






(*generate 1 ppobj in ptree*)
fun generate1 thy (Take' t) l (p,p_) pt = (* val (Take' t) = m; *)
  let 
    val ct = Sign.string_of_term (sign_of thy) t;
    (*TODO: remove with rewrite term*)
    val p = let val (ps,p') = split_last p(*no connex to prev.ppobj*)
	    in if p'=0 then ps@[1] else p end;
    val (pt,c) = cappend_form pt p l ct;
  in ((p,Frm):pos', c, 
      Form' (FormKF (~1,EdUndef,(length p), Nundef, ct)), pt) end

(* val (l, (p,p_)) = (RrlsState is, p);
   *)
  | generate1 thy (Begin_Trans' t) l (p,p_) pt =
  let val p = (lev_on o lev_dn) p; 
    val ct = Sign.string_of_term (sign_of thy) t;
    (*TODO: remove with rewrite term*)
    val (pt,c) = cappend_form pt p l ct;
  in ((p,Frm), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ct)), pt) end

  | generate1 thy (End_Trans' t) l (p,p_) pt =
  let 
    val ct = Sign.string_of_term (sign_of thy) t;
    (*TODO: remove with rewrite term*)
    val (pt,c) = append_result pt p l ct Complete;
    val p' = lev_up p;
  in ((p',Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ct)), pt) end

  | generate1 thy (End_Detail' t) l (p,p_) pt = 
    generate1 thy (End_Trans' t) l (p,p_) pt

  | generate1 thy (Rewrite_Inst' (_,_,_,_,subs',thm',f,(f',asm))) l (p,p_) pt =
  let 
    val t2str = Sign.string_of_term (sign_of thy);
    val ff = t2str f;
    val ff' = t2str f';
    val subs = subst2subs subs';
    (*TODO: remove with rewrite term*)
    val (pt,c) = cappend_atomic pt p l ff 
      (Rewrite_Inst (subs,thm')) ff' Complete;
    val asm' = map (Sign.string_of_term (sign_of thy)) asm;
    val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm');
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt) end

  | generate1 thy (Rewrite' (thy',ord',rls',pa,thm',f,(f',asm))) l (p,p_) pt =
  let 
    val ff = Sign.string_of_term (sign_of thy) f;
    val ff' = Sign.string_of_term (sign_of thy) f';
    (*TODO: remove with rewrite on type term, not cterm'*)
    val (pt,c) = cappend_atomic pt p l ff 
      (Rewrite thm') ff' Complete;
    val asm' = map (Sign.string_of_term (sign_of thy)) asm;
    val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm');
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt)end

  | generate1 thy (Rewrite_Asm' all) l p pt = generate1 thy (Rewrite' all) l p pt

  | generate1 thy (Rewrite_Set_Inst' (_,_,subs',rls',f,(f',asm))) l (p,p_) pt =
  let 
    val t2str = Sign.string_of_term (sign_of thy);
    val ff = t2str f;
    val ff' = t2str f';
    val subs = subst2subs subs';
    (*TODO: remove with rewrite term*)
    val (pt,c) = cappend_atomic pt p l ff 
      (Rewrite_Set_Inst (subs,id_rls rls')) ff' Complete;
    val asm' = map (Sign.string_of_term (sign_of thy)) asm;
    val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm');
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt) end

  | generate1 thy (Rewrite_Set' (_,_,rls',f,(f',asm))) l (p,p_) pt =
  let 
    val t2str = Sign.string_of_term (sign_of thy);
    val ff = t2str f;
    val ff' = t2str f';
    (*TODO: remove with rewrite term*)
    val (pt,c) = cappend_atomic pt p l ff 
      (Rewrite_Set (id_rls rls')) ff' Complete;
    val asm' = map (Sign.string_of_term (sign_of thy)) asm;
    val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm');
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt) end

  | generate1 thy (Check_Postcond' (pI,scval)) l (p,p_) pt =
    let val ff' = Sign.string_of_term (sign_of thy) scval
	(*val (l',_) = get_obj g_loc pt p..don't overwrite with l from subpbl*)
	val (pt,c) = append_result pt p l ff' Complete
    in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), 
	pt) end

  | generate1 thy (Calculate' (thy',op_,f,(f',thm'))) l (p,p_) pt =
  let 
    val ff = Sign.string_of_term (sign_of thy) f;
    val ff' = Sign.string_of_term (sign_of thy) f';
    (*TODO: remove with rewrite term*)
    val (pt,c) = cappend_atomic pt p l ff 
      (Calculate op_) ff' Complete;
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt)end

  | generate1 thy (Check_elementwise' (consts,pred,f')) l (p,p_) pt =
    let 
      val ff = Sign.string_of_term (sign_of thy) consts;
      val ff' = Sign.string_of_term (sign_of thy) f';
      (*TODO: remove with rewrite term*)
      val (pt,c) = cappend_atomic pt p l ff 
	(Check_elementwise pred) ff' Complete;
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt)end

  | generate1 thy (Or_to_List' (ors,list)) l (p,p_) pt =
    let 
      val ff = Sign.string_of_term (sign_of thy) ors;
      val ff' = Sign.string_of_term (sign_of thy) list;
      (*TODO: remove with rewrite term*)
      val (pt,c) = cappend_atomic pt p l ff 
	Or_to_List ff' Complete;
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt)end

  | generate1 thy (Mstep' (_,f,id,f')) l (p,p_) pt =
    let val (pt,c) = cappend_atomic pt p l f (Mstep id) f' Complete;
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, f')), pt)end

  | generate1 thy (Subproblem' ((domID, pblID, metID), oris, f)) l (p,p_) pt =
    let val (pt,c) = cappend_problem pt p l (oris, (domID, pblID, metID));
	val pbl = init_pbl ((#ppc o get_pbt) pblID);
	val pt = update_pblppc pt p pbl;
	(*val _= writeln("### generate1: is([3],Frm)= "^
		       (istate2str (get_istate pt ([3],Frm))));*)
	val f = Sign.string_of_term (sign_of thy) f;
    in ((p,Pbl), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, f)), pt) end

  | generate1 thy m' _ _ _ = 
    raise error ("generate1: not impl.for "^(mstep'2str m'))
;


fun generate_hard thy m' (p,p_) pt =
  let  
    val p = case p_ of Frm => p | Res => lev_on p
  | _ => raise error ("generate_hard: call by "^(pos'2str (p,p_)));
  in generate1 thy m' e_istate (p,p_) pt end;
