(* W.N.22.11.99

   use"ME/modspec.sml";
   use"modspec.sml";

(* 25.1.: alle fun auskommentiert, die auch in nnewcode.sml sind 
   ...                                            *)
*)

(*---------------------------------------------(1) nach ptyps.sml 23.3.02*)

(* datatypes *)

datatype pblmet =       (*%^%*)
    Problem of pblID    (*%^%*)
  | Method of metID;    (*%^%*)
fun pblmet2str (Problem pblID) = "Problem "^(strs2str pblID)(*%^%*)
  | pblmet2str (Method metID) = "Method "^(metID2str metID);(*%^%*)
      (*%^%*)   (*26.6. moved to sequent.sml: fun ~~~~~~~~~; was here below*)


(* copy from 03.60.usecases.sml 15.11.99 *)
datatype user_cmd = 
  Accept   | NotAccept | Example
| YourTurn | MyTurn (* internal use only 7.6.02 java-sml*)   
| Rules
| DontKnow  (*| HowComes | WhatFor       7.6.02 java-sml*)
| Undo      (*| Back          | Forward  7.6.02 java-sml*)
| EndProof | EndSession
| ActivePlus | ActiveMinus | SpeedPlus | SpeedMinus
                           (*Stepwidth...7.6.02 java-sml*)
| Auto | NotAuto | Details;
(* for test-print-outs *)
fun user_cmd2str Accept     ="Accept"
  | user_cmd2str NotAccept  ="NotAccept"
  | user_cmd2str Example    ="Example"
  | user_cmd2str MyTurn     ="MyTurn"
  | user_cmd2str YourTurn   ="YourTurn"
  | user_cmd2str Rules	    ="Rules"
(*| user_cmd2str HowComes   ="HowComes"*)
  | user_cmd2str DontKnow   ="DontKnow"
(*| user_cmd2str WhatFor    ="WhatFor"
  | user_cmd2str Back       ="Back"*)
  | user_cmd2str Undo       ="Undo"
(*| user_cmd2str Forward    ="Forward"*)
  | user_cmd2str EndProof   ="EndProof"
  | user_cmd2str EndSession ="EndSession"
  | user_cmd2str ActivePlus = "ActivePlus"
  | user_cmd2str ActiveMinus = "ActiveMinus"
  | user_cmd2str SpeedPlus = "SpeedPlus"
  | user_cmd2str SpeedMinus = "SpeedMinus"
  | user_cmd2str Auto = "Auto"
  | user_cmd2str NotAuto = "NotAuto"
  | user_cmd2str Details = "Details";



(*3.5.00: TODO: foppFK eliminated in interface FE-KE !!!*)
datatype foppFK =                  (* in DG cases div 2 *)
  EmptyFoppFK         (*DG internal*)
| FormFK of cterm'
| PpcFK of cterm' ppc;
fun foppFK2str (FormFK ct') ="FormFK "^ct'
  | foppFK2str (PpcFK  ppc) ="PpcFK "^(ppc2str ppc)
  | foppFK2str EmptyFoppFK  ="EmptyFoppFK";


datatype nest = Open | Closed | Nundef;
fun nest2str Open = "Open"
  | nest2str Closed = "Closed"
  | nest2str Nundef = "Nundef";

type indent = int;
datatype edit = EdUndef | Write | Protect;
                                   (* bridge --> kernel *)
                                   (* bridge <-> kernel *)
(* needed in dialog.sml *)         (* bridge <-- kernel *)
fun edit2str EdUndef = "EdUndef"
  | edit2str Write = "Write"
  | edit2str Protect = "Protect";


datatype inout =
  New_User | End_User                                          (*<->*)
| New_Proof | End_Proof                                        (*<->*)
| Command of user_cmd                                          (*-->*)
| Request of string | Message of string                        (*<--*) 
| Error_ of string  | System of string                         (*<--*)
| FoPpcFK of foppFK                                            (*-->*)
| FormKF of cellID * edit * indent * nest * cterm'             (*<--*)
| PpcKF of cellID * edit * indent * nest * (pblmet * item ppc) (*<--*)
| RuleFK of mstep                                              (*-->*)
| RuleKF of edit * mstep                                       (*<--*)
| RefinedKF of match list                                      (*<--*)
| Select of mstep list                                         (*<--*)
| RefineKF of match list                                       (*<--*)
| Speed of int                                                 (*<--*)
| Active of int                                                (*<--*)
| Domain of domID;                                             (*<--*)

fun inout2str End_Proof = "End_Proof"
  | inout2str (Command user_cmd) = "Command "^(user_cmd2str user_cmd)
  | inout2str (Request s) = "Request "^s
  | inout2str (Message s) = "Message "^s
  | inout2str (Error_  s) = "Error_ "^s
  | inout2str (System  s) = "System "^s
  | inout2str (FoPpcFK foppFK) = "FoPpcFK "^(foppFK2str foppFK)
  | inout2str (FormKF (cellID, edit, indent, nest, ct')) =  
	       "FormKF ("^(string_of_int cellID)^","
	       ^(edit2str edit)^","^(string_of_int indent)^","
	       ^(nest2str nest)^",("
	       ^ct' ^")"
  | inout2str (PpcKF (cellID, edit, indent, nest, (pm,itemppc))) =
	       "PpcKF ("^(string_of_int cellID)^","
	       ^(edit2str edit)^","^(string_of_int indent)^","
	       ^(nest2str nest)^",("
	       ^(pblmet2str pm)^","^(itemppc2str itemppc)^"))"
  | inout2str (RuleKF (edit,mstep)) = "RuleKF "^
	       pair2str(edit2str edit,mstep2str mstep)
  | inout2str (RuleFK mstep) = "RuleFK "^(mstep2str mstep)  
  | inout2str (Select msteps)= 
	       "Select "^((strs2str' o (map mstep2str)) msteps)
  | inout2str (RefineKF ms)  = "RefineKF "^(matchs2str ms)
  | inout2str (Speed i) = "Speed "^(string_of_int i)
  | inout2str (Active i) = "Active "^(string_of_int i)
  | inout2str (Domain dI) = "Domain "^dI;
fun inouts2str ios = (strs2str' o (map inout2str)) ios; 

datatype mout =          (* DG<--ME *)
  Form' of inout         (* packing cterm' | cterm' ppc *)
| Problems of inout      (* passes specify (and solve)  *)
| Error' of inout
| EmptyMout;
fun mout2str (Form' inout) ="Form' "^(inout2str inout)
  | mout2str (Error'  inout) ="Error' "^(inout2str inout)
  | mout2str (EmptyMout    ) ="EmptyMout";

(*30.4.02 intermediate hack for ass_up*)
fun f_mout thy (Form' (FormKF (_,_,_,_,f))) = (term_of o the o (parse thy)) f
  | f_mout thy _ = raise error "f_mout: not called with formula";





(*---------------------------------------------(2) nach ptyps.sml 23.3.02*)


(* make a term 'typeless' for comparing with another 'typeless' term;
   'type-less' usually is illtyped                                  *)
fun typeless (Const(s,_)) = (Const(s,e_type)) 
  | typeless (Free(s,_)) = (Free(s,e_type))
  | typeless (Var(n,_)) = (Var(n,e_type))
  | typeless (Bound i) = (Bound i)
  | typeless (Abs(s,_,t)) = Abs(s,e_type, typeless t)
  | typeless (t1 $ t2) = (typeless t1) $ (typeless t2);
(*
> val (Some ct) = parse thy "max_relation (A=#2*a*b - a^^^#2)";
> val (_,t1) = split_dsc_t hs (term_of ct);
> val (Some ct) = parse thy "A=#2*a*b - a^^^#2";
> val (_,t2) = split_dsc_t hs (term_of ct);
> typeless t1 = typeless t2;
val it = true : bool
*)



(* to an input (d,ts) find the according ori
   and insert the ts *)
fun seek_oridts thy sel (d,ts) [] pval = 
  ("'"^(string_of_cterm (compos thy (d,ts)))^
   "' not found (typed)", e_ori_:ori, [], pval)
  | seek_oridts thy sel (d,ts) ((id,vat,sel',d',ts')::(oris:ori list)) pval =
    if sel = sel' andalso d=d' andalso (ts inter ts') <> [] 
      then if sel = sel' 
	     then ("",(id,vat,sel,d, ts inter(*!overlap!*) ts'):ori, pval,
		   ts')
	   else ((string_of_cterm (compos thy(d,ts)))^
		 " not for "^sel, e_ori_, [], [])
    else seek_oridts thy sel (d,ts) oris pval;

fun seek_orits thy sel ts [] pval = 
  ("'"^
   (strs2str (map (Sign.string_of_term (sign_of thy)) ts))^
   "' not found (typed)", e_ori_, pval, [])
  | seek_orits thy sel ts ((id,vat,sel',d,ts')::(oris:ori list)) pval =
    if sel = sel' andalso (ts inter ts') <> [] 
      then if sel = sel' 
	     then ("",(id,vat,sel,d,ts inter(*!overlap!*) ts'):ori, pval,
		   ts')
	   else (((strs2str' o map 
		  (Sign.string_of_term (sign_of thy))) ts)^
	     " not for "^sel, e_ori_, [], [])
    else seek_orits thy sel ts oris pval;
(* false
> val ((id,vat,sel',d,ts')::(ori':ori)) = ori;
> seek_orits thy sel ts [(id,vat,sel',d,ts')];
uncaught exception TYPE
> seek_orits thy sel ts [];
uncaught exception TYPE
*)

fun seek_ppc id [] = None
  | seek_ppc id (p::(ppc:itm list)) =
    if id = #1 p then Some p else seek_ppc id ppc;



(*---------------------------------------------(3) nach ptyps.sml 23.3.02*)


datatype appl = Appl of mstep' | Notappl of string;

fun ppc2list ({Given=gis,Where=whs,Find=fis,
	       With=wis,Relate=res}: 'a ppc) =
  gis @ whs @ fis @ wis @ res;
fun ppc135list ({Given=gis,Find=fis,Relate=res,...}: 'a ppc) =
  gis @ fis @ res;




(* get the number of variants in a problem in 'original',
   assumes equal descriptions in immediate sequence    *)
fun variants_in ts =
  let fun eq(x,y) = head_of x = head_of y;
    fun cnt eq [] y n = ([n],[])
      | cnt eq (x::xs) y n = if eq(x,y) then cnt eq xs y (n+1)
			     else ([n], x::xs);
    fun coll eq  xs [] = xs
      | coll eq  xs (y::ys) = 
      let val (n,ys') = cnt eq (y::ys) y 0;
      in if ys' = [] then xs @ n else coll eq  (xs @ n) ys' end;
    val vts = (distinct (coll eq [] ts))\\[1];
  in case vts of [] => 1 | [n] => n
      | _ => error "different variants in formalization" end;
(*
> cnt (op=) [2,2,2,4,5,5,5,5,5] 2 0;
val it = ([3],[4,5,5,5,5,5]) : int list * int list
> coll (op=) [] [1,2,2,2,4,5,5,5,5,5];
val it = [1,3,1,5] : int list
*)

fun is_list_type (Type("List.list",_)) = true
  | is_list_type _ = false;
(* fun destr (Type(str,sort)) = (str,sort);
> val (Some ct) = parse thy "lll::real list";
> val ty = (#T o rep_cterm) ct;
> is_list_type ty;
val it = true : bool 
> destr ty;
val it = ("List.list",["RealDef.real"]) : string * typ list
> atomty thy ((#t o rep_cterm) ct);
*** -------------
*** Free ( lll, real list)
val it = () : unit
 
> val (Some ct) = parse thy "[lll::real]";
> val ty = (#T o rep_cterm) ct;
> is_list_type ty;
val it = true : bool 
> destr ty;
val it = ("List.list",["'a"]) : string * typ list
> atomty thy ((#t o rep_cterm) ct);
*** -------------
*** Const ( List.list.Cons, [real, real list] => real list)
***   Free ( lll, real)
***   Const ( List.list.Nil, real list) 

> val (Some ct) = parse thy "lll";
> val ty = (#T o rep_cterm) ct;
> is_list_type ty;
val it = false : bool  *)


fun has_list_type (Free(_,T)) = is_list_type T
  | has_list_type _ = false;
(*
> val (Some ct) = parse thy "lll::real list";
> has_list_type (term_of ct);
val it = true : bool
> val (Some ct) = parse thy "[lll::real]";
> has_list_type (term_of ct);
val it = false : bool *)




(*fdcrs = descriptions in formalization
  unused 22.11.00
fun is_already_input thy fdcrs ts t = 
  let 
    val tss = flat (map isalist2list ts);
(*28.1.     val (dcr,t') = split_dsc_t fdcrs t; *)
    val (dcr,[t']) = split_dts t;
  in if (typeless t') mem (map typeless tss)
            then ("term '"^(Sign.string_of_term (sign_of thy) t')^
		  "' already input")
	  else "" end;

> val pts = appc (map (term_of o the o (parse thy))) pbl;
> val ts = #Relate pts;
> val t = (term_of o the o (parse thy))"(A=#2*a*b - a^^^#2)";
> is_already_input thy ts t;
val it = "term 'A = #2 * a * b - a ^^^ #2' already input" : string
> val t = (term_of o the o (parse thy))"a=#2*R*sin alpha";
> is_already_input thy ts t;
val it = "term 'a = #2 * R * sin alpha' already input" : string
> val t = (term_of o the o (parse thy))"a=R*sin alpha";
> is_already_input thy ts t;
val it = "" : string
*)


fun is_parsed (Syn _) = false
  | is_parsed _ = true;
fun parse_ok its = foldl and_ (true, map is_parsed its);

fun all_dsc_in itm_s =
  let    
    fun d_in (Cor ((d,_),_)) = [d]
      | d_in (Syn c) = []
      | d_in (Typ c) = []
      | d_in (Inc ((d,_),_)) = [d]
      | d_in (Sup (d,_)) = [d]
      | d_in (Mis (d,_)) = [d];
  in (flat o (map d_in)) itm_s end;  

(* 30.1.00 ---
fun is_Syn (Syn _) = true
  | is_Syn (Typ _) = true
  | is_Syn _ = false;
 --- *)
fun is_error (Cor (_,ts)) = false
  | is_error (Sup (_,ts)) = false
  | is_error (Inc (_,ts)) = false
  | is_error (Mis (_,ts)) = false
  | is_error _ = true;

(* 30.1.00 ---
fun ct_in (Syn (c)) = c
  | ct_in (Typ (c)) = c
  | ct_in _ = raise error "ct_in called for Cor .. Sup";
 --- *)

(*#############################################################*)
(*#############################################################*)
(* vvv--- aus nnewcode.sml am 30.1.00 ---vvv *)


(* testdaten besorgen:
   use"test-coil-kernel.sml";
   val (PblObj{origin=(oris,_),meth={ppc=itms,...},...}) = 
        get_obj I pt p;
  *)

(* given oris, ppc, 
   variant V: oris union ppc => int, id ID: oris union ppc => int

   ppc is_complete == 
     EX vt:V. ALL r:oris --> EX i:ppc. ID r = ID i  &  complete i

   and
     @vt = max sum(i : ppc) V i
*)



(*
> ((vts_cnt (vts_in itms))) itms;



---^^--test 10.3.
> val vts = vts_in itms;
val vts = [1,2,3] : int list
> val nvts = vts_cnt vts itms;
val nvts = [(1,6),(2,5),(3,7)] : (int * int) list
> val mx = max2 nvts;
val mx = (3,7) : int * int
> val v = max_vt itms;
val v = 3 : int
--------------------------
> 
*)

(* get the first term in ts *)
fun getr_ct thy ((_,_,fd,d,ts):ori) =
  (fd, (string_of_cterm o (compos thy)) (d,[hd ts]):cterm');

(* get a term from ori, notyet input in itm *)
fun geti_ct thy ((_,_,_,d,ts):ori) ((_,_,_,fd,itm_):itm) =  
  (fd, (string_of_cterm o (compos thy)) (d,ts \\ (ts_in itm_)):cterm');
(* test-maximum.sml fmy <> [], Init_Proof ...
   val (_,_,_,d,ts) = ori; val (_,_,_,fd,itm_) = hd icl;
   val d' $ ts' = (term_of o the o (parse thy)) "fixedValues [r=Arbfix]";
   atomty thy d;
   atomty thy d';
   atomty thy (hd ts);
   atomty thy ts';
   cterm_of (sign_of thy) (d $ (hd ts));
   cterm_of (sign_of thy) (d' $ ts');

   compos thy (d,ts);
   *)


(* in FE dsc, not dat: this is in itms ...*)
fun is_untouched ((_,_,false,_,Inc((_,[]),_)):itm) = true
  | is_untouched _ = false;


(* select an item in oris, notyet input in itms 
   (precondition: in itms are only Cor, Sup, Inc) *)
(* 
>  val thy = assoc_thy dI;val itms = pbl;
   nxt_add thy oris pbt itms;
   *)
fun nxt_add thy ([]:ori list) pbt itms = (*root (only) ori...fmz=[]*)
  let
    fun test_d d ((i,_,_,_,itm_):itm) = (d = (d_in itm_)) andalso i<>0; 
    fun is_elem itms (f,(d,t)) = 
      case find_first (test_d d) itms of 
	Some _ => true | None => false;
  in case filter_out (is_elem itms) pbt of
(* val ((f,(d,_))::itms) = filter_out (is_elem itms) pbt;
   *)
    (f,(d,_))::itms => 
      Some (f:string, (string_of_cterm o compos thy) (d,[]):cterm')
  | _ => None end

(* val thy = assoc_thy dI; val pbt = mpc; val itms = met;

   val (thy,itms)=(assoc_thy (if dI=e_domID then dI' else dI), pbl);
   *)
  | nxt_add thy oris pbt itms =
  let
    fun testr_vt v ori = (curry (op mem) v) (#2 (ori:ori))
      andalso (#3 ori) <>"#undef";
    fun testi_vt v itm = (curry (op mem) v) (#2 (itm:itm));
    fun test_id ids r = curry (op mem) (#1 (r:ori)) ids;
(* val itm = hd icl; val (_,_,_,d,ts) = v6;
   *)
    fun test_subset (itm:itm) ((_,_,_,d,ts):ori) = 
	(d_in (#5 itm)) = d andalso (ts_in (#5 itm)) subset ts;
    fun false_and_not_Sup((i,v,false,f,Sup _):itm) = false
      | false_and_not_Sup (i,v,false,f, _) = true
      | false_and_not_Sup  _ = false;

    val v = if itms = [] then 1 else max_vt itms;
    val vors = if v = 0 then oris else filter (testr_vt v) oris;(*oris..vat*)
    val vits = if v = 0 then itms (*because of dsc without dat*)
	       else filter (testi_vt v) itms;                   (*itms..vat*)
    val icl = filter false_and_not_Sup vits; (* incomplete *)
  in if icl = [] 
       then case filter_out (test_id (map #1 vits)) vors of
	 [] => None
       | miss => Some (getr_ct thy (hd miss))
     else
       case find_first (test_subset (hd icl)) vors of
(* val Some ori = find_first (test_subset (hd icl)) vors;
   *)
	 None => raise error "nxt_add: EX itm. not(dat(itm)<=dat(ori))"
       | Some ori => Some (geti_ct thy ori (hd icl))
  end;



fun mk_delete thy "#Given"  itm_ = Del_Given   (itm_out thy itm_)
  | mk_delete thy "#Find"   itm_ = Del_Find    (itm_out thy itm_)
  | mk_delete thy "#Relate" itm_ = Del_Relation(itm_out thy itm_)
  | mk_delete thy str _ = 
  raise error ("mk_delete: called with field '"^str^"'");
fun mk_additem "#Given" ct = Add_Given ct
  | mk_additem "#Find"  ct = Add_Find ct    
  | mk_additem "#Relate"ct = Add_Relation ct
  | mk_additem str _ = 
  raise error ("mk_additem: called with field '"^str^"'");


(* called only once, if a Subproblem has been located in the script*)
fun nxt_model_pbl (Subproblem'((_,pblID,metID),_,_)) =
    (case metID of
	(_,"no_met") => Refine_Tacitly pblID
    | _ => Model_Problem pblID)
  | nxt_model_pbl e = raise error ("nxt_model_pbl: called by last ets = ");
(* run subp_rooteq.sml ''
   until nxt=("Subproblem",Subproblem ("SqRoot.thy",["univariate","equation"]))
> val (_, (Subproblem'((_,pblID,metID),_,_),_,_,_,_,_)) =
      (last_elem o drop_last) ets'';
> val mst = (last_elem o drop_last) ets'';
> nxt_model_pbl mst;
val it = Refine_Tacitly ["univariate","equation"] : mstep
*)




(* find the next mstep in specify (except nxt_model_pbl)
   4.00.: TODO: do not return a pos !!!
          (sind from DG comes the _OLD_ writepos)*)
(* 
> val (pbl,pbt,mpc) =(pbl',get_pbt cpI,(#ppc o get_met) cmI);
> val (dI,pI,mI) = empty_spec;
> nxt_spec Pbl (oris:ori list) ((dI',pI',mI'):spec(*original*))
  ((pbl:itm list), (met:itm list)) (pbt,mpc) ((dI,pI,mI):spec);

at Init_Proof:
> val met = [];val (pbt,mpc) = (get_pbt pI',(#ppc o get_met) mI');
> val (dI,pI,mI) = empty_spec;
> nxt_spec Pbl (oris:ori list) ((dI',pI',mI'):spec(*original*))
  ((pbl:itm list), (met:itm list)) (pbt,mpc) ((dI,pI,mI):spec);
  *)

(*. determine the next step of specification;
    not done here: Refine_Tacitly (otherwise *** unknown method: (..., no_met))
eg. in rootpbl 'no_met': 
args:
  preok          predicates are _all_ ok, or problem matches completely
  oris           immediately from formalization 
  (dI',pI',mI')  specification coming from author/parent-problem
  (pbl,          item lists specified by user
   met)          -"-, tacitly completed by copy_probl
  (dI,pI,mI)     specification explicitly done by the user
  (pbt, mpc)     problem type, guard of method
.*)
fun nxt_spec Pbl preok (oris:ori list) ((dI',pI',mI'):spec)
  ((pbl:itm list), (met:itm list)) (pbt,mpc) ((dI,pI,mI):spec) = 
(* val preok=ok; val (pbl,met)=(itms,met); 
   val (pbt,mpc)=((#ppc o get_pbt) pI'', (#ppc o get_met) mID);
   val (dI,pI,mI) = (dI'',pI'',mID);

   val preok = ok; val pbl = itms; 
   val (pbt,mpc) = ((#ppc o get_pbt) pI,(#ppc o get_met) mI'');

   val (preok,pbl,pbt,mpc)=(pb,pbl',(#ppc o get_pbt) cpI,(#ppc o get_met) cmI);
   *)
  ((*writeln"### nxt_spec Pbl";*)
   if dI'=e_domID andalso dI=e_domID then (Pbl, Specify_Domain dI')
   else if pI'=e_pblID andalso pI=e_pblID 
	  then (Pbl, Specify_Problem pI')
	else case find_first (is_error o #5) (pbl:itm list) of
	  Some (_,_,_,fd,itm_) => 
	      (Pbl, mk_delete 
	       (assoc_thy (if dI=e_domID then dI' else dI)) fd itm_)
	| None => 
	    ((*writeln"### nxt_spec is_error None";*)
	     case nxt_add (assoc_thy (if dI=e_domID then dI' else dI)) 
		 oris pbt pbl of
(* val Some (fd,ct') = nxt_add (assoc_thy (if dI=e_domID then dI' else dI)) 
                       oris pbt pbl;
  *)
	       Some (fd,ct') => ((*writeln"### nxt_spec nxt_add Some";*)
				 (Pbl, mk_additem fd ct'))
	     | None => (*pbl-items complete*)
	       if not preok then (Pbl, Refine_Problem pI')
	       else
		 if dI = e_domID then (Pbl, Specify_Domain dI')
		 else if pI = e_pblID then (Pbl, Specify_Problem pI')
		      else if mI = e_metID then (Pbl, Specify_Method mI')
			   else
			     case find_first (is_error o #5) met of
			       Some (_,_,_,fd,itm_) => 
				   (Met, mk_delete (assoc_thy dI) fd itm_)
			     | None => 
				 (case nxt_add (assoc_thy dI) oris mpc met of
				      Some (fd,ct') => (*30.8.01: pre?!?*)
				      (Met, mk_additem fd ct')
				    | None => 
				      ((*Solv 3.4.00*)Met, Apply_Method mI))))
(* val preok=pb; val (pbl, met) = (pbl,met');
   val (pbt,mpc)=((#ppc o get_pbt) cpI,(#ppc o get_met) cmI);
   *)
  | nxt_spec Met preok oris (dI',pI',mI') (pbl, met) (pbt,mpc) (dI,pI,mI) = 
  ((*writeln"### nxt_spec Met"; *)
   case find_first (is_error o #5) met of
     Some (_,_,_,fd,itm_) => 
	 (Met, mk_delete (assoc_thy (if dI=e_domID then dI' else dI)) fd itm_)
   | None => 
       case nxt_add (assoc_thy (if dI=e_domID then dI' else dI))oris mpc met of
	 Some (fd,ct') => (Met, mk_additem fd ct')
       | None => 
	   ((*writeln"### nxt_spec Met: nxt_add None";*)
	    if dI = e_domID then (Met, Specify_Domain dI')
	    else if pI = e_pblID then (Met, Specify_Problem pI')
		 else if not preok then (Met, Specify_Method mI)
		      else (Met, Apply_Method mI)));
	  
(* di_ pI_ mI_ pos_
val itms = [(1,[1],true,"#Find",Cor(e_term,[e_term])):itm,
	    (2,[2],true,"#Find",Syn("empty"))];
*)


(* ^^^--- aus nnewcode.sml am 30.1.00 ---^^^ *)
(*#############################################################*)
(*#############################################################*)
(* vvv--- aus nnewcode.sml vor 29.1.00 ---vvv *)

(*3.3.--
fun update_itm (cl,d,ts) ((id,vt,_,sl,Cor (_,_)):itm) = 
  (id,vt,cl,sl,Cor (d,ts)):itm
  | update_itm (cl,d,ts) (id,vt,_,sl,Syn (_)) =   
  raise error ("update_itm "^(string_of_cterm (compos thy (d,ts)))^
	       " not not for Syn (s:cterm')")
  | update_itm (cl,d,ts) (id,vt,_,sl,Typ (_)) = 
  raise error ("update_itm "^(string_of_cterm (compos thy (d,ts)))^
	       " not not for Typ (s:cterm')")
  | update_itm (cl,d,ts) (id,vt,_,sl,Fal (_,_)) =
  (id,vt,cl,sl,Fal (d,ts))
  | update_itm (cl,d,ts) (id,vt,_,sl,Inc (_,_)) =
  (id,vt,cl,sl,Inc (d,ts))
  | update_itm (cl,d,ts) (id,vt,_,sl,Sup (_,_)) =
  (id,vt,cl,sl,Sup (d,ts));
*)




fun is_field_correct sel d dscpbt =
  case assoc (dscpbt, sel) of
    None => false
  | Some ds => d mem ds;

(*. update the itm_ already input, all..from ori .*)
(* make penv w.r.t. intersections ... 22.3.02 TODO *)
(* val (id,vt,fd,d,ts) = (i,v,f,d,ts\\ts');
   *)
fun ori_2itm itm_ (pid, pval) all ((id,vt,fd,d,ts):ori) = 
  let 
    val ts' = (ts_in itm_) union ts;
    val complete = if eq_set (ts', all) then true else false;
  in case itm_ of
    (Cor _) => 
	(if fd = "#undef" then (id,vt,complete,fd,Sup(d,ts')) 
	 else (id,vt,complete,fd,Cor((d,ts'),(pid, pval)))):itm
  | (Syn c)     => raise error ("ori_2itm wants to overwrite "^c)
  | (Typ c)     => raise error ("ori_2itm wants to overwrite "^c)
  | (Inc _) => if complete
	       then (id,vt,true ,fd, Cor ((d,ts'),(pid, pval)))
	       else (id,vt,false,fd, Inc ((d,ts'),(pid, pval)))
  | (Sup ((*_,_*)d,ts')) => (*4.9.01 lost env*)
	 (*if fd = "#undef" then*) (id,vt,complete,fd,Sup(d,ts'))
	 (*else (id,vt,complete,fd,Cor((d,ts'),e))*)
(* 28.1.00: not completely clear ---^^^ etc.*)
(* 4.9.01: Mis just copied---vvv *)
  | (Mis _) => if complete
		     then (id,vt,true ,fd, Cor ((d,ts'),(pid, pval)))
		     else (id,vt,false,fd, Inc ((d,ts'),(pid, pval)))
  end;


fun eq1 d (_,(d',_)) = (d = d');
fun eq3 f d (_,_,_,f',itm_) = f = f' andalso d = (d_in itm_); 


(* 'all' ts from ori; ts is the input; (ori carries rest of info)
   9.01: this + ori_2itm is _VERY UNCLEAR_ ? overhead ?
   pval: value for problem-environment _NOT_ checked for 'inter'*)
(*. is_input ori itms <=> 
    EX itm. (1) ori(field,dsc) = itm(field,dsc) & (2..4)
            (2) ori(ts) subset itm(ts)        --- Err "already input"       
	    (3) ori(ts) inter itm(ts) = empty --- new: ori(ts)
	    (4) -"- <> empty                  --- new: ori(ts) \\ inter .*)
(* val(itms,(i,v,f,d,ts)) = (ppc,ori');
   *)
fun is_notyet_input thy (itms:itm list) pval all ((i,v,f,d,ts):ori) pbt =
  case find_first (eq1 d) pbt of
      Some (_,(_,pid)) =>(* val Some (_,(_,pid)) = find_first (eq1 d) pbt;
                            val Some (_,_,_,_,itm_)=find_first (eq3 f d) itms;
			   *)
      (case find_first (eq3 f d) itms of
	   Some (_,_,_,_,itm_) =>
	   let 
	       val ts' = (ts_in itm_) inter ts;
	   in if ts subset ts' 
	      then (((strs2str' o 
		      map (Sign.string_of_term (sign_of thy))) ts')^
		    " already input", e_itm)                            (*2*)
	      else ("", ori_2itm itm_ (pid, pval) all 
				 (i,v,f,d,ts\\ts'))     (*3,4*)
	   end
	 | None => ("", ori_2itm (Inc ((e_term,[]),(pid,[]))) 
				 (pid, pval) all (i,v,f,d,ts))          (*1*)
	)
    | None => ("", ori_2itm (Sup (d,ts)) 
			      (e_term, []) all (i,v,f,d,ts));
(*------------------------------------------------
fun eq3 f d (_,_,_,f',itm_) = f = f' andalso d = (d_in itm_); 
fun is_notyet_input thy itms pval all ((id,vt,fd,d,ts):ori) pbt =
  case find_first (eq1 d) pbt of
      Some (_,(_,pid)) => (* val Some (_,(_,pid)) = find_first (eq1 d) pbt;
                              *)
      (case seek_ppc id itms of
	   Some (id',_,_,_,itm_) =>
	   let 
	       val ts' = (ts_in itm_) inter ts;
	   in if ts'= [] then ("", ori_2itm itm_ (pid, pval) all 
					    (id,vt,fd,d,(ts_in itm_)@ts))
	      else (((strs2str' o 
		      map (Sign.string_of_term (sign_of thy))) ts')^
		    " already input", e_itm) end
	 | None => 
	   if all = ts 
	   then ("", ori_2itm (Cor ((e_term,[]),(pid,[])))
			      (pid, pval) all (id,vt,fd,d,ts))
	   else ("", ori_2itm (Inc ((e_term,[]),(e_term,[]))) 
			      (pid, pval) all (id,vt,fd,d,ts))
	)
    | None => ("", ori_2itm (Sup (e_term,[])) 
			      (e_term, []) all (id,vt,fd,d,ts));----*)

fun test_types thy (d,ts) =
  let 
    val s = !show_types; val _ = show_types:= true;
    val opt = (try (compos thy)) (d,ts);
    val msg = case opt of 
      Some _ => "" 
    | None => ((Sign.string_of_term  (sign_of thy) d)^" "^
	     ((strs2str' o map (Sign.string_of_term(sign_of thy)))ts)
	     ^" is illtyped");
    val _ = show_types:= s
  in msg end;



fun maxl [] = raise error "maxl of []"
  | maxl (y::ys) =
  let fun mx x [] = x
	| mx x (y::ys) = if x < (y:int) then mx y ys else mx x ys
  in mx y ys end;


(*. is the input term t known in oris ? 
    give feedback on all(?) strange input;
    return _all_ terms already input to this item (e.g. valuesFor a,b) .*)
fun is_known thy sel ori t =
(* val (ori,t)=(oris,term_of ct);
   *)
  let
    val ots = (distinct o flat o (map #5)) (ori:ori list);
    val oids = ((map (fst o dest_Free)) o distinct o 
		flat o (map vars)) ots;
    val (d,ts,pval) = split_dts thy t;
    val ids = map (fst o dest_Free) 
      ((distinct o (flat o (map vars))) ts);
  in if (ids \\ oids) <> []
       then (("identifiers "^(strs2str' (ids \\ oids))^
	      " not in example"), e_ori_, [], [])
     else 
	 if d = e_term 
	 then 
	     if not ((map typeless ts) subset (map typeless ots))
	     then (("terms '"^
		    ((strs2str' o (map (Sign.string_of_term 
					    (sign_of thy)))) ts)^
		    "' not in example (typeless)"), e_ori_, [], [])
	     else (case seek_orits thy sel ts ori pval of
		       ("", ori_ as (_,_,_,d,ts), all, pval) =>
		       (case test_types thy (d,ts) of
			    "" => ("", ori_, pval, all)
			  | msg => (msg, e_ori_, [], []))
		     | (msg,_,_,_) => (msg, e_ori_, [], []))
	 else 
	     if d mem (map #4 ori) 
	     then seek_oridts thy sel (d,ts) ori pval
	     else ((Sign.string_of_term (sign_of thy) d)^
		   " not in example", e_ori_, [], [])
  end;


(*. for return-value of appl_add .*)
datatype additm =
	 Add of itm
       | Err of string;    (*error-message*)


(*. add an item; check wrt. oris and pbt .*)

(* in contrary to oris<>[] below, this part handles user-input
   extremely acceptive, i.e. accept input instead error-msg *)
fun appl_add thy sel ([]:ori list) ppc pbt ct' =
(* val (ppc,pbt,ct',env) = (pbl, (#ppc o get_pbt) cpI, ct, []:envv);
   !!!! 28.8.01: env tested _minimally_ !!!
   *)
  let 
    val i = 1 + (if ppc=[] then 0 else maxl (map #1 ppc));
  in case parse thy ct' of (*should be done in applicable_in 4.00.TODO*)
    None => Add (i,[],false,sel,Syn ct')
(* val (Some ct) = parse thy ct';
   *)
  | Some ct =>
      let
	val (d,ts,pval) = split_dts thy (term_of ct);
      in if d = e_term 
	 then Add (i,[],false,sel,Mis (dsc_unknown,hd ts(*24.3.02*)))
      
	 else  
	   (case find_first (eq1 d) pbt of
	     None => Add (i,[],true,sel,Sup ((d,ts)))
	   | Some (f,(_,id)) =>
(* val Some (f,(_,id)) = find_first (eq1 d) pbt;
   *)
	       let
		 fun eq2 d ((i,_,_,_,itm_):itm) = 
		     (d = (d_in itm_)) andalso i<>0;
	       in case find_first (eq2 d) ppc of 
		 None => Add (i,[],true,f, Cor ((d,ts), (id, pval)))
	       | Some (i',_,_,_,itm_) => 
(* val Some (i',_,_,_,itm_) = find_first (eq2 d) ppc;
   val None = find_first (eq2 d) ppc;
   *)
		   if is_list_dsc d
		   then let val ts = ts union (ts_in itm_) 
			in Add (if ts_in itm_ = [] then i else i',
				 [],true,f,Cor ((d, ts), (id, pval)))
			end
		   else Add (i',[],true,f,Cor ((d,ts),(id, pval)))
	       end
	   )
      end
  end
(*. add ct to ppc .*)
(*FIXXME: accept items as Sup, Syn here, too (like appl_add..oris=[] above)*)
(* val (ppc,pbt) = (pbl, (#ppc o get_pbt) cpI);

   val (ppc,pbt) = (met, (#ppc o get_met) cmI);

   val (ppc,pbt) = (pbl, (#ppc o get_pbt) cpI);
   *)
  | appl_add thy sel oris ppc pbt(*only for upd_envv*) ct = 
  let
    val ctopt = parse thy ct;
  in case ctopt of
    None => Err ("syntax error in "^ct)
  | Some ct =>(* val Some ct = ctopt;
		 val (msg,ori',pval,all) = is_known thy sel oris (term_of ct);
		 val (msg,itm) = is_notyet_input thy ppc pval all ori' pbt;
		*) 
    (case is_known thy sel oris (term_of ct) of
	 ("",ori'(*ts='ct'*), pval, all) => 
	 (case is_notyet_input thy ppc pval all ori' pbt of
	      ("",itm)  => Add itm
	    | (msg,_) => Err msg)
       | (msg,_,_,_) => Err msg)
  end;
(* 
> val (msg,itm) = is_notyet_input thy ppc all ori';
val itm = (12,[3],false,"#Relate",Cor (Const #,[#,#])) : itm
> val itm_ = #5 itm;
> val ts = ts_in itm_;
> map (atomty thy) ts; 
*)

(*---------------------------------------------(4) nach ptyps.sml 23.3.02*)


(* make oris from args of SubProblem and pbt *)

fun is_cpy str =
    case (rev o explode) str of
	"_"::_::"_"::_ => true
      | _ => false;
(*> is_cpy "v_i_";
val it = true : bool
  > is_cpy "e_";
val it = false : bool *)
fun is_cp (_,(_,t)) = (is_cpy o free2str) t;

fun mtc thy (str, (dsc, _)) (ty $ va) = 
    (cterm_of (sign_of thy) (dsc $ va);
     Some (([1], str, dsc, [va])(*:ori without leading #*)))
    handle _ => None;
(*> val pbt = (#ppc o get_pbt) ["univariate","equation"];
> val Const ("Script.SubProblem",_) $
	(Const ("Pair",_) $ Free (thy',_) $
	       (Const ("Pair",_) $ pblID' $
		      (Const ("Pair",_) $ Free (mI1',_) $ Free (mI2',_)))) $
	ags = (term_of o the o (parse thy))
  "(SubProblem (SqRoot_,[univariate,equation],\
   \   (SqRoot_,solve_linear)) [bool_ (x+#1-#2=#0), real_ x])::bool list";
> val ags = isalist2list ags;
> mtc thy (hd pbt) (hd ags);
val it = Some ([1],"#Given",Const (#,#),[# $ #]) *)

(*copy-named vars must be filtered out*)
fun matc thy [] _ oris = oris (*type oris, but without leading # *)
  | matc thy ((p as (s,(d,t)))::pbt) (a::ags) oris =
    if (is_cpy o free2str) t then oris
    else let val opt = mtc thy p a;  
	 in case opt of 
		Some ori => matc thy pbt ags (oris @ [ori])
	      | None => raise error ("match "^
				     (Sign.string_of_term (sign_of thy) (d$t))^
				     " doesn't match "^
				     (Sign.string_of_term (sign_of thy) a))
	 end; 
fun matc thy [] _ oris = oris (*type oris, but without leading #1 *)
  | matc thy ((p as (s,(d,t)))::pbt) (a::ags) oris =
    if (is_cpy o free2str) t then oris
    else let val opt = mtc thy p a;  
	 in case opt of 
		Some ori => ((*writeln("### matc: ori0= "^(ori02str ori));*)
			     matc thy pbt ags (oris @ [ori]))
	      | None => raise error ("match: "^
				     (Sign.string_of_term (sign_of thy) (d$t))^
				     " doesn't match "^
				     (Sign.string_of_term (sign_of thy) a))
	 end; 
(* run subp-rooteq.sml until Init_Proof before ...
> val Nd (PblObj {origin=(oris,_),...},_) = pt;(*from test/subp-rooteq.sml*)
> fun xxxfortest (_,a,b,c,d) = (a,b,c,d);val oris = map xxxfortest oris;

 other vars as in mtc ..
> matc thy (drop_last pbt) ags [];
val it = ([[1],"#Given",Const #,[#]),(0,[#],"#Given",Const #,[#])],2)*)


(*copy name from an appropriate in problem-type,
  pbt and oris are 1:1 until cpy-nam at the end*)
fun cpy_nam pbt oris (gfr,(dsc,t)) =
  let fun sel (_,_,_,[vl]) = vl;
      val cy = (implode o drop_last o drop_last o explode o free2str) t;
      val ext = (last_elem o drop_last o explode o free2str) t;
      val vars' = map (free2str o snd o snd) pbt;(*cpy-nam filtered_out*)
      val vals = map sel oris;
      val cy_ext = (free2str o the) (assoc (vars'~~vals, cy))^"_"^ext;
  in ([1], gfr, dsc, [mk_free (type_of t) cy_ext]) end;
(*> val (gfr,(dsc,t)) = last_elem pbt;
> cpy_nam pbt (drop_last oris) (gfr,(dsc,t));
val it = ([1],"#Find",
   Const ("Descript.solutions","bool List.list => Tools.toreall"),
   [Free ("x_i","bool List.list")])                             *)

(*expects beginning of pbt:ags = 1:1, until cpy-nam in pbt*)
fun match_ags thy pbt ags =
    let fun flattup (i,(var,bool,str,itm_)) = (i,var,bool,str,itm_);
	val pbt' = filter_out is_cp pbt;(*cpy-nam are never args of script*)
	val cy = filter is_cp pbt;
	val oris' = matc thy pbt' ags [];
	val cy' = map (cpy_nam pbt' oris') cy;
	val ors = add_id (oris' @ cy');
    in (map flattup ors):ori list end;
(*vars as above ..
> match_ags thy pbt ags; 
val it =
  [(1,[1],"#Given",Const ("Descript.equality","bool => Tools.una"),
    [Const # $ (# $ #) $ Free (#,#)]),
   (2,[1],"#Given",Const ("Descript.solveFor","RealDef.real => Tools.una"),
    [Free ("x","RealDef.real")]),
   (3,[1],"#Find",
    Const ("Descript.solutions","bool List.list => Tools.toreall"),
    [Free ("x_i","bool List.list")])] : ori list*)

(*@@@
> val Nd (PblObj {origin=(oris,_),...},_) = pt;(*from test/subp-rooteq.sml*)

*)





(* init pbl with ...,dsc,empty | [] *)
fun init_pbl pbt = 
  let 
    fun pbt2itm (f,(d,t)) = 
      ((0,[],false,f,Inc((d,[]),(e_term,[]))):itm);
  in map pbt2itm pbt end;

fun overwrite_ppc thy itm ppc =
  let 
    fun repl ppc' (_,_,_,_,itm_) [] =
      raise error ("overwrite_ppc: "^(itm_2str thy itm_)^" not found")
      | repl ppc' itm (p::ppc) =
	if (#1 itm) = (#1 (p:itm)) then ppc' @ [itm] @ ppc
	else repl (ppc' @ [p]) itm ppc
  in repl [] itm ppc end;

(*10.3.00: insert the already compiled itm into ppc;
   filter_out ev. related untouched (in FE) item    *)
(* val ppc=pbl;
   *)
fun insert_ppc thy itm ppc =
  let 
    fun eq_untouched d ((0,_,_,_,itm_):itm) = (d = d_in itm_)
      | eq_untouched _ _ = false;
    val ppc' = 
      (
(*writeln("### insert_ppc: itm= "^(itm2str itm));*)       
       case seek_ppc (#1 itm) ppc of
	 Some _ => (*itm updated in is_notyet_input*)
	   overwrite_ppc thy itm ppc
       | None => (ppc @ [itm]));
  in filter_out (eq_untouched ((d_in o #5) itm)) ppc' end;



(*. output the headline to a ppc .*)
fun header p_ pI mI =
    case p_ of Pbl => Problem (if pI = e_pblID then [] else pI) 
	     | Met => Method mI
	     | pos => raise error ("header called with "^ pos_2str pos);



(* test-printouts ---
val _=writeln("### insert_ppc: (d,ts)= "^(string_of_cterm(compos thy(d,ts))));
 val _=writeln("### insert_ppc: pts= "^
(strs2str' o map (Sign.string_of_term (sign_of thy))) pts);


 val sel = "#Given"; val Add_Given' ct = m;
 val sel = "#Find"; val Add_Find' ct = m;
 val (_,_,f,nxt',_,pt')= specify_additem sel ct (p,Pbl(*!!!!!!!*)) c pt;
  *)
fun specify_additem sel ct (p,Pbl) c pt = 
    let
      val (PblObj{meth=met,origin=(oris,(dI',pI',mI')),
		  probl=pbl,spec=(dI,pI,mI),...}) = get_obj I pt p;
      val thy = if dI = e_domID then assoc_thy dI' else assoc_thy dI;
    (*val ppt = if pI = e_pblID then get_pbt pI' else get_pbt pI;*)
      val cpI = if pI = e_pblID then pI' else pI;
      val cmI = if mI = e_metID then mI' else mI
      val {ppc,where_,prls,...} = get_pbt cpI
(* val Add itm = appl_add thy sel oris pbl ((#ppc o get_pbt) cpI) ct;
                  *)
    in case appl_add thy sel oris pbl ppc ct of
      Add itm (*..union old input *) =>
	let
(*val _= writeln("###specify_additem: itm= "^(itm2str itm));*)
	  val pbl' = insert_ppc thy itm pbl;
	  val pt' = update_pbl pt p pbl'
	  val (pre, pb) = check_preconds thy prls where_ pbl';
	  val (p_,nxt) =
	    nxt_spec Pbl pb oris (dI',pI',mI') (pbl',met) 
		     (ppc,(#ppc o get_met) cmI) (dI,pI,mI);
	  val ppc = if p_= Pbl then pbl' else met;
	in ((p,p_), []:cid,
	    Form' (PpcKF (0,EdUndef,(length p),Nundef,
			  (header p_ pI cmI,
			   itms2itemppc thy ppc pre))), nxt,Safe,pt') end
    | Err msg =>
	  let val (_, pb) = check_preconds thy prls where_ pbl
	      val (p_,nxt) =
	    nxt_spec Pbl pb oris (dI',pI',mI') (pbl,met) 
	    (ppc,(#ppc o get_met) cmI) (dI,pI,mI);
	  in ((p,p_), []:cid, Error' (Error_ msg), nxt, Safe,pt) end
    end
(* val sel = "#Find"; val (p,_) = p; val Add_Find' ct = nxt;
   val (_,_,f,nxt',_,pt')= specify_additem sel ct (p,Met) c pt;
  *)
  | specify_additem sel ct (p,Met) c pt = 
    let
      val (PblObj{meth=met,origin=(oris,(dI',pI',mI')),
		  probl=pbl,spec=(dI,pI,mI),...}) = get_obj I pt p;
      val thy = if dI = e_domID then assoc_thy dI' else assoc_thy dI;
    (*val ppt = if pI = e_pblID then get_pbt pI' else get_pbt pI;*)
      val cpI = if pI = e_pblID then pI' else pI;
      val cmI = if mI = e_metID then mI' else mI;
      val {ppc,pre,prls,...} = get_met cmI
    in case appl_add thy sel oris met ppc ct of
      Add itm (*..union old input *) =>
	let (* val Add itm = appl_add thy sel oris met (#ppc (get_met cmI)) ct;
               *)
	  val met' = insert_ppc thy itm met;
	  val pt' = update_met pt p met';
	  (*val pt' = update_pbl pt p (env, pbl); 3.9.01*)
	  val (pre', pb) = check_preconds thy prls pre met';
	  val (p_,nxt) =
	    nxt_spec Met pb oris (dI',pI',mI') (pbl,met') 
	    ((#ppc o get_pbt) cpI,ppc) (dI,pI,mI);
	in ((p,p_), []:cid,
	    Form' (PpcKF (0,EdUndef,(length p),Nundef,
			  (Method cmI, itms2itemppc thy met' pre'))),
	    nxt,Safe,pt') end
    | Err msg =>
	  let val (_, pb) = check_preconds thy prls pre met;
	      val (p_,nxt) =
	    nxt_spec Met pb oris (dI',pI',mI') (pbl,met) 
	    ((#ppc o get_pbt) cpI,(#ppc o get_met) cmI) (dI,pI,mI);
	  in ((p,p_), []:cid, Error' (Error_ msg), nxt, Safe,pt) end
    end;
(* ori
val (msg,itm) = appl_add thy sel oris ppc ct;
val (Cor(d,ts)) = #5 itm;
map (atomty thy) ts;

pre
*)

(* specify (Init_Proof' (fmz,(dI',pI',mI'))) e_pos' [] EmptyPtree;
   *)
fun specify (Init_Proof' (fmz,(dI',pI',mI')))(_:pos')(_:cid)(_:ptree)= 
  let          (* either """"""""""""""" all empty or complete *)
    val thy = assoc_thy dI'
    val oris = if dI' = e_domID orelse pI' = e_pblID then ([]:ori list)
	       else prep_ori fmz thy ((#ppc o get_pbt) pI');
    val (pt,c) = cappend_problem e_ptree [] e_istate (oris,(dI',pI',mI'));
    val {ppc,prls,where_,...} = get_pbt pI'
    val pbl = init_pbl ppc;
    val pt = update_pbl pt [] pbl;
    val (pre, pb) = check_preconds thy prls where_ pbl;
  in case mI' of
	 (_,"no_met") => 
	 (([],Pbl), c,
	  Form' (PpcKF (0,EdUndef,(length []),Nundef,
			(Problem [], itms2itemppc (assoc_thy dI') pbl pre))),
	  Refine_Tacitly pI', Safe,pt)
       | _ => 
	 (([],Pbl), c,
	  Form' (PpcKF (0,EdUndef,(length []),Nundef,
			(Problem [], itms2itemppc (assoc_thy dI') pbl pre))),
	  snd(nxt_spec Pbl pb oris (dI',pI',mI') 
	      (pbl,[]) ((#ppc o get_pbt) pI',(#ppc o get_met) mI')empty_spec),
	  Safe,pt)
  end

  | specify (Model_Problem' _) (p,_) c pt = (*called only by Subproblem*)
  let
    val (PblObj{origin=(oris,(dI',pI',mI')), meth=met,
		probl=pbl,spec=(dI,_,_),...}) = get_obj I pt p
    val thy' = if dI = e_domID then dI' else dI
    val thy = assoc_thy thy'
    val {ppc,prls,where_,...} = get_pbt pI'
    val (pre, pb) = check_preconds thy prls where_ pbl;
    val (_,nxt) = nxt_spec Pbl pb oris (dI',pI',mI') (pbl,met) 
		(ppc,(#ppc o get_met) mI') (dI',pI',mI');
  in ((p,Pbl), c,
      Form' (PpcKF (0,EdUndef,(length p),Nundef,
		    (Problem pI', itms2itemppc (assoc_thy dI') pbl pre))),
      nxt, Safe, pt) end

(*. called only if no_met is specified .*)     
  | specify (Refine_Tacitly' (pI,pIre)) (p,_) c pt =
  let (* val Refine_Tacitly' (pI,pIre) = m;
         *)
    val (PblObj{origin=(oris,(dI',pI',mI')), meth=met, ...}) = 
	get_obj I pt p;
    val {prls,met,ppc,thy,where_,...} = get_pbt pIre;
    val pbl = init_pbl ppc;
    val pt = update_pbl pt p pbl;
    val pt = update_orispec pt p 
		(string_of_thy thy, pIre, 
		 if length met = 0 then e_metID else hd met);
    val (pre, pb) = check_preconds thy prls where_ pbl;
  in ((p,Pbl), c,
      Form' (PpcKF (0,EdUndef,(length p),Nundef,
		    (Problem pIre, itms2itemppc (assoc_thy dI') pbl pre))),
      Model_Problem pIre, Safe, pt) end
     
  | specify (Refine_Problem' ms) (p,_) c pt =
    ((p,Pbl), c, Problems (RefinedKF ms), Model_Problem (refined ms), Safe, pt)
(* val (Specify_Problem' (pI, (ok, (itms, pre)))) = nxt; val (p,_) = p;
   *)
  | specify (Specify_Problem' (pI, (ok, (itms, pre)))) (p,_) c pt =
  let val (PblObj {origin=(oris,(dI',pI',mI')), spec=(dI,_,mI), 
		   meth=met, ...}) = get_obj I pt p;
    val pt = update_pbl pt p itms;
    val pt = update_pblID pt p pI;
    val dI'' = assoc_thy (if dI=e_domID then dI' else dI);
    val mI'' = if mI=e_metID then mI' else mI;
    val (_,nxt) = nxt_spec Pbl ok oris (dI',pI',mI') (itms, met) 
		((#ppc o get_pbt) pI,(#ppc o get_met) mI'') (dI,pI,mI);
  in ((p,Pbl), c,
      Form' (PpcKF (0,EdUndef,(length p),Nundef,
		    (Problem pI, itms2itemppc dI'' itms pre))),
      nxt, Safe, pt) end    
(* val Specify_Method' mID = nxt; val (p,_) = p;
   val Specify_Method' mID = m;
   specify (Specify_Method' mID) (p,p_) c pt;
   *)
  | specify (Specify_Method' mID) (p,_) c pt =
  let val (PblObj {origin=(oris,(dI',pI',mI')), probl=pbl, spec=(dI,pI,mI), 
		   meth=met, ...}) = get_obj I pt p;
    val {ppc,pre,prls,...} = get_met mID
    val thy = assoc_thy dI
    val oris = add_field' thy ppc oris;
    val pt = update_oris pt p oris; (*20.3.02: repl. "#undef"*)
    val dI'' = if dI=e_domID then dI' else dI;
    val pI'' = if pI = e_pblID then pI' else pI;
    val met = if met=[] then pbl else met;
    val (ok, (itms, pre')) = match_itms_oris thy met (ppc,pre,prls ) oris;
    val pt = update_met pt p itms;
    val pt = update_metID pt p mID;
    val (_,nxt) = nxt_spec Met (*ok*)true oris (dI',pI',mI') (pbl, itms) 
		((#ppc o get_pbt) pI'',ppc) (dI'',pI'',mID);
  in ((p,Met), c,
      Form' (PpcKF (0,EdUndef,(length p),Nundef,
		    (Method mID, itms2itemppc (assoc_thy dI'') itms pre'))),
      nxt, Safe, pt) end    
(* val Add_Find' ct = nxt; val sel = "#Find"; val (p,p_) = p;
   *)
  | specify (Add_Given' ct) p c pt = specify_additem "#Given" ct p c pt
  | specify (Add_Find'  ct) p c pt = specify_additem "#Find"  ct p c pt
  | specify (Add_Relation' ct) p c pt=specify_additem"#Relate"ct p c pt
(* val Specify_Domain' domID = m;
   *)
  | specify (Specify_Domain' domID) (p,p_) c pt =
    let
      val thy = assoc_thy domID;
      val (PblObj{origin=(oris,(dI',pI',mI')), meth=met,
		  probl=pbl, spec=(dI,pI,mI),...}) = get_obj I pt p;
      val mppc = case p_ of Pbl => pbl | Met => met;
      val cpI = if pI = e_pblID then pI' else pI;
      val {prls=per,ppc,where_=pwh,...} = get_pbt cpI
      val cmI = if mI = e_metID then mI' else mI;
      val {prls=mer,ppc=mpc,pre=mwh,...} = get_met cmI
      val (pre, pb) = 
	  case p_ of
	      Pbl => (check_preconds thy per pwh pbl)
	    | Met => (check_preconds thy mer mwh met)
    in if domID = dI
       then let 
           val (p_,nxt) = nxt_spec p_ pb oris (dI',pI',mI') 
				   (pbl,met) (ppc,mpc) (dI,pI,mI);
	      in ((p,p_), c, 
		  Form'(PpcKF (0,EdUndef,(length p), Nundef,
			       (header p_ pI cmI, itms2itemppc thy mppc pre))),
		  nxt,Safe,pt) end
       else (*FIXME: check ppc wrt. (new!) domID .. 30.8.01 still !!!*)
	 let 
	   val pt = update_domID pt p domID;
	   val (p_,nxt) = nxt_spec p_ pb oris (dI',pI',mI') (pbl,met) 
				   (ppc,mpc) (domID,pI,mI);
	 in ((p,p_), c, 
	     Form' (PpcKF (0, EdUndef, (length p),Nundef,
			   (header p_ pI cmI, itms2itemppc thy mppc pre))),
	     nxt, Safe,pt) end
    end
(* itms2itemppc thy [](*mpc*) pre
   *)
  | specify m' _ _ _ = 
    raise error ("specify: not impl. for (no: mstep'2str m'");




(*18.12.99*)
fun get_spec_form (m:mstep') ((p,p_):pos') (pt:ptree) = 
(*  case appl_spec p pt m of           /// 19.1.00
    Notappl e => Error' (Error_ e)
  | Appl => 
*)    let val (_,_,f,_,_,_) = specify m (p,p_) [] pt
      in f end;






(* --------------------- ME --------------------- *)
fun tag_form thy (formal, given) = cterm_of (sign_of thy) 
	      (((head_of o term_of) given) $ (term_of formal));
(* val formal = (the o (parse thy)) "[R::real]";
> val given = (the o (parse thy)) "fixed_values (cs::real list)";
> tag_form thy (formal, given);
val it = "fixed_values [R]" : cterm
*)
fun chktyp thy (n, fs, gs) = 
  ((writeln o string_of_cterm o (nth n)) fs;
   (writeln o string_of_cterm o (nth n)) gs;
   tag_form thy (nth n fs, nth n gs));

fun chktyps thy (fs, gs) = map (tag_form thy) (fs ~~ gs);

(* #####################################################
   find the failing item:
> val n = 2;
> val tag__form = chktyp (n,formals,givens);
> (type_of o term_of o (nth n)) formals; 
> (type_of o term_of o (nth n)) givens;
> atomty thy ((term_of o (nth n)) formals);
> atomty thy ((term_of o (nth n)) givens);
> atomty thy (term_of tag__form);
> use_thy"isa-98-1-HOL-plus/knowl-base/DiffAppl";
 ##################################################### *)

(* #####################################################
   testdata setup
val origin = ["sqrt(9+4*x)=sqrt x + sqrt(5+x)","x::rat","(+0)"];
val formals = map (the o (parse thy)) origin;

val given  = ["equation (lhs=rhs)",
	     "bound_variable bdv",   (* TODO type *) 
	     "error_bound apx"];
val where_ = ["e is_root_equation_in bdv",
	      "bdv is_var",
	      "apx is_const_expr"];
val find   = ["L::rat set"];
val with_  = ["L = {bdv. || ((%x. lhs) bdv) - ((%x. rhs) bdv) || < apx}"];
val chkpbl = map (the o (parse thy)) (given @ where_ @ find @ with_);
val givens = map (the o (parse thy)) given;

val tag__forms = chktyps (formals, givens);
map ((atomty thy) o term_of) tag__forms;
 ##################################################### *)


(* check pbltypes, announces one failure a time *)
fun chk_vars ctppc = 
  let val {Given=gi,Where=wh,Find=fi,With=wi,Relate=re} = 
    appc flat (mappc (vars o term_of) ctppc)
  in if (wh\\gi) <> [] then ("wh\\gi",wh\\gi)
     else if (re\\(gi union fi)) <> [] 
	    then ("re\\(gi union fi)",re\\(gi union fi))
	  else ("ok",[]) end;

(* check a new pbltype: variables (Free) unbound by given, find*) 
fun unbound_ppc ctppc =
  let val {Given=gi,Find=fi,Relate=re,...} = 
    appc flat (mappc (vars o term_of) ctppc)
  in distinct (re\\(gi union fi)) end;
(*
> val org = {Given=["[R=(R::real)]"],Where=[],
	   Find=["[A::real]"],With=[],
	   Relate=["[A=#2*a*b - a^^^#2, (a//#2)^^^#2 + (b//#2)^^^#2 = R^^^#2]"]
	   }:string ppc;
> val ctppc = mappc (the o (parse thy)) org;
> unbound_ppc ctppc;
val it = [("a","RealDef.real"),("b","RealDef.real")] : (string * typ) list
*)


(* f, a binary operator, is nested rightassociative *)
fun foldr1 f xs =
  let
    fun fld f (x::[]) = x
      | fld f (x::x'::[]) = f (x',x)
      | fld f (x::x'::xs) = f (fld f (x'::xs),x);
  in ((fld f) o rev) xs end;
(*
> val (Some ct) = parse thy "[a=b,c=d,e=f]";
> val ces = map (cterm_of (sign_of thy)) (isalist2list (term_of ct));
> val conj = foldr1 HOLogic.mk_conj (isalist2list (term_of ct));
> cterm_of (sign_of thy) conj;
val it = "(a = b & c = d) & e = f" : cterm
*)

(* f, a binary operator, is nested leftassociative *)
fun foldl1 f (x::[]) = x
  | foldl1 f (x::x'::[]) = f (x,x')
  | foldl1 f (x::x'::xs) = f (x,foldl1 f (x'::xs));
(*
> val (Some ct) = parse thy "[a=b,c=d,e=f,g=h]";
> val ces = map (cterm_of (sign_of thy)) (isalist2list (term_of ct));
> val conj = foldl1 HOLogic.mk_conj (isalist2list (term_of ct));
> cterm_of (sign_of thy) conj;
val it = "a = b & c = d & e = f & g = h" : cterm
*)



(*
 use"ME/modspec.sml";
 use"modspec.sml";
 *)