(* tools for model-specify and ptyps
   use"ME/mstools.sml";
   use"mstools.sml";
   *)



(*27.8.01: problem-environment*)
type penv = (term          (*err_*)
	     * (term list) (*[#0, epsilon]*)
	     ) list;
fun pen2str thy (t, ts) =
    pair2str(Sign.string_of_term (sign_of thy) t,
	     (strs2str' o map (Sign.string_of_term (sign_of thy))) ts);
fun penv2str thy (penv:penv) = (strs2str' o (map (pen2str thy))) penv;

type envv = (int * penv) list;

(*. 14.9.01: not used after putting penv-values into itm_
      make the result of split_* a value of problem-environment .*)
fun mkval dsc [] = raise error "mkval called with []"
  | mkval dsc [t] = t
  | mkval dsc ts = list2isalist ((type_of o hd) ts) ts;




(*. get the constant value from a penv .*)
fun getval (id, values) = 
    case values of
	[] => raise error ("penv_value: no values in '"^
			   (Sign.string_of_term (sign_of Tools.thy) id))
      | [v] => (id, v)
      | (v1::v2::_) => (case v1 of 
			     Const ("Script.Arbfix",_) => (id, v2)
			   | _ => (id, v1));
(*
  val e_ = (term_of o the o (parse thy)) "e_::bool";
  val ev = (term_of o the o (parse thy)) "#4 + #3 * x^^^#2 = #0";
  val v_ = (term_of o the o (parse thy)) "v_";
  val vv = (term_of o the o (parse thy)) "x";
  val r_ = (term_of o the o (parse thy)) "err_::bool";
  val rv1 = (term_of o the o (parse thy)) "eps";
  val rv2 = (term_of o the o (parse thy)) "#0";

  val penv = [(e_,[ev]),(v_,[vv]),(r_,[rv2,rv1])]:penv;
  map getval penv;
[(Free ("e_","bool"),
  Const (#,#) $ (# $ # $ (# $ #)) $ Free ("#0","RealDef.real")),
 (Free ("v_","RealDef.real"),Free ("x","RealDef.real")),
 (Free ("err_","bool"),Free ("#0","RealDef.real"))] : (term * term) list      
*)


(*23.3.02 TODO: ideas on redesign of type itm_,type item,type ori,type item ppc
(1) kinds of itms:
  (1.1) untouched: for modeling only dsc displayed(impossible after match_itms)
        =(presently) Mis (? should be Inc initially, and Mis after match_itms?)
  (1.2)  Syn,Typ,Sup: not related to oris
    Syn, Typ (presently) should be accepted in appl_add (instead Error')
    Sup      (presently) should be accepted in appl_add (instead Error')
         _could_ be w.r.t current vat (and then _is_ related to vat
    Mis should _not_ be  made Inc ((presently, by appl_add & match_itms)
- dsc in itm_ is timeconsuming -- keep id for respective queries ?
- order of items in ppc should be stable w.r.t order of itms

- stepwise input of itms --- match_itms (in one go) ..not koordinated
  - unify code
  - match_itms / match_itms_oris ..2 versions ?!
    (fast, for refine / slow, for modeling)

- clarify: efficiency <--> simplicity !!!
  ?: shift dsc itm_ -> itm | discard int in ori,itm | take int instead dsc 
    | take int for perserving order of item ppc in itms 
    | make all(!?) handling of itms stable against reordering(?)
    | field in ori ?? (not from fmz!) -- meant for efficiency (not doc!???)
      -"- "#undef" ?= not touched ?= (id,..)
-----------------------------------------------------------------
27.3.02:
def: type pbt = (field, (dsc, pid))

(1) fmz + pbt -> oris
(2) input + oris -> itm
(3) match_itms      : schnell(?) f"ur refine
    match_itms_oris : r"uckmeldung f"ur item ppc

(1.1) in oris fehlt daher pid: (i,v,f,d,ts,pid)
---------- ^^^^^ --- dh. pbt meist als argument zu viel !!!

(3.1) abwarten, wie das matchen mehr unterschiedlicher pbt's sich macht;
      wenn Problem pbt v"ollig neue, dann w"are eigentlich n"otig ????:
      (a) (_,_,d1,ts,_):ori + pbt -> (i,vt,d2,ts,pid)  dh.vt neu  ????
      (b) 
*)




(*4.9.01: not consistent:
  after Init_Proof 'Inc', but after copy_probl 'Mis' - for same situation
  (involves 'is_error');
  bool in itm really necessary ???*)
datatype itm_ = 
    Cor of (term *              (* description *)
	    (term list)) *      (* for list: elem-wise input *) 
	   (term * (term list)) (* elem of penv *)
  | Syn of cterm'
  | Typ of cterm'
  | Inc of (term * (term list))	* (term * (term list)) (*lists only !*)
  | Sup of (term * (term list)) (* user-input not found in pbt *)
  | Mis of (term * term)        (* pbt-item not found in pbl: only dsc, pid_ *)
(*| Inc of bool --- instead of istate in itm ?26.1.00?*);

type vats = int list;      (*variants in formalizations*)

(*.data-type for working on pbl/met-ppc: 
   in pbl initially holds descriptions (only) for user guidance.*)
type itm = 
  int *        (* id  =0 .. untouched - descript (only) from init 
		  23.3.02: seems to correspond to ori (fun insert_ppc)
		           with the purpose to maintain order in item ppc?*)
  vats *       (* variants - copy from ori *)
  bool *       (* input on this item is not/complete *)
  string *     (* #Given | #Find | #Relate *)
  itm_;        (*  *)
(* use"ME/sequent.sml";
   *)
val e_itm = (0,[],false,"e_itm",Syn"e_itm"):itm;

(* find most frequent variant v in itms *)

fun vts_in itms = (distinct o flat o (map #2)) (itms:itm list);

fun cnt itms v = (v,(length o (filter (curry op= v)) o 
		     flat o (map #2)) (itms:itm list));
fun vts_cnt vts itms = map (cnt itms) vts;
fun max2 [] = raise error "max2 of []"
  | max2 (y::ys) =
  let fun mx (a,x) [] = (a,x)
	| mx (a,x) ((b,y)::ys) = 
    if x < y then mx (b,y) ys else mx (a,x) ys;
in mx y ys end;

(*. find the variant with most items already input .*)
fun max_vt itms = 
    let val vts = (vts_cnt (vts_in itms)) itms;
    in if vts = [] then 0 else (fst o max2) vts end;


(* TODO ev. make more efficient by avoiding flat *)
fun mk_e (Cor (_, iv)) = [getval iv]
  | mk_e (Syn _) = []
  | mk_e (Typ _) = [] 
  | mk_e (Inc (_, iv)) = [getval iv]
  | mk_e (Sup _) = []
  | mk_e (Mis _) = [];
fun mk_en vt ((i,vts,b,f,itm_):itm) =
    if vt mem vts then mk_e itm_ else [];
(*. extract the environment from an item list; 
    takes the variant with most items .*)
fun mk_env itms = 
    let val vt = max_vt itms
    in (flat o (map (mk_en vt))) itms end;



(*. example as provided by an author, complete w.r.t. pbt specified 
    not touched by any user action                                 .*)
type ori = (int *      (* id: 10.3.00ff impl. only <>0 .. touched 
			  21.3.02: insert_ppc needs it ! ?:purpose maintain
				   order in item ppc ???*)
	    vats *     (* variants 21.3.02: related to pbt..discard ?*)
	    string *   (* #Given | #Find | #Relate 21.3.02: discard ?*)
	    term *     (* description *)
	    term list  (* isalist2list t | [t] *)
	    );
val e_ori_ = (0,[],"",e_term,[e_term]):ori;
val e_ori = (0,[],"",e_term,[e_term]):ori;
(* [e_ori_]:ori;
val it = [(0,[],"",Const (#,#),[Const #])] : ori
*)
fun ori2str ((i,vs,fi,t,ts):ori) = 
    "("^(string_of_int i)^", "^((strs2str o (map string_of_int)) vs)^", "^fi^","^
    (term2str t)^", "^((strs2str o (map term2str)) ts)^")";
fun ori02str (vs,fi,t,ts) = 
    "("^((strs2str o (map string_of_int)) vs)^", "^fi^", "^
    (term2str t)^", "^((strs2str o (map term2str)) ts)^")";




(*. given the input value (from split_dts)
    make the value in a problem-env according to description-type .*)
(*28.8.01: .nam and .una impl. properly, others copied .. TODO*)
fun pbl_ids thy (Const(_,Type("fun",[_,Type("Tools.nam",_)]))) v =
    if is_list v 
    then [v]         (*eg. [r=Arbfix]*)
    else (case v of  (*eg. eps=#0*)
	      (Const ("op =",_) $ l $ r) => [r,l]
	    | _ => raise error ("pbl_ids Tools.nam: no equality "
				^(Sign.string_of_term (sign_of thy) v)))
  | pbl_ids thy (Const(_,Type("fun",[_,Type("Tools.una",_)]))) v = [v]
  | pbl_ids thy (Const(_,Type("fun",[_,Type("Tools.unl",_)]))) v = [v]
  | pbl_ids thy (Const(_,Type("fun",[_,Type("Tools.str",_)]))) v = [v]
  | pbl_ids thy (Const(_,Type("fun",[_,Type("Tools.toreal",_)]))) v = [v] 
  | pbl_ids thy (Const(_,Type("fun",[_,Type("Tools.toreall",_)])))v = [v] 
  | pbl_ids thy (Const(_,Type("fun",[_,Type("Tools.unknown",_)])))v = [v] 
  | pbl_ids thy _ v = raise error ("pbl_ids: not implemented for "
				    ^(Sign.string_of_term (sign_of thy) v));
(*
  val t = (term_of o the o (parse thy)) "fixedValues [r=Arbfix]";
  val (d,argl) = strip_comb t;
  is_dsc d;                      (*see split_dts*)
  dest_list (d,argl);
  val (_ $ v) = t;
  is_list v;
  pbl_ids thy d v;
[Const ("List.list.Cons","[bool, bool List.list] => bool List.list") $
       (Const # $ Free # $ Const (#,#)) $ Const ("List.list.Nil","bool List..

  val (dsc,vl,_) = (split_dts o term_of o the o (parse thy)) "solveFor x";
val dsc = Const ("Descript.solveFor","RealDef.real => Tools.una") : term
val vl = Free ("x","RealDef.real") : term 

  val (dsc,id) = (split_did o term_of o the o (parse thy)) "solveFor v_";
  pbl_ids thy dsc vl;
val it = [Free ("x","RealDef.real")] : term list
   
  val (dsc,vl,_) = (split_dts o term_of o the o(parse thy))
		       "errorBound (eps=#0)";
  val (dsc,id) = (split_did o term_of o the o(parse thy)) "errorBound err_";
  pbl_ids thy dsc vl;
val it = [Free ("#0","RealDef.real"),Free ("eps","RealDef.real")] : term list     *)

(*. given an already input itm, ((14.9.01: no difference to pbl_ids jet!!))
    make the value in a problem-env according to description-type .*)
(*28.8.01: .nam and .una impl. properly, others copied .. TODO*)
fun pbl_ids' (Const(_,Type("fun",[_,Type("Tools.nam",_)]))) vs =
    (case vs of 
	 [] => raise error ("pbl_ids' Tools.nam called with []")
       | [t] => (case t of  (*eg. eps=#0*)
		     (Const ("op =",_) $ l $ r) => [r,l]
		   | _ => raise error ("pbl_ids' Tools.nam: no equality "
				       ^(Sign.string_of_term (sign_of thy) t)))
       | vs' => vs (*14.9.01: ???TODO *))
  | pbl_ids' (Const(_,Type("fun",[_,Type("Tools.una",_)]))) vs = vs
  | pbl_ids' (Const(_,Type("fun",[_,Type("Tools.unl",_)]))) vs = vs
  | pbl_ids' (Const(_,Type("fun",[_,Type("Tools.str",_)]))) vs = vs
  | pbl_ids' (Const(_,Type("fun",[_,Type("Tools.toreal",_)]))) vs = vs 
  | pbl_ids' (Const(_,Type("fun",[_,Type("Tools.toreall",_)])))vs = vs 
  | pbl_ids' (Const(_,Type("fun",[_,Type("Tools.unknown",_)])))vs = vs 
  | pbl_ids'  _ vs = 
    raise error ("pbl_ids': not implemented for "
		 ^(terms2str vs));

(*
@@@@@ v
*)






(*14.9.01: not used after putting values for penv into itm_*)
fun upd_penv thy penv dsc (id, vl) =
  overwrite (penv, (id, pbl_ids thy dsc vl));
(* 
  val penv = [];
  val (dsc,vl) = (split_did o term_of o the o (parse thy)) "solveFor x";
  val (dsc,id) = (split_did o term_of o the o (parse thy)) "solveFor v_";
  val penv = upd_penv thy penv dsc (id, vl);
[(Free ("v_","RealDef.real"),
  [Const (#,#) $ Free (#,#) $ Free ("#0","RealDef.real")])]
: (term * term list) list                                                     

  val (dsc,vl) = (split_did o term_of o the o(parse thy))"errorBound (eps=#0)";
  val (dsc,id) = (split_did o term_of o the o(parse thy))"errorBound err_";
  upd_penv thy penv dsc (id, vl);
[(Free ("v_","RealDef.real"),
  [Const (#,#) $ Free (#,#) $ Free ("#0","RealDef.real")]),
 (Free ("err_","bool"),
  [Free ("#0","RealDef.real"),Free ("eps","RealDef.real")])]
: (term * term list) list    ^.........!!!!
*)


fun upd thy envv dsc (id, vl) i =
    let val penv = case assoc (envv, i) of
		       Some e => e
		     | None => [];
        val penv' = upd_penv thy penv dsc (id, vl);
    in (i, penv') end;
(*
  val i = 2;
  val envv = [(1,[]:penv),(2,[]:penv),(3,[]:penv)]:envv;
  val (dsc,vl) = (split_did o term_of o the o(parse thy))"boundVariable b";
  val (dsc,id) = (split_did o term_of o the o(parse thy))"boundVariable v_";
  upd thy envv dsc (id, vl) i;
val it = (2,[(Free ("v_","RealDef.real"),[Free ("b","RealDef.real")])])
  : int * (term * term list) list*)


(*14.9.01: not used after putting pre-penv into itm_*)
fun upd_envv thy (envv:envv) (vats:vats) dsc id vl  =
    let val vats = if length vats = 0 
		   then (*unknown id to _all_ variants*)
		       if length envv = 0 then [1]
		       else (intsto o length) envv 
		   else vats
	fun isin vats (i,_) = i mem vats;
	val envs_notin_vat = filter_out (isin vats) envv;
    in ((map (upd thy envv dsc (id, vl)) vats) @ envs_notin_vat):envv end;
(*
  val envv = [(1,[]:penv),(2,[]:penv),(3,[]:penv)]:envv;
 
  val vats = [2] 
  val (dsc,vl) = (split_did o term_of o the o(parse thy))"boundVariable b";
  val (dsc,id) = (split_did o term_of o the o(parse thy))"boundVariable v_";
  val envv = upd_envv thy envv vats dsc id vl;
val envv = [(2,[(Free ("v_","RealDef.real"),[Free ("b","RealDef.real")])])]
  : (int * (term * term list) list) list

  val vats = [1,2,3];
  val (dsc,vl) = (split_did o term_of o the o(parse thy))"maximum A";
  val (dsc,id) = (split_did o term_of o the o(parse thy))"maximum m_";
  upd_envv thy envv vats dsc id vl;
[(1,[(Free ("m_","bool"),[Free ("A","bool")])]),
 (2,
  [(Free ("v_","RealDef.real"),[Free ("b","RealDef.real")]),
   (Free ("m_","bool"),[Free ("A","bool")])]),
 (3,[(Free ("m_","bool"),[Free ("A","bool")])])]
: (int * (term * term list) list) list


  val env = []:envv;
  val (d,ts) = (split_dts o term_of o the o (parse thy))
		   "fixedValues [r=Arbfix]";
  val (_,id) = (split_did o term_of o the o (parse thy))"fixedValues fix_";
  val vats = [1,2,3];
  val env = upd_envv thy env vats d id (mkval ts);
*)

(*. update envv by folding from a list of arguments .*)
fun upds_envv thy envv [] = envv
  | upds_envv thy envv ((vs, dsc, id, vl)::ps) = 
    upds_envv thy (upd_envv thy envv vs dsc id vl) ps;
(* eval test-maximum.sml until Specify_Method ...
  val PblObj{probl=(_,pbl),origin=(_,(_,_,mI)),...} = get_obj I pt [];
  val met = (#ppc o get_met) mI;

  val envv = [];
  val eargs = flat eargs;
  val (vs, dsc, id, vl) = hd eargs;
  val envv = upds_envv thy envv [(vs, dsc, id, vl)];

  val (vs, dsc, id, vl) = hd (tl eargs);
  val envv = upds_envv thy envv [(vs, dsc, id, vl)];

  val (vs, dsc, id, vl) = hd (tl (tl eargs));
  val envv = upds_envv thy envv [(vs, dsc, id, vl)];

  val (vs, dsc, id, vl) = hd (tl (tl (tl eargs)));
  val envv = upds_envv thy envv [(vs, dsc, id, vl)];
[(1,
  [(Free ("fix_","bool List.list"),[Const (#,#),Free (#,#)]),
   (Free ("m_","bool"),[Free (#,#)]),
   (Free ("vs_","bool List.list"),[# $ # $ Const #]),
   (Free ("rs_","bool List.list"),[# $ # $ (# $ #)])]),
 (2,
  [(Free ("fix_","bool List.list"),[Const (#,#),Free (#,#)]),
   (Free ("m_","bool"),[Free (#,#)]),
   (Free ("vs_","bool List.list"),[# $ # $ Const #]),
   (Free ("rs_","bool List.list"),[# $ # $ (# $ #)])]),
 (3,
  [(Free ("fix_","bool List.list"),[Const (#,#),Free (#,#)]),
   (Free ("m_","bool"),[Free (#,#)]),
   (Free ("vs_","bool List.list"),[# $ # $ Const #])])] : envv *)


datatype item = 
    Correct of cterm'
  | SyntaxE of string
  | TypeE   of string
  | False   of cterm'
  | Incompl of cterm'
  | Superfl of string
  | Missing of cterm';
fun item2str (Correct  s) ="Correct "^s
  | item2str (SyntaxE  s) ="SyntaxE "^s
  | item2str (TypeE    s) ="TypeE "^s
  | item2str (False    s) ="False "^s
  | item2str (Incompl  s) ="Incompl "^s
  | item2str (Superfl  s) ="Superfl "^s
  | item2str (Missing  s) ="Missing "^s;
fun init_item str = SyntaxE str;




type 'a ppc = 
    {Given : 'a list,
     Where: 'a list,
     Find  : 'a list,
     With : 'a list,
     Relate: 'a list};
fun ppc2str {Given=Given,Where=Where,Find=Find,With=With,Relate=Relate}=
    ("{Given =" ^ (strs2str Given ) ^
     ",Where=" ^ (strs2str Where) ^
     ",Find  =" ^ (strs2str Find  ) ^
     ",With =" ^ (strs2str With ) ^
     ",Relate=" ^ (strs2str Relate) ^ "}");




fun item_ppc ({Given = gi,Where= wh,
		 Find = fi,With = wi,Relate= re}: string ppc) =
  {Given = map init_item gi,Where= map init_item wh,
   Find = map init_item fi,With = map init_item wi,
   Relate= map init_item re}:item ppc;
fun itemppc2str ({Given=Given,Where=Where,
		 Find=Find,With=With,Relate=Relate}:item ppc)=
    ("{Given =" ^ ((strs2str' o (map item2str))	 Given ) ^
     ",Where=" ^ ((strs2str' o (map item2str))	 Where) ^
     ",Find  =" ^ ((strs2str' o (map item2str))	 Find  ) ^
     ",With =" ^ ((strs2str' o (map item2str))	 With ) ^
     ",Relate=" ^ ((strs2str' o (map item2str))	 Relate) ^ "}");

fun de_item (Correct x) = x
  | de_item (SyntaxE x) = x
  | de_item (TypeE   x) = x
  | de_item (False   x) = x
  | de_item (Incompl x) = x
  | de_item (Superfl x) = x
  | de_item (Missing x) = x;
val empty_ppc ={Given = [],
		Where= [],
		Find  = [], 
		With = [],
		Relate= []}:item ppc;
val empty_ppc_ct' ={Given = [],
		Where = [],
		Find  = [], 
		With  = [],
		Relate= []}:cterm' ppc;


datatype match = 
  Matches of pblID * item ppc
| NoMatch of pblID * item ppc;
fun match2str (Matches (pI, ppc)) = 
    "Matches ("^(strs2str pI)^", "^(itemppc2str ppc)^")"
  | match2str(NoMatch (pI, ppc)) = 
    "NoMatch ("^(strs2str pI)^", "^(itemppc2str ppc)^")";
fun matchs2str ms = (strs2str o (map match2str)) ms;
fun pblID_of_match (Matches (pI,_)) = pI
  | pblID_of_match (NoMatch (pI,_)) = pI;


(*. the refined pbt is the last_element Matches in the list .*)
fun is_matches (Matches _) = true
  | is_matches _ = false;
fun matches_pblID (Matches (pI,_)) = pI;
fun refined ms = ((matches_pblID o the o (find_first is_matches) o rev) ms)
    handle _ => []:pblID;

fun ts_in (Cor ((_,ts),_)) = ts
  | ts_in (Syn  (c)) = []
  | ts_in (Typ  (c)) = []
  | ts_in (Inc ((_,ts),_)) = ts
  | ts_in (Sup (_,ts)) = ts
  | ts_in (Mis _) = [];
fun all_ts_in itm_s = (flat o (map ts_in)) itm_s;
val unique = (term_of o the o (parse Real.thy)) "UnIqE_tErM";
fun d_in (Cor ((d,_),_)) = d
  | d_in (Syn  (c)) = (writeln("*** d_in: Syn ("^c^")"); unique)
  | d_in (Typ  (c)) = (writeln("*** d_in: Syn ("^c^")"); unique)
  | d_in (Inc ((d,_),_)) = d
  | d_in (Sup (d,_)) = d
  | d_in (Mis (d,_)) = d;



(* val pre = t;
   (eval_true' "Isac.thy" "eval_rls" pre) handle e => print_exn e;
   *)

(*. check a predicate and make it an item .*)
(* val pre::_ = pres';
   *)
fun chkpre2item prls pre =
    if eval_true (assoc_thy "Isac.thy") (*for Pattern.match   *)
		 [pre] prls             (*pre parsed, prls.thy*)
    then (true , Correct (term2str pre))
    else (false , False (term2str pre));

(*. check preconditions, make them items, return true for all true .*)
fun check_preconds' _ [] _ _ = ([], true)
(* val pres = (#where_ o get_pbt) pI'; val mvat = max_vt pbl;

   val (pres,pbl)=(pre,itms);
   *)
  | check_preconds' prls pres pbl mvat =
    let val env = mk_env pbl;
        val pres' = map (subst_atomic env) pres;
	val pres'' = map (chkpre2item prls) pres';
    in (map snd pres'', foldl and_ (true, map fst pres'')) end;
(*
 val [t] = pres';
 term2str t;
 chkpre2item t;
 *)


fun check_preconds thy prls pres pbl = 
    check_preconds' prls pres pbl (max_vt pbl);
(* run test-root-equ-sml until nxt=Add_Find "solutions L")...

  val ppp = hd pres';
  val ppp = (term_of o the o (parse thy)) "matches (a=b) (x=#0)";

  eval_matches "" "" ppp thy;
  eval_true' "Isac.thy" "eval_rls" ppp;

*)

(*----------------------------24.3.02: done too much-----
(**. copy the already input items from probl to meth (in PblObj):
     for each item in met search the related one in pbl,
     items not found in probl are (1) inserted as 'untouched' (0,...),
     and (2) completed from oris (via max_vt)  
    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ "uberkomplett 21.2.02 ------------ .**)
(* val (pbl, met) = (itms, ppc);
   *)
fun copy_pbl thy oris pbl met =
  let val vt = max_vt pbl;
      fun vt_and_dsc d' ((i,v,f,d,ts):ori) =
	  vt mem v andalso d'= d
      fun cpy its [] (f, (d, id)) = 
	  if length its = 0        (*no dsc found in pbl*)
	  then case find_first (vt_and_dsc d) oris
		of Some (i,v,_,_,ts) => 
		   [(i,v,true,f, Cor ((d,ts), (id,pbl_ids' thy d ts)))]
		 | None => [(0,[],false,f,Mis (d, id))]
	  else its	       
	| cpy its ((it as (i, vs, b, f, itm_))::itms) (pb as (x, (d, id))) =
	  if d = d_in itm_ andalso i<>0 (*already touched by user*)
	  then cpy (its @ [it]) itms pb else cpy its itms pb;	  
  in ((flat o (map (cpy [] pbl))) met):itm list end;


(**. copy the already input items from probl to meth (in PblObj):
     for each item in met search the related one in pbl,
     items not found in probl are inserted as 'untouched' (0,...)
    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ "uberkomplett 21.2.02 ------------ .**)
(* val (pbl, met) = (itms, ppc);
   *)
fun copy_pbl (pbl:itm list) met =
  let fun cpy its [] (f, (d, id)) = 
	  if length its = 0        (*no dsc found in pbl*)
	  then [(0,[],false,f,Mis (d, id))]
	  else its	       
	| cpy its ((it as (i, vs, b, f, itm_))::itms) (pb as (x, (d, id))) =
	  if d = d_in itm_ andalso i<>0 (*already touched by user*)
	  then cpy (its @ [it]) itms pb else cpy its itms pb;	  
  in ((flat o (map (cpy [] pbl))) met):itm list end;


(**. copy the already input items from probl to meth (in PblObj):
     for each item in met search the related one in pbl    
     (missing items are requested by nxt_spec)                .**)
(* val (pbl, met) = (itms, ppc);
   *)
fun copy_pbl (pbl:itm list) met =
  let fun cpy its [] (f, (d, id)) = its
	| cpy its ((it as (i, vs, b, f, itm_))::itms) (pb as (x, (d, id))) =
	  if d = d_in itm_ andalso i<>0 (*already touched by user*)
	  then cpy (its @ [it]) itms pb 
	  else cpy its itms pb;	  
  in ((flat o (map (cpy [] pbl))) met):itm list end;

(*. copy pbt to met (in Specify_Method)
    ALL pbt. (1) dsc(pbt) notmem dsc(pbls) =>
             (2) filter (dsc(pbt) = dsc(oris)) oris; -> newitms;
    (3) pbt @ newitms                                          .*)
(* val (pbl, met) = (itms, pbt);
   *)
fun copy_pbl (pbl:itm list) met oris =
  let fun eqdsc_pbt_itm ((_,(d,_))) ((_,_,_,_,itm_):itm) = d = d_in itm_;
      fun notmem pbl pbt1 = case find_first (eqdsc_pbt_itm pbt1) pbl of
				Some _ => false | None => true;
 (*1*)val mis = ((map (cons2 (fst, fst o snd))) o (filter (notmem pbl))) met;

      fun eqdsc_ori d ((_,_,_,d',_):ori) = d = d';
      fun ori2itmMis f ((i,v,_,d,ts):ori) = (i,v,false,f,Mis (d,ts)):itm;
      fun oris2itms oris mis1 = ((map (ori2itmMis (fst mis1)))
				 o (filter ((eqdsc_ori o snd) mis1))) oris;
      val news = (flat o (map (oris2itms oris))) mis;
  in pbl @ news end;
 ----------------------------24.3.02: done too much-----*)






(* ---------------------------------------------NOT UPTODATE !!! 4.9.01
   eval test-maximum.sml until Specify_Method ...
   val PblObj{probl=(_,pbl),origin=(_,(_,_,mI)),...} = get_obj I pt [];
   val met = (#ppc o get_met) mI;
   val (m::_) = met;
   cpy [] pbl m;
[((1,[1,2,3],true,"#Given",Cor ((Const #,[#]),[])),
  [([1,2,3],Const ("Descript.fixedValues","bool List.list => Tools.nam"),
    Free ("fix_","bool List.list"),Const # $ Free # $ Const (#,#))])]
: (itm * (vats * term * term * term) list) list                               

   upds_envv thy [] (flat eargs);
[(1,
  [(Free ("fix_","bool List.list"),[Const (#,#),Free (#,#)]),
   (Free ("m_","bool"),[Free (#,#)]),
   (Free ("vs_","bool List.list"),[# $ # $ (# $ #)]),
   (Free ("rs_","bool List.list"),[# $ # $ (# $ #)])]),
 (2,
  [(Free ("fix_","bool List.list"),[Const (#,#),Free (#,#)]),
   (Free ("m_","bool"),[Free (#,#)]),
   (Free ("vs_","bool List.list"),[# $ # $ (# $ #)]),
   (Free ("rs_","bool List.list"),[# $ # $ (# $ #)])]),
 (3,
  [(Free ("fix_","bool List.list"),[Const (#,#),Free (#,#)]),
   (Free ("m_","bool"),[Free (#,#)]),
   (Free ("vs_","bool List.list"),[# $ # $ (# $ #)])])] : envv                
 *)



