(* use_thy_only"Isa99/ListG";
   use_thy"Isa99/ListG";
   W.N. 8.01
   attaches identifiers to definition of listfuns,
   for storing them in list_rls
*)

ListG = Real +

consts (*'nat' in List.thy replaced by 'real'*)
  length_       :: 'a list => real
(*-----
  nth_          :: ['a list, real] => 'a
  list_update_  :: 'a list => real => 'a => 'a list
  take_, drop_  :: [real, 'a list] => 'a list
  upt_          :: real => real => real list      ("(1[_../_'(])")
  replicate_    :: real => 'a => 'a list
-----*)
  Length   :: 'a list => real        (*DONT USE!!! 18.9.02:check testexpls*)
  Nth      :: [real, 'a list] => 'a  (*take nth_ instead, DONT USE!!!*)
  del      :: "['a list, 'a] => 'a list"

primrec
  length_Nil_	"length_ [] = 0"     (*length: 'a list => nat*)
  length_Cons_	"length_ (x#xs) = 1 + length_ xs"

  primrec
  del_base "del [] x = []"
  del_rec  "del (y#ys) x = (if x = y then ys else y#(del ys x))"

constdefs
  
  list_diff :: "['a list, 'a list] => 'a list"         (* as -- bs *)
              ("(_ --/ _)" [66, 66] 65) "a -- b == foldl del a b"
  
consts

  DropWhile :: "('a => bool) => 'a list => 'a list" (*DONT USE!!!*)
  primrec
  DropWhile_base "DropWhile P [] = []"
  DropWhile_rec  "DropWhile P (x#xs) = (if P x then DropWhile P xs else x#xs)"

(*-----
primrec
  hdNil	"hd([]) = arbitrary"
  hdCons	"hd(x#xs) = x"
primrec
  tlNil	"tl([]) = []"
  tlrCons	"tl(x#xs) = xs"
primrec
  lastNil	"last [] = arbitrary"
  lastCons	"last(x#xs) = (if xs=[] then x else last xs)"
primrec
  butlastNil	"butlast [] = []"
  butlastCons	"butlast(x#xs) = (if xs=[] then [] else x#butlast xs)"
primrec
  memNil	"x mem [] = False"
  memCons	"x mem (y#ys) = (if y=x then True else x mem ys)"
primrec
  setNil	"set [] = {}"
  setCons	"set (x#xs) = insert x (set xs)"
primrec
  list_all_Nil  "list_all P [] = True"
  list_all_Cons "list_all P (x#xs) = (P(x) & list_all P xs)"
primrec
  mapNil	"map f [] = []"
  mapCons	"map f (x#xs) = f(x)#map f xs"
primrec
  append_Nil  "[]    @ys = ys"
  append_Cons "(x#xs)@ys = x#(xs@ys)"
primrec
  revNil	"rev([]) = []"
  revCons	"rev(x#xs) = rev(xs) @ [x]"
primrec
  filterNil	"filter P [] = []"
  filterCons	"filter P (x#xs) = (if P x then x#filter P xs else filter P xs)"
primrec
  foldl_Nil  "foldl f a [] = a"
  foldl_Cons "foldl f a (x#xs) = foldl f (f a x) xs"
primrec
  concatNil	"concat([]) = []"
  concatCons	"concat(x#xs) = x @ concat(xs)"
primrec
  drop_Nil  "drop n [] = []"
  drop_Cons "drop n (x#xs) = (case n of 0 => x#xs | Suc(m) => drop m xs)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for n=0 / n=Suc k*)
primrec
  take_Nil  "take'_ n [] = []"
  take_Cons "take'_ n (x#xs) = (case n of 0 => [] | Suc(m) => x # take'_ m xs)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for n=0 / n=Suc k*)
primrec 
  nth_Cons  "(x#xs)!n = (case n of 0 => x | (Suc k) => xs!k)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for n=0 / n=Suc k*)
(*
primrec
 "    [][i:=v] = []"
 "(x#xs)[i:=v] = (case i of 0     => v # xs 
			  | Suc j => x # xs[j:=v])"
*)
primrec
  takeWhileNil	"takeWhile P [] = []"
  takeWhileCons	"takeWhile P (x#xs) = (if P x then x#takeWhile P xs else [])"
primrec
  dropWhileNil	"dropWhile P [] = []"
  dropWhileCons	"dropWhile P (x#xs) = (if P x then dropWhile P xs else x#xs)"
primrec
  zipNil	"zip xs []     = []"
  zipCons	"zip xs (y#ys) = (case xs of [] => [] | z#zs => (z,y)#zip zs ys)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for xs=[] / xs=z#zs *)
(*
primrec
  "[i..0(] = []"
  "[i..(Suc j)(] = (if i <= j then [i..j(] @ [j] else [])"
*)
primrec
  nodupsNil	"nodups []     = True"
  nodupsCons	"nodups (x#xs) = (x ~: set xs & nodups xs)"
primrec
  remdupsNil	"remdups [] = []"
  remdupsCons	"remdups (x#xs) = (if x : set xs then remdups xs else x # remdups xs)"
primrec
  replicate_0   "replicate  0      x = []"
  replicate_Suc "replicate (Suc n) x = x # replicate n x"

-----*)
end