(* tools which depend on Script.thy and thus are not in term_G.sml
   *)

fun is_reall_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("real",[])]),_]))) = true
  | is_reall_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("real",[])]),_])) $ t) = true
  | is_reall_dsc _ = false;
fun is_booll_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("bool",[])]),_]))) = true
  | is_booll_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("bool",[])]),_])) $ t) = true
  | is_booll_dsc _ = false;
(*
> val t = (term_of o the o (parse thy)) "relations";
> atomtyp (type_of t);
*** Type (fun,[
***   Type (List.list,[
***     Type (bool,[])
***     ]
***   Type (Tools.una,[])
***   ]
> is_booll_dsc t;
val it = true : bool
> is_reall_dsc t;
val it = false : bool
*)

fun is_list_dsc (Const(_,Type("fun",[Type("List.list",_),_]))) = true
  | is_list_dsc (Const(_,Type("fun",[Type("List.list",_),
				     _])) $ t) = true
  | is_list_dsc _ = false;
(*
> val t = (term_of o the o (parse thy))
          "additional_relations [a=b,c=(d::real)]";
> is_list_dsc t;
val it = true : bool
> is_list_dsc (head_of t);
val it = true : bool

> val t = (term_of o the o (parse thy))"max_relation (A=#2*a*b-a^^^#2)";
> is_list_dsc t;
val it = false : bool
> is_list_dsc (head_of t);
val it = false : bool     
> val t = (term_of o the o (parse thy)) "testdscforlist";
> is_list_dsc (head_of t);
val it = true : bool
*)


fun is_dscforlist (Const(_,Type("fun",[_,
			   Type("Tools.unl",_)]))) = true
  | is_dscforlist _ = false;
(*
> val t = (term_of o the o (parse thy)) "testdscforlist";
> is_dscforlist t;
val it = true : bool
> val t = (term_of o the o (parse thy)) "maximum";
> is_dscforlist t;
val it = false : bool
*)

fun is_dsc (Const(_,Type("fun",[_,Type("Tools.nam",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.una",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.unl",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.str",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.toreal",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.toreall",_)])))= true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.unknown",_)])))= true
  | is_dsc _ = false;
(*
> val t = (term_of o the o (parse thy)) "maximum";
> is_dsc t;
val it = true : bool
> val t = (term_of o the o (parse thy)) "testdscforlist";
> is_dsc t;
val it = true : bool

> val t = (head_of o term_of o the o (parse thy)) "maximum A";
> is_dsc t;
val it = true : bool
> val t = (head_of o term_of o the o (parse thy)) 
  "fixed_values [R=(R::real)]";
> is_dsc t;
val it = true : bool
*)


(*make the term 'Subproblem (domID, pblID)' to a formula for frontend;
  needs to be here after def. Subproblem in Script.thy*)
val t as (subpbl_t $ (pair_t $ Free (domID,_) $ pblID)) = 
    (term_of o the o (parse Script.thy)) 
	"Subproblem (Isac,[equation,univar])";
val Free (_, ID_type) = (term_of o the o (parse Script.thy)) "x::ID";

fun subpbl domID pblID =
    subpbl_t $ (pair_t $ Free (domID,ID_type) $ 
	(((list2isalist ID_type) o (map (mk_free ID_type))) pblID));
(*> subpbl "Isac" ["equation","univar"] = t;
val it = true : bool *)

(*6.8.02 ...*)

