(* use"Isa02/term_G.sml";
   WN.22.10.99
   functions closely related to original isabelle-98-1 functions,
   distinguished by ..._G
   use"term_G.sml";
*)

(*
> cterm_of (sign_of thy) a_term;
val it = "empty" : cterm        *)



fun match thy t pat =
    (snd (Pattern.match (Sign.tsig_of (sign_of thy)) (pat, t)))
    handle _ => [];
fun matches thy t pat = if match thy t pat = [] then false else true;
(*
> val t = (term_of o the o (parse thy)) "3 * x^^^2 = 1";
> val pat = (free2var o term_of o the o (parse thy)) "a * b^^^2 = c";
            !^^^^^^^^!... necessary for Pattern.match
> val insts = Pattern.match (Sign.tsig_of (sign_of thy)) (pat, t);
   val insts =
  ([],
   [(("c",0),Free ("1","RealDef.real")),(("b",0),Free ("x","RealDef.real")),
    (("a",0),Free ("3","RealDef.real"))])
  : (indexname * typ) list * (indexname * term) list*)


fun idt str 0 = " "
  | idt str n = str ^ idt str (n-1);
fun indent 0 = ""
  | indent n = ". " ^ indent(n-1);
(*
  datatype typ =
    Type  of string * typ list |
    TFree of string * sort |
    TVar  of indexname * sort
> ("wer",1):indexname;
> ["wer"]:sort;
*)
fun atomtyp t =
  let
    fun ato n (Type (s,[])) = 
      ("\n*** "^indent n^"Type ("^s^",[])")
      | ato n (Type (s,Ts)) =
      ("\n*** "^indent n^"Type ("^s^",["^ atol (n+1) Ts)

      | ato n (TFree (s,sort)) =
      ("\n*** "^indent n^"TFree ("^s^",["^ strs2str' sort)

      | ato n (TVar ((s,i),sort)) =
      ("\n*** "^indent n^"TVar (("^s^","^ 
       string_of_int i ^ strs2str' sort)
    and atol n [] = 
      ("\n*** "^indent n^"]")
      | atol n (T::Ts) = (ato n T ^ atol n Ts)
in print (ato 0 t ^ "\n") end;

(*
> val T = (type_of o term_of o the o (parse thy)) "a::[real,int] => nat";
> atomtyp T;
*** Type (fun,[
***   Type (RealDef.real,[])
***   Type (fun,[
***     Type (IntDef.int,[])
***     Type (nat,[])
***     ]
***   ]
*)
fun atomt t =
    let fun ato (Const(a,T))     n = 
	print("\n*** "^indent n^"Const ( "^a^")")
	  | ato (Free (a,T))     n =  
	print("\n*** "^indent n^"Free ( "^a^", "^")")
	  | ato (Var ((a,ix),T)) n =
	print("\n*** "^indent n^"Var (("^a^", "^(string_of_int ix)^"), "^")")
	  | ato (Bound ix)       n = 
	print("\n*** "^indent n^"Bound "^(string_of_int ix))
	  | ato (Abs(a,T,body))  n = 
	(print("\n*** "^indent n^"Abs( "^a^",..");ato body (n+1))
	  | ato (f$t')           n = (ato f n; ato t' (n+1))
    in print"\n*** -------------"; ato t 0; print"\n" end;

fun atomty thy t =
    let fun ato (Const(a,T))     n = 
	print("\n*** "^indent n^"Const ( "^a^", "^
	      (Sign.string_of_typ (sign_of thy) T)^")")
	  | ato (Free (a,T))     n =  
	print("\n*** "^indent n^"Free ( "^a^", "^
	      (Sign.string_of_typ (sign_of thy) T)^")")
	  | ato (Var ((a,ix),T)) n =
	print("\n*** "^indent n^"Var (("^a^", "^(string_of_int ix)^"), "^
	      (Sign.string_of_typ (sign_of thy) T)^")")
	  | ato (Bound ix)       n = 
	print("\n*** "^indent n^"Bound "^(string_of_int ix))
	  | ato (Abs(a,T,body))  n = 
	(print("\n*** "^indent n^"Abs( "^a^", "^
	       (Sign.string_of_typ (sign_of thy) T)^",..");ato body (n+1))
	  | ato (f$t')           n = (ato f n; ato t' (n+1))
    in print"\n*** -------------"; ato t 0; print"\n" end;

fun term_detail2str t =
    let fun ato (Const(a,T))     n = 
	    "\n*** "^indent n^"Const ( "^a^")"
	  | ato (Free (a,T))     n =  
	    "\n*** "^indent n^"Free ( "^a^", "^")"
	  | ato (Var ((a,ix),T)) n =
	    "\n*** "^indent n^"Var (("^a^", "^string_of_int ix^"), "^")"
	  | ato (Bound ix)       n = 
	    "\n*** "^indent n^"Bound "^string_of_int ix
	  | ato (Abs(a,T,body))  n = 
	    "\n*** "^indent n^"Abs( "^a^",.."^ato body (n+1)
	  | ato (f$t')           n = ato f n^ato t' (n+1)
    in "\n*** -------------"^ato t 0^"\n" end;
fun term_str thy (Const(s,_)) = s
  | term_str thy (Free(s,_)) = s
  | term_str thy (Var((s,i),_)) = s^(string_of_int i)
  | term_str thy (Bound i) = "B."^(string_of_int i)
  | term_str thy (Abs(s,_,_)) = s
  | term_str thy t = raise error("term_str not for "^
			     (Sign.string_of_term (sign_of thy) t));



fun int_of_str str =
    let val ss = explode str
	val str' = case ss of
	   "("::s => drop_last s | _ => ss
    in case BasisLibrary.Int.fromString (implode str') of
	     SOME i => Some i
	   | NONE => None end;
(*
> int_of_str "123";
val it = Some 123 : int option                                                 > int_of_str "(-123)";
val it = Some 123 : int option                                                 > int_of_str "#123";
val it = None : int option                                                     > int_of_str "-123";
val it = Some ~123 : int option                                                *)
fun int_of_str' str = 
    case int_of_str str of
	Some i => i
      | None => raise TERM ("int_of_string: no int-string",[]);
    
fun is_numeral str = case int_of_str str of
			 Some _ => true
		       | None => false;
val is_no = is_numeral;
fun is_num (Free (s,_)) = if is_numeral s then true else false
  | is_num _ = false;
(*>
> is_num ((term_of o the o (parse thy)) "#1");
val it = true : bool
> is_num ((term_of o the o (parse thy)) "#-1");
val it = true : bool
> is_num ((term_of o the o (parse thy)) "a123");
val it = false : bool
*)

fun vars t =
  let
    fun scan vs (Const(s,T)) = vs
      | scan vs (t as Free(s,T)) = if is_no s then vs else t::vs
      | scan vs (t as Var((s,i),T)) = t::vs
      | scan vs (Bound i) = vs 
      | scan vs (Abs(s,T,t)) = scan vs t
      | scan vs (t1 $ t2) = (scan vs t1) @ (scan vs t2)
  in (distinct o (scan [])) t end;

fun vars_str t =
  let
    fun scan vs (Const(s,T)) = vs
      | scan vs (t as Free(s,T)) = if is_no s then vs else s::vs
      | scan vs (t as Var((s,i),T)) = (s^"_"^(string_of_int i))::vs
      | scan vs (Bound i) = vs 
      | scan vs (Abs(s,T,t)) = scan vs t
      | scan vs (t1 $ t2) = (scan vs t1) @ (scan vs t2)
  in (distinct o (scan [])) t end;

fun free2str (Free (s,_)) = s
  | free2str t = raise error ("free2str not for "^
			      (Sign.string_of_term (sign_of thy) t));
fun free2int (t as Free (s, _)) = (((the o int_of_str) s)
    handle _ => raise error ("free2int: "^term_detail2str t))
  | free2int t = raise error ("free2int: "^term_detail2str t);

(*27.8.01: unused*)
fun var2free (t as Const(s,T)) = t
  | var2free (t as Free(s,T)) = t
  | var2free (Var((s,i),T)) = Free(s,T)
  | var2free (t as Bound i) = t 
  | var2free (Abs(s,T,t)) = Abs(s,T,var2free t)
  | var2free (t1 $ t2) = (var2free t1) $ (var2free t2);
  
(*27.8.01: doesn't find some subterm ???!???*)
fun free2var (t as Const(s,T)) = t
  | free2var (t as Free(s,T)) = if is_no s then t else Var((s,0),T)
  | free2var (t as Var((s,i),T)) = t
  | free2var (t as Bound i) = t 
  | free2var (Abs(s,T,t)) = Abs(s,T,free2var t)
  | free2var (t1 $ t2) = (free2var t1) $ (free2var t2);
  

fun mk_listT T = Type ("List.list", [T]);
fun list_const T = 
  Const("List.list.Cons", [T, mk_listT T] ---> mk_listT T);
(*28.8.01: TODO: get type from head of list: 1 arg less!!!*)
fun list2isalist T [] = Const("List.list.Nil",mk_listT T)
  | list2isalist T (t::ts) = (list_const T) $ t $ (list2isalist T ts);
(*
> val tt = (term_of o the o (parse thy)) "R=(R::real)";
> val TT = type_of tt;
> val ss = list2isalist TT [tt,tt,tt];
> cterm_of (sign_of thy) ss;
val it = "[R = R, R = R, R = R]" : cterm  *)

fun isalist2list ls =
  let
    fun get es (Const("List.list.Cons",_) $ t $ ls) = get (t::es) ls
      | get es (Const("List.list.Nil",_)) = es
      | get _ _ = raise error "Isalist2list applied to NON-list"
  in (rev o (get [])) ls end;
(*      
> val (Some ct) = parse thy "[a=b,c=d,e=f]";
> val ces = map (cterm_of (sign_of thy)) (isalist2list (term_of ct));
val it = ["a = b","c = d","e = f"] : cterm list
*)



val prop = Type ("prop",[]);     (* ~/Diss.99/Integers-Isa/tools.sml*)
val bool = Type ("bool",[]);     (* Integ.int *)
val Trueprop = Const("Trueprop",bool-->prop);
fun mk_prop t = Trueprop $ t;
val true_as_term = Const("True",bool);
val false_as_term = Const("False",bool);
val true_as_cterm = cterm_of (sign_of thy) true_as_term;
val false_as_cterm = cterm_of (sign_of thy) false_as_term;

infixr 5 -->;                    (* /Pure/term.ML *)
infixr --->;			 (* /Pure/term.ML *)
fun S --> T = Type("fun",[S,T]); (* /Pure/term.ML *)
val op ---> = foldr (op -->);    (* /Pure/term.ML *)
fun list_implies ([], B) = B : term
  | list_implies (A::AS, B) = implies $ A $ list_implies(AS,B);(* /term.ML *)



(** substitution **)

fun match_bvs(Abs(x,_,s),Abs(y,_,t), al) =      (* = thm.ML *)
      match_bvs(s, t, if x="" orelse y="" then al
                                          else (x,y)::al)
  | match_bvs(f$s, g$t, al) = match_bvs(f,g,match_bvs(s,t,al))
  | match_bvs(_,_,al) = al;
fun ren_inst(insts,prop,pat,obj) =              (* = thm.ML *)
  let val ren = match_bvs(pat,obj,[])
      fun renAbs(Abs(x,T,b)) =
            Abs(case assoc_string(ren,x) of None => x 
	  | Some(y) => y, T, renAbs(b))
        | renAbs(f$t) = renAbs(f) $ renAbs(t)
        | renAbs(t) = t
  in subst_vars insts (if null(ren) then prop else renAbs(prop)) end;






fun dest_equals' (Const("op =",_) $ t $ u)  =  (t,u)(* logic.ML: Const("=="*)
  | dest_equals' t = raise TERM("dest_equals'", [t]);
fun is_equality (Const("op =",_) $ t $ u)  =  true  (* logic.ML: Const("=="*)
  | is_equality _ = false;
fun mk_equality (t,u) = (Const("op =",[type_of t,type_of u]--->bool) $ t $ u); 
fun is_expliceq (Const("op =",_) $ (Free _) $ u)  =  true
  | is_expliceq _ = false;
fun strip_trueprop (Const("Trueprop",_) $ t) = t
  | strip_trueprop t = t;
(*  | strip_trueprop t = raise TERM("strip_trueprop", [t]);
*)

(*.(A1==>...An==>B) goes to (A1==>...An==>).*)
fun strip_imp_prems' (Const("==>", T) $ A $ t) = 
    let fun coll_prems As (Const("==>", _) $ A $ t) = 
	    coll_prems (As $ (implies $ A)) t
	  | coll_prems As _ = Some As
    in coll_prems (implies $ A) t end
  | strip_imp_prems' _ = None;  (* logic.ML: term -> term list*)
(*
  val thm = real_mult_div_cancel1;
  val prop = (#prop o rep_thm) thm;
  atomt prop;
*** -------------
*** Const ( ==>)
*** . Const ( Trueprop)
*** . . Const ( Not)
*** . . . Const ( op =)
*** . . . . Var ((k, 0), )
*** . . . . Const ( 0)
*** . Const ( Trueprop)
*** . . Const ( op =)                                                          *** .............
  val Some t = strip_imp_prems' ((#prop o rep_thm) thm);
  atomt t;
*** -------------
*** Const ( ==>)
*** . Const ( Trueprop)
*** . . Const ( Not)
*** . . . Const ( op =)
*** . . . . Var ((k, 0), )
*** . . . . Const ( 0)

  val thm = real_le_anti_sym;
  val prop = (#prop o rep_thm) thm;
  atomt prop;
*** -------------
*** Const ( ==>)
*** . Const ( Trueprop)
*** . . Const ( op <=)
*** . . . Var ((z, 0), )
*** . . . Var ((w, 0), )
*** . Const ( ==>)
*** . . Const ( Trueprop)
*** . . . Const ( op <=)
*** . . . . Var ((w, 0), )
*** . . . . Var ((z, 0), )
*** . . Const ( Trueprop)
*** . . . Const ( op =)
*** .............
  val Some t = strip_imp_prems' ((#prop o rep_thm) thm);
  atomt t;
*** -------------
*** Const ( ==>)
*** . Const ( Trueprop)
*** . . Const ( op <=)
*** . . . Var ((z, 0), )
*** . . . Var ((w, 0), )
*** . Const ( ==>)
*** . . Const ( Trueprop)
*** . . . Const ( op <=)
*** . . . . Var ((w, 0), )
*** . . . . Var ((z, 0), )
*)

(*. (A1==>...An==>) (B) goes to (A1==>...An==>B), where B is lowest branch.*)
fun ins_concl (Const("==>", T) $ A $ t) B = implies $ A $ (ins_concl t B)
  | ins_concl (Const("==>", T) $ A    ) B = implies $ A $ B
  | ins_concl t B =  raise TERM("ins_concl", [t, B]);
(*
  val thm = real_le_anti_sym;
  val prop = (#prop o rep_thm) thm;
  val concl = Logic.strip_imp_concl prop;
  val Some prems = strip_imp_prems' prop;
  val prop' = ins_concl prems concl;
  prop = prop';
  atomt prop;
  atomt prop';
*)


fun vperm (Var _, Var _) = true  (* Pure/thm.ML *)
  | vperm (Abs (_, _, s), Abs (_, _, t)) = vperm (s, t)
  | vperm (t1 $ t2, u1 $ u2) = vperm (t1, u1) andalso vperm (t2, u2)
  | vperm (t, u) = (t = u);

fun var_perm (t, u) = (* Pure/thm.ML *)
  vperm (t, u) andalso eq_set_term (term_vars t, term_vars u);
    
(* fun decomp_simp, Pure/thm.ML *)
fun perm lhs rhs = var_perm (lhs, rhs) andalso not (lhs aconv rhs)
    andalso not (is_Var lhs);


(*---6.1.00: Isa99
fun char2int c = ord c - ord "0";

fun rev_strl2int [s]     = char2int s
  | rev_strl2int (s::ss) = char2int s + 10*(rev_strl2int ss)
  | rev_strl2int _       = raise ERROR;

 fun int_of_str str = 
  let
    fun scan ("(" :: "+" :: is) = 
          (case rev is of
	    ")" :: si => rev_strl2int si
	  | _ => raise error ("no number: "^str))
      | scan ("(" :: "-" :: is) =
	  (case rev is of
	    ")" :: si => (~1)*(rev_strl2int si)
	  | _ => raise error ("no number: "^str))
      | scan ("(" ::        is) =
	  (case rev is of
	    ")" :: si => rev_strl2int si
	  | _ => raise error ("no number: "^str))
      | scan (       "+" :: is) = (rev_strl2int o rev) is
      | scan (       "-" :: is) = (~1)*((rev_strl2int o rev) is)
      | scan (              is) = (rev_strl2int o rev) is
  in (scan o skip_blanks o explode o strip_thy) str 
    handle ERROR => raise error ("no number: "^str) end;
---*)


fun str_of_int n = 
  if n < 0 then "-"^((string_of_int o abs) n)
  else string_of_int n;
(*
> str_of_int 1;
val it = "1" : string                                                          > str_of_int ~1;
val it = "-1" : string
*)


fun power b 0 = 1
  | power b n = 
  if n>0 then b*(power b (n-1))
  else raise error ("power "^(str_of_int b)^" "^(str_of_int n));
(*
> power 2 3;
val it = 8 : int
> power ~2 3;
val it = ~8 : int
> power ~3 2;
val it = 9 : int
> power 3 ~2;
*)
fun gcd 0 b = b
  | gcd a b = if a < b then gcd (b mod a) a
	      else gcd (a mod b) b;
fun sign n = if n < 0 then ~1
	     else if n = 0 then 0 else 1;
fun sign2 n1 n2 = (sign n1) * (sign n2);

infix dvd;
fun d dvd n = n mod d = 0;

fun divisors n =
  let fun pdiv ds d n = 
    if d=n then d::ds
    else if d dvd n then pdiv (d::ds) d (n div d)
	 else pdiv ds (d+1) n
  in pdiv [] 2 n end;

divisors 30;
divisors 32;
divisors 60;
divisors 11;

fun doubles ds = (* ds is ordered *)
  let fun dbls ds [] = ds
	| dbls ds [i] = ds
	| dbls ds (i::i'::is) = if i=i' then dbls (i::ds) is
				else dbls ds (i'::is)
  in dbls [] ds end;
(*> doubles [2,3,4];
val it = [] : int list
> doubles [2,3,3,5,5,7];
val it = [5,3] : int list*)

fun squfact 1 = 1
  | squfact n = foldl op* (1, (doubles o divisors) n);
(*> squfact 30;
val it = 1 : int
> squfact 32;
val it = 4 : int
> squfact 60;
val it = 2 : int
> squfact 11;
val it = 1 : int*)


fun dest_type (Type(T,[])) = T
  | dest_type T = 
    (atomtyp T;
     raise error ("... dest_type: not impl. for this type"));

fun term_of_num ntyp n = Free (str_of_int n, ntyp);

fun pairT T1 T2 = Type ("*", [T1, T2]);
(*> val t = str2term "(1,2)";
> type_of t = pairT HOLogic.realT HOLogic.realT;
val it = true : bool
*)
fun PairT T1 T2 = ([T1, T2] ---> Type ("*", [T1, T2]));
(*> val t = str2term "(1,2)";
> val Const ("Pair",pT) $ _ $ _ = t;
> pT = PairT HOLogic.realT HOLogic.realT;
val it = true : bool
*)
fun pairt t1 t2 =
    Const ("Pair", PairT (type_of t1) (type_of t2)) $ t1 $ t2;
(*> val t = str2term "(1,2)";
> val (t1, t2) = (str2term "1", str2term "2");
> t = pairt t1 t2;
val it = true : bool*)


fun num_of_term (t as Free (s,_)) = 
    (case int_of_str s of
	 Some s' => s'
       | None => raise error ("num_of_term not for "^
			      (Sign.string_of_term (sign_of thy) t)))
  | num_of_term t = raise error ("num_of_term not for "^
				 (Sign.string_of_term (sign_of thy) t));

fun mk_factroot op_(*=thy.sqrt*) T fact root = 
  Const ("op *", [T, T] ---> T) $ (term_of_num T fact) $
  (Const (op_, T --> T) $ term_of_num T root);
(*
val T =  (type_of o term_of o the) (parse thy "#12::real");
val t = mk_factroot "SqRoot.sqrt" T 2 3;
cterm_of (sign_of thy) t;
val it = "#2 * sqrt #3 " : cterm
*)
fun var_op_num v op_ optype ntyp n =
  Const (op_, optype) $ v $ 
   Free (str_of_int  n, ntyp);

fun num_op_var v op_ optype ntyp n =
  Const (op_,optype) $  
   Free (str_of_int n, ntyp) $ v;

fun num_op_num T1 T2 (op_,Top) n1 n2 = 
  Const (op_,Top) $ 
  Free (str_of_int n1, T1) $ Free (str_of_int n2, T2);
(*
> val t = num_op_num "Int" 3 4;
> atomty thy t;
> string_of_cterm (cterm_of (sign_of thy) t);
*)

fun const_in str (Const _) = false
  | const_in str (Free (s,_)) = if strip_thy s = str then true else false
  | const_in str (Bound _) = false
  | const_in str (Var _) = false
  | const_in str (Abs (_,_,body)) = const_in str body
  | const_in str (f$u) = const_in str f orelse const_in str u;
(*
> val t = (term_of o the o (parse thy)) "6 + 5 * sqrt 4 + 3";
> const_in "sqrt" t;
val it = true : bool
> val t = (term_of o the o (parse thy)) "6 + 5 * 4 + 3";
> const_in "sqrt" t;
val it = false : bool
*)

(*used for calculating built in binary operations in Isabelle2002->Float.ML
fun calc "op +"  (n1, n2) = n1+n2
  | calc "op -"  (n1, n2) = n1-n2
  | calc "op *"  (n1, n2) = n1*n2
  | calc "HOL.divide"(n1, n2) = n1 div n2
  | calc "Atools.pow"(n1, n2) = power n1 n2
  | calc op_ _ = raise error ("calc: operator = "^op_^" not defined");-----*)
fun calc_equ "op <"  (n1, n2) = n1 < n2
  | calc_equ "op <=" (n1, n2) = n1 <= n2
  | calc_equ op_ _ = 
  raise error ("calc_equ: operator = "^op_^" not defined");
fun sqrt (n:int) = if n < 0 then 0
    (*FIXME ~~~*)  else (trunc o Math.sqrt o BasisLibrary.Real.fromInt) n;

fun mk_thmid thmid op_ n1 n2 = 
  thmid ^ (strip_thy n1) ^ "_" ^ (strip_thy n2);

fun dest_binop_typ (Type("fun",[range,Type("fun",[arg2,arg1])])) =
  (arg1,arg2,range)
  | dest_binop_typ _ = raise error "dest_binop_typ: not binary";
(* -----
> val t = (term_of o the o (parse thy)) "#3^#4";
> val hT = type_of (head_of t);
> dest_binop_typ hT;
val it = ("'a","nat","'a") : typ * typ * typ
 ----- *)


(** transform binary numerals into 
    Free("#numeral", Type ("polymorph",[])) **)

(*5.1.00.: apply_trans in /Pure/Syntax/printer.ML
  to numeral_tr' in HOL/Tools/numeral_syntax.ML failed:
fun pretty ... = 
    val trans = apply_trans "print ast translation";
    and combT (tup as (c, a, args, p)) =
      in
        (case token_trans a args of     (*try token translation function*)
          Some (s, len) => [Pretty.strlen_real s len]
        | None =>			(*try print translation functions*)
            astT (trans a (trf a) args, p) handle Match => prnt ([], tabs))

 Error: unbound type constructor: ast in path Ast.ast
*)

fun app_num_tr'1 (Const("0",T)) = Free("0",T)
  | app_num_tr'1 (Const("1",T)) = Free("1",T)
(*| app_num_tr'1 (t as Const("uminus",_) $ Free(s,T)) = 
    (case int_of_str s of Some i => 
			  if i > 0 then Free("-"^s,T) else Free(s,T)
		       | None => t)
  | app_num_tr'1 (t as Const(s,T)) = t
*)| app_num_tr'1 (Const("Numeral.number_of",Type ("fun", [_, T])) $ t) = 
    Free(NumeralSyntax.dest_bin_str t, T)
(*| app_num_tr'1 (t as Free(s,T)) = t
  | app_num_tr'1 (t as Var(n,T)) = t
  | app_num_tr'1 (t as Bound i) = t*)
  | app_num_tr'1 (Abs(s,T,body)) = Abs(s,T, app_num_tr'1 body)
  | app_num_tr'1 (t1 $ t2) = (app_num_tr'1 t1) $ (app_num_tr'1 t2)
  | app_num_tr'1 t = t;
(*.to be used immediately before evaluation of numerals.*)
fun(*app_num_tr'2 (Const("0",T)) = Free("0",T)
  | app_num_tr'2 (Const("1",T)) = Free("1",T)
  |*)app_num_tr'2 (t as Const("uminus",_) $ Free(s,T)) = 
    (case int_of_str s of Some i => 
			  if i > 0 then Free("-"^s,T) else Free(s,T)
		       | None => t)
(*| app_num_tr'2 (t as Const(s,T)) = t
  | app_num_tr'2 (Const("Numeral.number_of",Type ("fun", [_, T])) $ t) = 
    Free(NumeralSyntax.dest_bin_str t, T)
  | app_num_tr'2 (t as Free(s,T)) = t
  | app_num_tr'2 (t as Var(n,T)) = t
  | app_num_tr'2 (t as Bound i) = t
*)| app_num_tr'2 (Abs(s,T,body)) = Abs(s,T, app_num_tr'2 body)
  | app_num_tr'2 (t1 $ t2) = (app_num_tr'2 t1) $ (app_num_tr'2 t2)
  | app_num_tr'2 t = t;

fun num_str thm =
  let 
    val {sign_ref = sign_ref, der = der, maxidx = maxidx,
	    shyps = shyps, hyps = hyps, prop = prop} = rep_thm_G thm;
    val prop' = app_num_tr'1 prop;
  in assbl_thm sign_ref der maxidx shyps hyps prop' end;


(** get types of Free and Abs for parse' **)
(*11.1.00: not used, fix-typed +,*,-,^ instead *)

val dummyT = Type ("dummy",[]);
val dummyT = TVar (("DUMMY",0),[]);

(* assumes only 1 type for numerals 
   and different identifiers for Const, Free and Abs *)
fun get_types t = 
  let
    fun get ts  (Const(s,T)) = (s,T)::ts
      | get ts  (Free(s,T)) = if is_no s 
				then ("#",T)::ts else (s,T)::ts
      | get ts  (Var(n,T)) = ts
      | get ts  (Bound i) = ts
      | get ts  (Abs(s,T,body)) = get ((s,T)::ts)  body
      | get ts  (t1 $ t2) = (get ts  t1) @ (get ts  t2)
  in distinct (get [] t) end;
(*
val t = (term_of o the o (parse thy)) "sqrt(#9+#4*x)=sqrt x + sqrt(#-3+x)";
get_types t;
*)

(*11.1.00: not used, fix-typed +,*,-,^ instead *)
fun set_types al (Const(s,T)) = 
    (case assoc (al,s) of
       Some T' => Const(s,T')
     | None => (warning ("set_types: no type for "^s); Const(s,dummyT)))
  | set_types al (Free(s,T)) = 
  if is_no s then
    (case assoc (al,"#") of
      Some T' => Free(s,T')
    | None => (warning ("set_types: no type for numerals"); Free(s,T)))
  else (case assoc (al,s) of
	       Some T' => Free(s,T')
	     | None => (warning ("set_types: no type for "^s); Free(s,T)))
  | set_types al (Var(n,T)) = Var(n,T)
  | set_types al (Bound i) = Bound i
  | set_types al (Abs(s,T,body)) = 
		 (case assoc (al,s) of
		    Some T'  => Abs(s,T', set_types al body)
		  | None => (warning ("set_types: no type for "^s);
			     Abs(s,T, set_types al body)))
  | set_types al (t1 $ t2) = (set_types al t1) $ (set_types al t2);
(*
val t = (term_of o the o (parse thy)) "sqrt(#9+#4*x)=sqrt x + sqrt(#-3+x)";
val al = get_types t;

val t = (term_of o the o (parse thy)) "x = #0 + #-1 * #-4";
atomty thy t;                         (* 'a *)
val t' = set_types al t;
atomty thy t';                        (*real*)
cterm_of (sign_of thy) t';
val it = "x = #0 + #-1 * #-4" : cterm

val t = (term_of o the o (parse thy)) 
  "#5 * x + x ^^^ #2 = (#2 + x) ^^^ #2";
atomty thy t;
val t' = set_types al t;
atomty thy t';
cterm_of (sign_of thy) t';
uncaught exception TYPE               (*^^^ is new, NOT in al*)
*)
      

(** from Descript.ML **)

(** decompose an isa-list to an ML-list 
    i.e. [] belong to the meta-language, too **)

fun is_list ((Const("List.list.Cons",_)) $ _ $ _) = true
  | is_list _ = false;
(* val (Some ct) = parse thy "lll::real list";
> val ty = (#t o rep_cterm) ct;
> is_list ty;
val it = false : bool
> val (Some ct) = parse thy "[lll]";
> val ty = (#t o rep_cterm) ct;
> is_list ty;
val it = true : bool *)



fun mk_Free (s,T) = Free(s,T);
fun mk_free T s =  Free(s,T);


(*instantiate let; necessary for ass_up*)
fun inst_abs thy (Const sT) = Const sT
  | inst_abs thy (Free sT) = Free sT
  | inst_abs thy (Bound n) = Bound n
  | inst_abs thy (Var iT) = Var iT
  | inst_abs thy (Const ("Let",T1) $ e $ (Abs (v,T2,b))) = 
  let val (v',b') = variant_abs (v,T2,b);     (*term.ML*)
  in Const ("Let",T1) $ inst_abs thy e $ (Abs (v',T2,inst_abs thy b')) end
  | inst_abs thy (t1 $ t2) = inst_abs thy t1 $ inst_abs thy t2
  | inst_abs thy t = 
    (writeln("inst_abs: unchanged t= "
	     ^(Sign.string_of_term (sign_of thy) t));t);
(*val scr as (Script sc) = Script ((term_of o the o (parse thy))
 "Script Testeq (e_::bool) =                                        \
   \While (contains_root e_) Do                                     \
   \ (let e_ = Try (Repeat (Rewrite rroot_square_inv False e_));    \
   \      e_ = Try (Repeat (Rewrite square_equation_left True e_)) \
   \   in Try (Repeat (Rewrite radd_0 False e_)))                 ");
ML> atomt sc;
*** Const ( Script.Testeq)
*** . Free ( e_, )
*** . Const ( Script.While)
*** . . Const ( RatArith.contains'_root)
*** . . . Free ( e_, )
*** . . Const ( Let)
*** . . . Const ( Script.Try)
*** . . . . Const ( Script.Repeat)
*** . . . . . Const ( Script.Rewrite)
*** . . . . . . Free ( rroot_square_inv, )
*** . . . . . . Const ( False)
*** . . . . . . Free ( e_, )
*** . . . Abs( e_,..
*** . . . . Const ( Let)
*** . . . . . Const ( Script.Try)
*** . . . . . . Const ( Script.Repeat)
*** . . . . . . . Const ( Script.Rewrite)
*** . . . . . . . . Free ( square_equation_left, )
*** . . . . . . . . Const ( True)
*** . . . . . . . . Bound 0                            <-- !!!
*** . . . . . Abs( e_,..
*** . . . . . . Const ( Script.Try)
*** . . . . . . . Const ( Script.Repeat)
*** . . . . . . . . Const ( Script.Rewrite)
*** . . . . . . . . . Free ( radd_0, )
*** . . . . . . . . . Const ( False)
*** . . . . . . . . . Bound 0                          <-- !!!
val it = () : unit
ML> atomt (inst_abs thy sc);
*** Const ( Script.Testeq)
*** . Free ( e_, )
*** . Const ( Script.While)
*** . . Const ( RatArith.contains'_root)
*** . . . Free ( e_, )
*** . . Const ( Let)
*** . . . Const ( Script.Try)
*** . . . . Const ( Script.Repeat)
*** . . . . . Const ( Script.Rewrite)
*** . . . . . . Free ( rroot_square_inv, )
*** . . . . . . Const ( False)
*** . . . . . . Free ( e_, )
*** . . . Abs( e_,..
*** . . . . Const ( Let)
*** . . . . . Const ( Script.Try)
*** . . . . . . Const ( Script.Repeat)
*** . . . . . . . Const ( Script.Rewrite)
*** . . . . . . . . Free ( square_equation_left, )
*** . . . . . . . . Const ( True)
*** . . . . . . . . Free ( e_, )                        <-- !!!
*** . . . . . Abs( e_,..
*** . . . . . . Const ( Script.Try)
*** . . . . . . . Const ( Script.Repeat)
*** . . . . . . . . Const ( Script.Rewrite)
*** . . . . . . . . . Free ( radd_0, )
*** . . . . . . . . . Const ( False)
*** . . . . . . . . . Free ( e_, )                      <-- !!!
val it = () : unit*)



fun T_a2real (Type (s, [])) = 
    if s = "'a" orelse s = "'b" orelse s = "'c" then HOLogic.realT else Type (s, [])
  | T_a2real (Type (s, Ts)) = Type (s, map T_a2real Ts)
  | T_a2real (TFree (s, srt)) = 
    if s = "'a" orelse s = "'b" orelse s = "'c" then HOLogic.realT else TFree (s, srt)
  | T_a2real (TVar (("DUMMY",_),srt)) = HOLogic.realT;

(*FIXME .. fixes the type (+see Typefix.thy*)
fun typ_a2real (Const( s, T)) = (Const( s, T_a2real T)) 
  | typ_a2real (Free( s, T)) = (Free( s, T_a2real T))
  | typ_a2real (Var( n, T)) = (Var( n, T_a2real T))
  | typ_a2real (Bound i) = (Bound i)
  | typ_a2real (Abs(s,T,t)) = Abs(s, T, typ_a2real t)
  | typ_a2real (t1 $ t2) = (typ_a2real t1) $ (typ_a2real t2);
(*
----------------6.8.02---------------------------------------------------
 val str = "1";
 val t = read_cterm (sign_of thy) (str,(TVar(("DUMMY",0),[])));
 atomty thy (term_of t);
*** -------------
*** Const ( 1, 'a)
 val t = (app_num_tr' o term_of) t;
 atomty thy t;
*** ------------- 
*** Const ( 1, 'a)                                                              
 val t = typ_a2real t;
 atomty thy t;
*** -------------   
*** Const ( 1, real)                                                            

 val str = "2";
 val t = read_cterm (sign_of thy) (str,(TVar(("DUMMY",0),[])));
 atomty thy (term_of t);
*** -------------
*** Const ( Numeral.number_of, bin => 'a)
*** . Const ( Numeral.bin.Bit, [bin, bool] => bin)
*** . . Const ( Numeral.bin.Bit, [bin, bool] => bin)
*** . . . Const ( Numeral.bin.Pls, bin)
*** . . . Const ( True, bool)
*** . . Const ( False, bool)
 val t = (app_num_tr' o term_of) t;
 atomty thy t;
*** -------------
*** Free ( 2, 'a)
 val t = typ_a2real t;
 atomty thy t;
*** -------------
*** Free ( 2, real)
----------------6.8.02---------------------------------------------------


> val str = "R";
> val t = term_of (read_cterm(sign_of thy)(str,(TVar(("DUMMY",0),[]))));
val t = Free ("R","?DUMMY") : term
> val t' = typ_a2real t;
> cterm_of (sign_of thy) t';
val it = "R::RealDef.real" : cterm

> val str = "R=R";
> val t = term_of (read_cterm(sign_of thy)(str,(TVar(("DUMMY",0),[]))));
> atomty thy (typ_a2real t);
*** -------------
*** Const ( op =, [RealDef.real, RealDef.real] => bool)
***   Free ( R, RealDef.real)
***   Free ( R, RealDef.real)
> val t' = typ_a2real t;
> cterm_of (sign_of thy) t';
val it = "(R::RealDef.real) = R" : cterm

> val str = "fixed_values [R=R]";
> val t = term_of (read_cterm(sign_of thy)(str,(TVar(("DUMMY",0),[]))));
> val t' = typ_a2real t;
> cterm_of (sign_of thy) t';
val it = "fixed_values [(R::RealDef.real) = R]" : cterm
*)

fun parseold thy str = 
  (let 
     val sgn = sign_of thy;
     val t = ((*typ_a2real o*) app_num_tr'1 o term_of) 
       (read_cterm sgn (str,(TVar(("DUMMY",0),[]))));
   in Some (cterm_of sgn t) end)
     handle _ => None;

fun parse thy str = 
  (let 
     val sgn = sign_of thy;
     val t = (typ_a2real o app_num_tr'1 o term_of) 
       (read_cterm sgn (str,(TVar(("DUMMY",0),[]))));
   in Some (cterm_of sgn t) end) (*FIXXXXME 10.8.02: return term !!!*)
     handle _ => None;
(* 10.8.02: for this reason we still have ^^^--------------------
 val thy = SqRoot.thy;
 val str = "(1::real) ^ (2::nat)";
 val sgn = sign_of thy;
 val ct = (read_cterm sgn (str,(TVar(("DUMMY",0),[])))) handle e =>print_exn e;
(*1*)"(1::real) ^ 2"; 
 atomty thy (term_of ct);
*** -------------
*** Const ( Nat.power, [real, nat] => real)
*** . Const ( 1, real)
*** . Const ( Numeral.number_of, bin => nat)
*** . . Const ( Numeral.bin.Bit, [bin, bool] => bin)
*** . . . Const ( Numeral.bin.Bit, [bin, bool] => bin)
*** . . . . Const ( Numeral.bin.Pls, bin)
*** . . . . Const ( True, bool)
*** . . . Const ( False, bool)
 val t = ((app_num_tr' o term_of) 
	 (read_cterm sgn (str,(TVar(("DUMMY",0),[])))))handle e => print_exn e;
 val ct = (cterm_of sgn t) handle e => print_exn e;
(*2*)"(1::real) ^ (2::nat)";
 atomty thy (term_of ct);
*** -------------
*** Const ( Nat.power, [real, nat] => real)
*** . Free ( 1, real)
*** . Free ( 2, nat)                                                            (*1*) Const("2",_) (*2*) Free("2",_)


 val str = "(2::real) ^ (2::nat)";
 val t = (read_cterm sgn (str,(TVar(("DUMMY",0),[])))) handle e => print_exn e;
val t = "(2::real) ^ 2" : cterm
 val t = ((app_num_tr' o term_of) 
	 (read_cterm sgn (str,(TVar(("DUMMY",0),[])))))handle e => print_exn e;
 val ct = (cterm_of sgn t) handle e => print_exn e;
Variable "2" has two distinct types
real
nat
uncaught exception TYPE
  raised at: sign.ML:672.26-673.56
             goals.ML:1100.61


 val str = "(3::real) ^ (2::nat)";
 val t = (read_cterm sgn (str,(TVar(("DUMMY",0),[])))) handle e => print_exn e;
val t = "(3::real) ^ 2" : cterm
 val t = ((app_num_tr' o term_of) 
	 (read_cterm sgn (str,(TVar(("DUMMY",0),[])))))handle e => print_exn e;
 val ct = (cterm_of sgn t) handle e => print_exn e;
val ct = "(3::real) ^ (2::nat)" : cterm


Conclusion: The type inference allows different types 
            for one and the same  Numeral.number_of 
        BUT the type inference doesn't allow 
	    Free ( 2, real) and Free ( 2, nat) within one term
---------------       ~~~~                ~~~                  *)
(*
> val (Some ct) = parse thy "(-#5)^^^#3"; 
> atomty thy (term_of ct);
*** -------------
*** Const ( Nat.op ^, ['a, nat] => 'a)
***   Const ( uminus, 'a => 'a)
***     Free ( #5, 'a)
***   Free ( #3, nat)                
> val (Some ct) = parse thy "R=R"; 
> atomty thy (term_of ct);
*** -------------
*** Const ( op =, [real, real] => bool)
***   Free ( R, real)
***   Free ( R, real)

THIS IS THE OUTPUT FOR VERSION (3) above at typ_a2real !!!!!
*** -------------
*** Const ( op =, [RealDef.real, RealDef.real] => bool)
***   Free ( R, RealDef.real)
***   Free ( R, RealDef.real)                  *)

fun str2term str = (term_of o the o (parse (assoc_thy "Isac.thy"))) str;

(*+ makes a substitution from the output of Pattern.match +*)
fun mk_subs ((id, _):indexname, t:term) = (Free (id,type_of t), t); 
(*
 val t = (term_of o the o (parse thy)) "1/a";
 val pat = (term_of o the o (parse thy)) "?u/?v";
 val (_,sbst) = (Pattern.match (Sign.tsig_of(sign_of thy)) (pat,t))
     handle _ => ([],[]);
  ([],
   [(("v",0),Free ("a","RealDef.real")),(("u",0),Free ("1","RealDef.real"))])
  : (indexname * typ) list * (indexname * term) list
 val subst = map mk_subs sbst;
  [(Free ("v","RealDef.real"),Free ("a","RealDef.real")),
   (Free ("u","RealDef.real"),Free ("1","RealDef.real"))] : (term * term) list
*)


val atomthm = atomt o #prop o rep_thm;

(*.instantiate #prop thm with bound variables (as Free).*)
fun inst_bdv [] t = t : term
  | inst_bdv (instl: (term*term) list) t =
      let fun subst (v as Var((s,_),T)) = 
	      (case explode s of
		   "b"::"d"::"v"::_ => 
		   if_none (assoc(instl,Free(s,T))) (Free(s,T))
		 | _ => v)
            | subst (Abs(a,T,body)) = Abs(a, T, subst body)
            | subst (f$t') = subst f $ subst t'
            | subst t = if_none (assoc(instl,t)) t
      in  subst t  end;
(* num_str d1_isolate_add2;
    "~ ?a has_bdv_in ?bdv ==> (?a + ?bdv = 0) = (?bdv = -1 * ?a)"
   val subst = [(str2term "bdv", str2term "x")];
   val t = (norm o #prop o rep_thm) (num_str d1_isolate_add2);
   val t' = inst_bdv subst t;
   term2str t';
    "~ ?a has_bdv_in x ==> (?a + x = 0) = (x = -1 * ?a)"
*)
