(* use"tests/test-maximum.sml";
   use"test-maximum.sml";
   WW.N.1.3.00
   + see "test-circle.sml" for pre-, postconditions
   + see "test-coil-kernel.sml" for variants etc.
*)

"Contents----------------------------------------------";
"              Specify_Problem (match_itms_oris)       ";
"              test specify, fmz <> []                  ";
"              test specify, fmz = []                  ";
"          problemtypes + formalizations               ";
"------------------------------------------------------";



" #################################################### ";
"              Specify_Problem (match_itms_oris)       ";
" #################################################### ";
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a=Undef,b=Undef]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a=2*r*sin alpha, b=2*r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("DiffApp.thy",["maximum_of","function"],
   ("DiffApp.thy","max_by_calculus"));
val c = []:cid;

val nxt = Init_Proof' (fmz,(dI',pI',mI'));
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt e_pos' [] EmptyPtree;
(*val nxt = Add_Given "fixedValues [(r::real) = Arbfix]" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)

val nxt = mstep2mstep' pt p (Add_Find "valuesFor [(a::real) = Undef]"); 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)

if ppc<>(Problem [],  
         {Find=[Incompl "maximum",Incompl "valuesFor [a = Undef]"],
	  Given=[Correct "fixedValues [r = Arbfix]"],
	  Relate=[Incompl "relations []"], Where=[],With=[]})
then raise error "test-maximum.sml: model stepwise - different behaviour" 
else (); (*different with show_types !!!*)

(*-----appl_add should not create Error', but accept as Sup,Syn
val nxt = mstep2mstep' pt p (Add_Given "boundVariable a"); 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)
val nxt = mstep2mstep' pt p (Add_Given "boundVariable a+"); 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)---*)

val m = Specify_Problem ["maximum_of","function"];
val nxt = mstep2mstep' pt p m; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)

if ppc<>(Problem ["maximum_of","function"],  
         {Find=[Incompl "maximum",Incompl "valuesFor [a = Undef]"],
	  Given=[Correct "fixedValues [r = Arbfix]"],
	  Relate=[Incompl "relations []"], Where=[],With=[]})
then raise error "test-maximum.sml: Specify_Problem different behaviour" 
else (); (*different with show_types !!!*)

val nxt = mstep2mstep' pt p(Specify_Method ("DiffApp.thy","max_by_calculus"));
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)

if ppc<>(Method ("DiffApp.thy","max_by_calculus"),
	 {Find=[Incompl "maximum",Incompl "valuesFor [a = Undef]"],
	  Given=[Correct "fixedValues [r = Arbfix]",Missing "boundVariable v_",
		 Missing "interval itv_",Missing "errorBound err_"],
	  Relate=[Incompl "relations []"],Where=[],With=[]})
then raise error "test-maximum.sml: Specify_Method different behaviour" 
else (); (*different with show_types !!!*)








" #################################################### ";
"              test specify, fmz <> []                  ";
" #################################################### ";
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a=Undef,b=Undef]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a=2*r*sin alpha, b=2*r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("DiffApp.thy",["maximum_of","function"],
   ("DiffApp.thy","max_by_calculus"));
val c = []:cid;
val nxt = Init_Proof' (fmz,(dI',pI',mI'));

val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt e_pos' [] EmptyPtree;
(*val nxt = Add_Given "fixedValues [(r::real) = Arbfix]" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "maximum (A::bool)" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "valuesFor [(a::real) = Undef]" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "valuesFor [(b::real) = Undef]" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Relation "relations [A = a * b]" *)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*Add_Relation "relations\n [((a::real) // (#2::real)) ..."*)

if nxt<>(Add_Relation 
 "relations [(a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]")
then raise error "test specify, fmz <> []: nxt <> Add_Relation (a/2)^2.." else (); (*different with show_types !!!*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Domain "DiffApp.thy" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Problem ["maximum_of","function"]*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Method ("DiffApp.thy","max_by_calculus")*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "boundVariable a" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "interval {x. #0 <= x & x <= #2 * r}" : *)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "errorBound (eps = #0)" : mstep*)

val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Apply_Method ("DiffApp.thy","max_by_calculus") *)
if nxt<>(Apply_Method ("DiffApp.thy","max_by_calculus"))
then raise error "test specify, fmz <> []: nxt <> Apply_Method max_by_calculus" else ();


" #################################################### ";
"              test specify, fmz = []                  ";
" #################################################### ";
val fmz = [];
val (dI',pI',mI') = empty_spec;
val c = []:cid;

val nxt = Init_Proof' (fmz,(dI',pI',mI'));
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt e_pos' [] 
  EmptyPtree;
(*val nxt = Specify_Domain "e_domID" : mstep*)

val nxt = Specify_Domain "DiffApp.thy";
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Problem ["e_pblID"] : mstep*)

val nxt = Specify_Problem ["maximum_of","function"];
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "fixedValues" : mstep*)

val nxt = Add_Given "fixedValues [r=Arbfix]";
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "maximum" : mstep*)

val nxt = Add_Find "maximum A";
val nxt = mstep2mstep' pt p nxt; 


val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "valuesFor" : mstep*)

val nxt = Add_Find "valuesFor [a=Arbfix]";
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Relation "relations" --- 
  --- [b=Arbfix] KANN NICHT VERLANGT WERDEN !!!!*)

(*30.8.01 ... funktioniert nicht mehr nach Einfuehrung env ....
if nxt<>(Add_Relation "relations []")
then raise error "test specify, fmz <> []: nxt <> Add_Relation.." 
else (); (*different with show_types !!!*)
*)

val nxt = Add_Relation "relations [(A=a+b)]";
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Method ("e_domID","e_metID") : mstep*)

val nxt = Specify_Method ("DiffApp.thy","max_by_calculus");
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "boundVariable" : mstep*)

val nxt = Add_Given "boundVariable alpha";
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "interval" : mstep*)

val nxt = Add_Given "interval {x. 2 <= x & x <= 3}";
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "errorBound" : mstep*)

val nxt = Add_Given "errorBound (eps=999)";
val nxt = mstep2mstep' pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Apply_Method ("DiffApp.thy","max_by_calculus") *)

(*30.8.01 ... funktioniert nicht mehr nach Einfuehrung env ....
if nxt<>(Apply_Method ("DiffApp.thy","max_by_calculus"))
then raise error "test specify, fmz <> []: nxt <> Add_Relation.." 
else ();
*)

(* 2.4.00 nach Transfer specify -> hard_gen
val nxt = Apply_Method ("DiffApp.thy","max_by_calculus");
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt; *)
(*val nxt = Empty_Mstep : mstep*)



(* use_thy_only"Isa99/knowl-base/Script";
   *)



" #################################################### ";
"          problemtypes + formalizations               ";
" #################################################### ";
" -------------- [maximum_of,function] --------------- ";
val pbt = 
    ["fixedValues fix_","maximum m_","valuesFor vs_","relations rs_"];
map (the o (parseold thy)) pbt;
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a=Undef,b=Undef]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a=2*r*sin alpha, b=2*r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
map (the o (parseold thy)) fmz;
" -------------- [make,function] -------------- ";
val pbt = 
    ["functionOf f_","boundVariable v_","equalities eqs_",
     "functionTerm f_0_"];
map (the o (parseold thy)) pbt;
val fmz12 =
    ["functionOf A","boundVariable a","boundVariable b",
     "equalities [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    ["functionOf A","boundVariable a","boundVariable b",
     "equalities [A=a*b, a=2*R*sin alpha, b=2*R*cos alpha]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [univar,equation] --------- ";
val pbt = 
    ["equality e_","solveFor v_","solutions v_i_"];
map (the o (parseold thy)) pbt;
val fmz =
    ["equality ((a/2)^^^2 + (b/2)^^^2 = r^^^2)",
     "solveFor b","solutions b_i"];
map (the o (parseold thy)) fmz;
" ---- [on_interval,maximum_of,function] ---- ";
val pbt = 
    ["functionTerm t_","boundVariable v_","interval itv_",
     "errorBound err_","maxArgument v_0_"];
map (the o (parseold thy)) pbt;
val fmz12 =
    [(*28.11.00: "functionTerm (A_0 = a*sqrt(#4*r^^^#2 - a^^^#2))",*)
     "functionTerm (a*sqrt(4*r^^^2 - a^^^2))",
     (*28.11.00: "functionTerm (A_0 = b*sqrt(#4*r^^^#2 - b^^^#2))",*)
     "functionTerm (b*sqrt(4*r^^^2 - b^^^2))",
     "boundVariable a","boundVariable b",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "errorBound (eps=0)","maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    [(*28.11.00: "functionTerm (A_0 = (#2*r*sin alpha)*(#2*r*cos alpha))",*)
     "functionTerm ((2*r*sin alpha)*(2*r*cos alpha))",
     "boundVariable alpha",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=0)","maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [derivative_of,function] --------- ";
val pbt = 
    ["functionTerm f_","boundVariable v_","derivative f_'_"];
map (the o (parseold thy)) pbt;
val fmz =
    [(*28.11.00: "functionTerm (A_0=a*#2*sqrt r^^^#2 - (a//#2)^^^#2)",*)
     "functionTerm (a*2*sqrt r^^^2 - (a/2)^^^2)",
     "boundVariable a",
     (*28.11.00: "derivative (A_0'=Undef)"*)"derivative (Undef)"];
map (the o (parseold thy)) fmz;
" --------- [find_values,tool] --------- ";
val pbt = 
    ["maxArgument ma_","functionTerm f_","boundVariable v_",
     "valuesFor vls_","additionalRels rs_"];
map (the o (parseold thy)) pbt;
val fmz1 =
    ["maxArgument (a_0=(srqt 2)*r)",
     (*28.11.00: "functionTerm (A_0=a*#2*sqrt r^^^#2 - (a//#2)^^^#2)",*)
     "functionTerm (a*2*sqrt r^^^2 - (a/2)^^^2)",
     "boundVariable a",
     "valuesFor [a=Undef,b=Undef]","maximum A",
     "additionalRels [(a/2)^^^2 + (b/2)^^^2 = r^^^2]"];
map (the o (parseold thy)) fmz1;

"---------------------------------------------------------------------";
"---------------------------------------------------------------------";
"---------------------------------------------------------------------";

(* Teil von max-on-surface.sml,
   der nach Init_Proof -> prep_ori wieder l"auft
   (f"ur tests mit neuer pos')
   use"test-max-surf1.sml";

   Compiler.Control.Print.printDepth:=10; (*4 is default*)
   Compiler.Control.Print.printDepth:=4; (*4 is default*)
   *)

(* --vvv-- ausgeliehen von test-root-equ/sml *)
val loc = e_istate;
val (dI',pI',mI') =
  ("Script.thy",["sqroot-test","univariate","equation"],
   ("Script.thy","squ-equ-test2"));
val fmz = ["equality (sqrt(9+4*x)=sqrt x + sqrt(5+x))",
	   "solveFor x","errorBound (eps=0)",
	   "solutions L"];
(*
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val ((p,p_),_,_,_,_,(_,pt,_)) = do_ (mI,m) e_pos'[1](e_scr,EmptyPtree,[]);
 --^^^-- ausgeliehen von test-root-equ/sml *)
val (pt,_) = 
  cappend_problem EmptyPtree [] loc ([],(dI',pI',mI'));
val pos = (lev_on o lev_dn) [];
(* val pos = ([1]) *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). is-max ..." 
    Empty_Mstep Transitive;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([1,1])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-max ..." 
    Empty_Mstep "[1,1]:{(a,b). is-extremum ..." Complete;
val pos = lev_on pos;
(*val pos = ([1,2])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-extremum ..." 
    Empty_Mstep "[1,2]:{(a,b). f_x(a,b) ..." Complete;
val pos = lev_up pos;
(*val pos = ([1])*)
val (pt,_) = append_result pt pos e_istate "[1#]:{(a,b). f_x(a,b) ..."
    Complete;

val pos = lev_on pos;
(*val pos = ([2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x(a,b) ..." 
    Empty_Mstep "[2]:{(a,b). f_x & f_xx &..." Complete;
val pos = lev_on pos;
(*al pos = [3] : pos*)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x & f_xx &..." 
    Empty_Mstep Transitive;
val pos = (lev_on o lev_dn) pos;
(*pos = ([3,1]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx & ..." 
    Empty_Mstep "[3,1]:{(a,b). f_x & f_xx } cup ..." Complete;
val pos = lev_on pos;
(*pos = ([3,2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx } cup.."
    Empty_Mstep "[3,2]:{(a,b). f_x ..} cup ..." Complete;

val pos = lev_up pos;
(*pos = ([3]) *)
val (pt,_) = append_result pt pos e_istate "[3#]:{(a,b). f_x ..} cup.."
    Complete;
val pos = lev_on pos;
(*val pos = [4] : pos *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x ..} cup ..." 
    Empty_Mstep Intersect;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1]) *)
val (pt,_) = cappend_parent pt pos loc "set_1 = ..." 
    Empty_Mstep Sequence;


val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc"f_x = d/dx x^3 ..."
    Empty_Mstep Transitive;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1]) *)
val (pt,_) = cappend_parent pt pos loc "d/dx x^3 ..." 
    Empty_Mstep Transitive;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1,1]) *)
val (pt,_) = cappend_atomic pt pos loc "d/dx x^3 ..." 
    Empty_Mstep "[4,1,1,1,1]:3x^2 + d/dx ..." Complete;
val pos = lev_on pos;
(*val pos = ([4,1,1,1,2]) *)
val (pt,_) = cappend_atomic pt pos loc "3x^2 + d/dx ..." 
    Empty_Mstep "[4,1,1,1,2]:3x^2 + 0 + d/dx ..." Complete;
val pos = lev_on pos;
(*pos = ([4,1,1,1,3]) *)
val (pt,_) = cappend_atomic pt pos loc "3x^2 + 0 + d/dx ..." 
    Empty_Mstep "[4,1,1,1,3]:3x^2 + 0 -3 ..." Complete;
"--- 1 ---";
val pos = lev_up pos;
(*pos = ([4,1,1,1]) *)
val (pt,_) = append_result pt pos e_istate "[4,1,1,1#]:3x^2 -3."Complete;
"--- 2 ---";
val pos = lev_up pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = append_result pt pos e_istate "[4,1,1#]:found 3x^2 -3 ..." 
    Complete;
"--- 3 ---";
val pos = lev_on pos;
(*val pos = ([4,1,2]+) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc "f_y = d/dy x^3 ..."
    Empty_Mstep Transitive;
"--- 4 ---";
writeln (pr_ptree pr_short pt);

(*
.    ----- pblobj -----
1.   {(a,b). is-max ...
1.1.   {(a,b). is-max ...
1.2.   {(a,b). is-extremum ...
2.   {(a,b). f_x(a,b) ...
3.   {(a,b). f_x & f_xx &...
3.1.   {(a,b). f_x & f_xx & ...
3.2.   {(a,b). f_x & f_xx } cup..
4.   {(a,b). f_x ..} cup ...
4.1.   set_1 = ...
4.1.1.   f_x = d/dx x^3 ...
4.1.1.1.   d/dx x^3 ...
4.1.1.1.1.   d/dx x^3 ...
4.1.1.1.2.   3x^2 + d/dx ...
4.1.1.1.3.   3x^2 + 0 + d/dx ...
4.1.2.   f_y = d/dy x^3 ...
  
 use"test-max-surf1.sml";
   *)
